/*******************************************************************************
Copyright(c) 2000 - 2002 Analog Devices. All Rights Reserved.
Developed by Joint Development Software Application Team, IPDC, Bangalore, India
for Blackfin DSPs  ( Micro Signal Architecture 1.0 specification).

By using this module you agree to the terms of the Analog Devices License
Agreement for DSP Software. 
********************************************************************************
File Name   : test_imdct36.c
Description : This is the test file for the testing of functionality of
              of imdct36().
*******************************************************************************/
#include<stdio.h>
#include"imdct36_data.h"

int error_flag = 0;

void (*f1)();
int cycle_count[10];
void _imdct36();

main()
{
    int i,j, error;

// Test Case 1: Input is a constant signal   

    f1 = _imdct36;
    
    for(i=0;i<18;i++)
        in[i] = const_data1;

    cycle_count[0] = Compute_Cycle_Count(in, out, twid_coef);
                            //This function inturn calls imdct36()

    for(i = 0; i < 36; i++)
    {
        error = out[i] - exp_dc[i];
        if(error < 0)
            error = -error;
        if(error > MAX_PERMISSIBLE_ERROR)
        {
            error_flag = error_flag | 1;
        }
    }

//Test Case 2: Input is an impulse  

    in[0] = const_data1;

    for(i=1;i<18;i++)
        in[i] = const_data2;

    cycle_count[1] = Compute_Cycle_Count(in, out, twid_coef);

    for(i = 0; i < 36; i++)
    {
        error = out[i] - exp_imp[i];
        if(error < 0)
            error = -error;
        if(error > MAX_PERMISSIBLE_ERROR)
        {
            error_flag = error_flag | 2;
        }
    }

//Test Case 3: Input is random signal

  cycle_count[2] = Compute_Cycle_Count(in_rand, out, twid_coef);

    for(i=0;i<36;i++)
    {
        error = out[i] - exp_rand[i];
        if(error < 0)
            error = -error;

        if(error > MAX_PERMISSIBLE_ERROR)
        {
            error_flag = error_flag | 4;
        }
    }
    #ifdef PRINTF_SUPPORT
        if(error_flag & 1)
            printf("Test Case 1 failed\n");
        else
            printf("Test Case 1 passed\n");
        if(error_flag & 2)
            printf("Test Case 2 failed\n");
        else
            printf("Test Case 2 passed\n");
        if(error_flag & 4)
            printf("Test Case 3 failed\n");
        else
            printf("Test Case 3 passed\n");
    #endif
    
    printf("cycle_count[0]=%d,cycle_count[1]=%d,cycle_count[2]=%d\n",cycle_count[0],cycle_count[1],cycle_count[2]);    

}

