	.module P1_AVR_Init.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_Init.c
	.dbfunc e InitUART _InitUART fV
;              x -> R10
;       baudrate -> <dead>
	.even
_InitUART::
	st -y,r17
	st -y,r16
	st -y,R10
	.dbline -1
	.dbline 79
; /**************************************************************
; 
;    Program Title:  P1 AVR Boot/Monitor
;    
;    Program Name:  P1_AVR_Init.c		  Version: 0.91
;    
;    Author:  SS	  					  Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    This file contains routines that implement the basic initialization 
;    routines for the P1 AVR Boot Monitor.
;    
;    Copyright 2004-2007, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright (C) 2005-2007 by SOC Robotics, Inc. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com
;  */
; 
; /*
;  * $Log: P1_Monitor.c,v $
;  * Revision 0.91  2007/07/23 16:40:20  SS
;  *    Port to ATmega644
;  * Revision 0.55  2005/07/17 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; //#include <eeprom.h>
; //#include <stdio.h>
; #include "P1_AVR_Uart.h"
; #include "P1_AVR_Defines.h"
; #include "P1_AVR_Extern.h"
; 
; //****************************************************************
; //****************************************************************
; // Initialization code
; //****************************************************************
; //****************************************************************
; 
; // Initialize UART
; void InitUART(unsigned char baudrate)
; {
	.dbline 83
; 	unsigned char x;
; 	
; 	// Set the baud rate
; 	UBRR0H = 0x00;
	clr R2
	sts 197,R2
	.dbline 85
; //	UBRR0L = baudrate; 
; 	UBRR0L = 12; 
	ldi R24,12
	sts 196,R24
	.dbline 88
; 	
; 	// Enable UART receiver and transmitter
; 	UCSR0B = BIT(RXCIE0)|BIT(UDRIE0)|BIT(RXEN0)|BIT(TXEN0); 
	ldi R24,184
	sts 193,R24
	.dbline 92
;     //  8 data bits, 2 stop bits
; //	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
;     //  8 data bits, 1 stop bit
; 	UCSR0C = (3<<UCSZ00);
	ldi R24,6
	sts 194,R24
	.dbline 94
; 
; 	x = 0; // flush receive buffer
	clr R10
	.dbline 95
; 	rxcnt = x; // rx buffer empty
	sts _rxcnt,R10
	.dbline 96
; 	xoffsent = NO;
	sts _xoffsent,R2
	.dbline 97
; 	xonsent = NO;
	sts _xonsent,R2
	.dbline 98
; 	checkflag = NO;
	sts _checkflag,R2
	.dbline 99
; 	enablexonoff = NO; // turn serial driver xon/xoff flow control on
	sts _enablexonoff,R2
	.dbline 100
; 	echoinchars = NO;   // echo all received characters
	sts _echoinchars,R2
	.dbline 101
; 	UART_RxTail = x;
	sts _UART_RxTail,R10
	.dbline 102
; 	UART_RxHead = x;
	sts _UART_RxHead,R10
	.dbline 103
; 	UART_TxTail = x;
	sts _UART_TxTail,R10
	.dbline 104
; 	UART_TxHead = x;
	sts _UART_TxHead,R10
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R10,y+
	adiw R28,2
	ret
	.dbsym r x 10 c
	.dbsym l baudrate 1 c
	.dbend
	.dbfunc e InitADC _InitADC fV
	.even
_InitADC::
	.dbline -1
	.dbline 110
; }
; 
; //  Setup the Analog to Digital converter
; //  TBD - convert to background interrupt process
; void InitADC(void)
; {
	.dbline 111
; 	DDRA = 0x00;  // All inputs
	clr R2
	out 0x1,R2
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e InitRealTimeClock _InitRealTimeClock fV
	.even
_InitRealTimeClock::
	.dbline -1
	.dbline 120
; 		   		  // Setup Analog TDB
; }
; 
; //  Start the real time clock 
; //  Clocked by external 32.768KHz watch crystal
; //  Set prescalar to 0, set to interrupt using compare match 
; //  set to 128 (4msec interrupt rate).  
; void InitRealTimeClock(void)
; {  
	.dbline 122
;     // Software counters - approximately 4msec resolution
; 	rtccountdown1 = 0;  
	clr R2
	clr R3
	sts _rtccountdown1+1,R3
	sts _rtccountdown1,R2
	.dbline 123
; 	rtccountdown2 = 0;
	sts _rtccountdown2+1,R3
	sts _rtccountdown2,R2
	.dbline 124
; 	rtccountdown3 = 0;
	sts _rtccountdown3+1,R3
	sts _rtccountdown3,R2
	.dbline 125
; 	rtccountdown4 = 0;
	sts _rtccountdown4+1,R3
	sts _rtccountdown4,R2
	.dbline 126
; 	rtcclockcnt = 0;
	sts _rtcclockcnt,R2
	.dbline 127
; 	seconds = 0;
	sts _seconds,R2
	.dbline 128
; 	minutes = 0;
	sts _minutes,R2
	.dbline 129
; 	hours = 0;
	sts _hours,R2
	.dbline 130
; 	days = 0;
	sts _days,R2
	.dbline 132
; 	
;  	TCNT2 = 0;
	sts 178,R2
	.dbline 134
;  	// Select external real time clock oscillator
; 	ASSR = (1<<AS2);
	ldi R24,32
	sts 182,R24
	.dbline 136
; 	// Set match interrupt to 4msec
; 	OCR2A = 128;
	ldi R24,128
	sts 179,R24
	.dbline 138
; 	// Reload counter on match interrupt - pre-scalar set to 0
; 	TCCR2A = (1<<WGM21);   
	ldi R24,2
	sts 176,R24
	.dbline 139
; 	TCCR2B = (1<<CS20);   
	ldi R24,1
	sts 177,R24
	.dbline 141
;     // setup interrupts for real time clock
;     TIMSK2 |= (1<<OCIE2A);
	lds R24,112
	ori R24,2
	sts 112,R24
	.dbline -2
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_Timer0 _Init_Timer0 fV
	.even
_Init_Timer0::
	.dbline -1
	.dbline 147
; }
; 
; // Timer1 is called every 1msec - used to maintain four count down 
; // software timers to control precise time delays in various routines
; void Init_Timer0(void)
; {
	.dbline 148
;  	 mseccountdown1 = 0;
	clr R2
	clr R3
	sts _mseccountdown1+1,R3
	sts _mseccountdown1,R2
	.dbline 149
; 	 mseccountdown2 = 0;
	sts _mseccountdown2+1,R3
	sts _mseccountdown2,R2
	.dbline 150
; 	 mseccountdown3 = 0;
	sts _mseccountdown3+1,R3
	sts _mseccountdown3,R2
	.dbline 151
; 	 flashcountdown = 0;
	sts _flashcountdown+1,R3
	sts _flashcountdown,R2
	.dbline 153
; 	 
; 	 TCNT0 = 0;
	out 0x26,R2
	.dbline 155
; 	 // Set mode 2 - reset counter on compare match, clk/8
; 	 TCCR0A = (1<<WGM01);
	ldi R24,2
	out 0x24,R24
	.dbline 156
; 	 TCCR0B = (1<<CS01)|(1<<CS00);
	ldi R24,3
	out 0x25,R24
	.dbline 158
; 	 // Reset count after 1 msec
; 	 OCR0A = 125;
	ldi R24,125
	out 0x27,R24
	.dbline 160
; 	 // Enable compare match interrupt vector
; 	 TIMSK0 |= (1<<OCIE0A);
	lds R24,110
	ori R24,2
	sts 110,R24
	.dbline -2
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e InitWatchdog _InitWatchdog fV
	.even
_InitWatchdog::
	.dbline -1
	.dbline 165
; }
; 
; // Setup watch dog timer - TBD
; void InitWatchdog(void)
; {
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_SPI_Master _Init_SPI_Master fV
;         inchar -> <dead>
	.even
_Init_SPI_Master::
	.dbline -1
	.dbline 169
; }
; 
; void Init_SPI_Master(void)
; {
	.dbline 175
;     unsigned char inchar;
; 	
;     // Set MOSI and SCK output, all others input
; 	//  PB5 - MOSI, PB7 - SCK, PB4 - SS\
; //	DDRB |= (1<<PB5)|(1<<PB7)|(1<<PB4);
; 	DDRB |= (1<<PB5)|(1<<PB7);
	in R24,0x4
	ori R24,160
	out 0x4,R24
	.dbline 176
; 	PORTB |= 0xA0;  // Set bits MOSI & SCK
	in R24,0x5
	ori R24,160
	out 0x5,R24
	.dbline 179
; 
; 	//  Make Flash Chip select PC4 output and set high
; 	DDRC |= 0x10; 
	sbi 0x7,4
	.dbline 180
; 	PORTC |= 0x10;  
	sbi 0x8,4
	.dbline 184
; 	
; 	// Enable SPI, Master, set clock rate fck/16 - 500KHz
; 	//    Select SPI Mode 3 - CPOL=1, CPHA=1
; 	SPCR = (1<<SPE)|(1<<MSTR)|(1<<CPOL)|(1<<CPHA)|(1<<SPR0);
	ldi R24,93
	out 0x2c,R24
	.dbline 191
; 	
; 	// Clear SPI Receive Flag if set
; 	//if(SPSR&(1<<SPIF)) inchar = SPDR;
; 	
; 	// Enable double speed SCK clock - 4MHz
; 	//  Set SPR1/0 to 0 and SPI2x to 1
; 	SPCR &= 0xFC;
	in R24,0x2c
	andi R24,252
	out 0x2c,R24
	.dbline 192
; 	SPSR |= (1<<SPI2X);
	in R24,0x2d
	ori R24,1
	out 0x2d,R24
	.dbline -2
L6:
	.dbline 0 ; func end
	ret
	.dbsym l inchar 1 c
	.dbend
	.dbfunc e ChangeBaudRate _ChangeBaudRate fV
;       baudrate -> R16
	.even
_ChangeBaudRate::
	.dbline -1
	.dbline 196
; }
; 
; void ChangeBaudRate(unsigned char baudrate)
; {
	.dbline 198
; 	// Set the baud rate
; 	UBRR0H = 0x00;
	clr R2
	sts 197,R2
	.dbline 199
; 	UBRR0L = baudrate; 
	sts 196,R16
	.dbline -2
L7:
	.dbline 0 ; func end
	ret
	.dbsym r baudrate 16 c
	.dbend
	.dbfunc e CheckEEPROMWritten _CheckEEPROMWritten fc
;    P1signature -> y+0
;              i -> R20
	.even
_CheckEEPROMWritten::
	st -y,R20
	sbiw R28,19
	.dbline -1
	.dbline 203
; }
; 
; unsigned char CheckEEPROMWritten()
; {
	.dbline 207
;  	char P1signature[19];
; 	unsigned char i;
; 	
; 	P1signature[18] = 0;
	clr R2
	std y+18,R2
	.dbline 208
; 	for(i=0; i<18; i++)  P1signature[i] = EEPROMread(i);
	clr R20
	xjmp L13
L10:
	.dbline 208
	mov R16,R20
	clr R17
	xcall _EEPROMread
	movw R24,R28
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
L11:
	.dbline 208
	inc R20
L13:
	.dbline 208
	cpi R20,18
	brlo L10
X0:
	.dbline 209
; 	if(!strcmp(P1signature,"SOC Robotics V0.87")) return YES;
	ldi R18,<L16
	ldi R19,>L16
	movw R16,R28
	xcall _strcmp
	cpi R16,0
	cpc R16,R17
	brne L14
X1:
	.dbline 209
	ldi R16,1
	xjmp L8
L14:
	.dbline 210
; 	else return NO;
	clr R16
	.dbline -2
L8:
	.dbline 0 ; func end
	adiw R28,19
	ld R20,y+
	ret
	.dbsym l P1signature 0 A[19:19]c
	.dbsym r i 20 c
	.dbend
	.dbfunc e Init_EEPROM _Init_EEPROM fV
	.even
_Init_EEPROM::
	.dbline -1
	.dbline 214
; }
; 
; void Init_EEPROM()
; {
	.dbline 215
; 	WriteEEPROM(0,"SOC Robotics V0.87");
	ldi R18,<L16
	ldi R19,>L16
	clr R16
	clr R17
	xcall _WriteEEPROM
	.dbline 216
; 	EEPROMWrite(19,OSCCAL);   // Write calibration byte
	lds R18,102
	clr R19
	ldi R16,19
	ldi R17,0
	xcall _EEPROMWrite
	.dbline 217
; 	EEPROMWrite(20,'3');      // Set baud rate to 38400
	ldi R18,51
	ldi R19,0
	ldi R16,20
	ldi R17,0
	xcall _EEPROMWrite
	.dbline -2
L17:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LoadEEPROMSettings _LoadEEPROMSettings fV
	.even
_LoadEEPROMSettings::
	st -y,R10
	.dbline -1
	.dbline 221
; }
; 
; void  LoadEEPROMSettings(void)
; {
	.dbline 224
; 	//  See if EEPROM setup values exist - if not write them 
; 	//  otherwise load settings
; 	if(CheckEEPROMWritten()==NO)  {
	xcall _CheckEEPROMWritten
	tst R16
	brne L19
X2:
	.dbline 224
	.dbline 227
; 	    //puts("no eeprom match\n\r");
; 	    // Calibrate the internal oscillator
; 	    CalibrateOsc(QUIET);
	ldi R16,1
	xcall _CalibrateOsc
	.dbline 230
; 		
; 		// Write default EEPROM P1 AVR information
; 		Init_EEPROM();
	xcall _Init_EEPROM
	.dbline 231
; 		}
	xjmp L20
L19:
	.dbline 232
; 	else {
	.dbline 233
; 	    OSCCAL = EEPROMread(19);
	ldi R16,19
	ldi R17,0
	xcall _EEPROMread
	sts 102,R16
	.dbline 234
; 		SetNewBaudRate(EEPROMread(20));
	ldi R16,20
	ldi R17,0
	xcall _EEPROMread
	mov R10,R16
	xcall _SetNewBaudRate
	.dbline 236
; 		//puts("use eeprom settings\n\r");
; 		}
L20:
	.dbline -2
L18:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbend
	.dbfunc e Init_AVR _Init_AVR fV
	.even
_Init_AVR::
	.dbline -1
	.dbline 243
; }
; 
; //************************************************************
; //  Initialize the AVR - set port conditions for Blackfin
; //************************************************************
; void Init_AVR(void)
; {
	.dbline 245
;     // Setup serial flash constants and variables
; 	programmode = LFLASH;  // programming serial flash - default
	ldi R24,102
	sts _programmode,R24
	.dbline 246
; 	flashprogrammingactive = NO;
	clr R2
	sts _flashprogrammingactive,R2
	.dbline 247
; 	flashpageloaded = NO;
	sts _flashpageloaded,R2
	.dbline 248
; 	flashpageboundarytraversed = NO;
	sts _flashpageboundarytraversed,R2
	.dbline 249
; 	flashdatainbuffer = NO;
	sts _flashdatainbuffer,R2
	.dbline 250
; 	intelextendedaddress = 0;
	clr R3
	sts _intelextendedaddress+1,R3
	sts _intelextendedaddress,R2
	.dbline 251
; 	lastaddress = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	sts _lastaddress+1,R25
	sts _lastaddress,R24
	sts _lastaddress+2+1,R27
	sts _lastaddress+2,R26
	.dbline 252
; 	showascii = NO;
	sts _showascii,R2
	.dbline 253
; 	oldpage = 0;
	sts _oldpage+1,R3
	sts _oldpage,R2
	.dbline 254
; 	oldbyteoffset = 0;
	sts _oldbyteoffset+1,R3
	sts _oldbyteoffset,R2
	.dbline 255
; 	xofftransmitted = NO;
	sts _xofftransmitted,R2
	.dbline 258
; 	
;     // Setup Port A
; 	InitADC();
	xcall _InitADC
	.dbline 264
; 	
; 	// Setup Port B - SPI + General digital IO
; 	
; 	//   Setup SPI - SPI default inactive in this release
; //    Init_SPI_Master();
; 	Release_SPI();
	xcall _Release_SPI
	.dbline 269
; 	
; 	// Setup Port C - PF2,0 control + RS-485 + 2-Wire
; 	//   PC4 - First Serial Flash CS
; 	//   PC5 - connected directly to PF0 - 1K to PB4
; 	DDRC = 0x08;   // PC3 - RS-485 output and PC4 - PF2 Flash CS input
	ldi R24,8
	out 0x7,R24
	.dbline 270
; 	PORTC = 0x18;  // Set PC4,3 high - deselect Flash CS
	ldi R24,24
	out 0x8,R24
	.dbline 273
; 	
; 	//    Turn on real time clock on PC7,6 Timer/Counter 2
; 	InitRealTimeClock();
	xcall _InitRealTimeClock
	.dbline 278
; 	
; 	// Setup Timer 0 to interrupt a 1msec rate - this interrupt
; 	// controls four software delay timers used by various 
; 	// routines
; 	Init_Timer0();
	xcall _Init_Timer0
	.dbline 286
; 	
; 	//    Setup 2-Wire Interface
; 	//Init_TWI_Master();   // SCL freq = sclk/(16+2*TWBR)*4*TWPS
; 	
; 	// Setup Port D  - Blackfin control lines
; 	//  PD2 - Selects second serial flash - also connected to PF3
; 	//        Line pulled high  - should set PF3 as input
; 	DDRD = 0xFF;	// output
	ldi R24,255
	out 0xa,R24
	.dbline 287
; 	PORTD = 0x00;	// all off
	clr R2
	out 0xb,R2
	.dbline 293
; 	
; 	// Set initial Blackfin conditions - Boot mode 
; 	// If BMODE=00 then the Blackfin doesn't control SPI - this may work
; 	// BMODE1 is PD5
; 	// BMODE0 is PD4
; 	BlackfinBootMode(BOOTMODE3);
	ldi R16,51
	xcall _BlackfinBootMode
	.dbline 297
; 	// RESETB is PD3 - Release ResetB
; 	
; 	// Turn LEDs off
; 	RED_LED(OFF);
	ldi R16,1
	xcall _RED_LED
	.dbline 298
; 	GREEN_LED(OFF);
	ldi R16,1
	xcall _GREEN_LED
	.dbline 301
; 	
; 	// Watchdog timer setup
; 	InitWatchdog();
	xcall _InitWatchdog
	.dbline 307
; 	
; 	// Initialize UART - Interrupt
; 	// Set the baudrate to 9,600 bps using an 8MHz clock
; //	InitUART(BAUDRATE9600); 
; //	InitUART(BAUDRATE19200); 
; 	InitUART(BAUDRATE38400); 
	ldi R16,12
	xcall _InitUART
	.dbline 310
; //	InitUART(BAUDRATE57200);  
; 					
; 	_SEI(); // Enable interrupts => enable UART interrupts
	sei
	.dbline -2
L21:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_Init.c
L16:
	.blkb 19
	.area idata
	.byte 'S,'O,'C,32,'R,'o,'b,'o,'t,'i,'c,'s,32,'V,48,46
	.byte 56,55,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_Init.c
; 
; }
