	.module P1_AVR_SPI.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI.c
	.dbfunc e Release_SPI _Release_SPI fV
	.even
_Release_SPI::
	.dbline -1
	.dbline 72
; /**************************************************************
; 
;    Program Title:  P1 AVR Boot/Monitor
;    
;    Program Name:  P1_AVR_SPI.c	Version: 0.88
;    
;    Author:  SS	  					  Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V6.29
;    
;    This file contains routines that implement an SPI communications link
;    between the Blackfin and AVR processors. 
;    
;    Copyright 2004-2007, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright (C) 2005-2007 by SOC Robotics, Inc. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com
;  */
; 
; /*
;  * $Log: P1_Monitor.c,v $
;  * Revision 0.88  2007/07/23 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.55  2005/07/17 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "P1_AVR_Uart.h"
; #include "P1_AVR_Defines.h"
; #include "P1_AVR_Extern.h"
; 
; //  Free SPI pins
; void Release_SPI(void)
; {
	.dbline 74
; 	// Disable SPI, Master 
; 	SPCR = 0x00;
	clr R2
	out 0x2c,R2
	.dbline 77
; 
;  	// Set MOSI,MISO,SS and SCK input, leave others alone
; 	DDRB &= 0x0F;
	in R24,0x4
	andi R24,15
	out 0x4,R24
	.dbline 81
; //	DDRB = 0x00;
; 	
; 	// Change Atmel Flash CS to input (PF2 - Port C bit 4)
; 	DDRC &= 0xEF;
	in R24,0x7
	andi R24,239
	out 0x7,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SPI_MasterTransmit _SPI_MasterTransmit fV
;            cnt -> y+0
;          cData -> R16
	.even
_SPI_MasterTransmit::
	sbiw R28,8
	.dbline -1
	.dbline 86
; }
; 
; // TODO - break if no reception
; void SPI_MasterTransmit(unsigned char cData)
; {
	.dbline 89
;     long cnt;
; 	
; 	cnt = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	.dbline 91
;     // Start transmisstion
; 	SPDR = cData;
	out 0x2e,R16
	xjmp L4
L3:
	.dbline 94
; 	// Wait for transmission to complete
; //	puts("wait for spi tx to complete\n\r");
; 	while(!(SPSR & 0x80)) {
	.dbline 95
; 	  if(cnt++>10000) break;
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldi R24,1
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	add R2,R24
	adc R3,R25
	adc R4,R26
	adc R5,R27
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R24,16
	ldi R25,39
	ldi R26,0
	ldi R27,0
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	cp R24,R2
	cpc R25,R3
	cpc R26,R4
	cpc R27,R5
	brge L6
X0:
	.dbline 95
	xjmp L5
L6:
	.dbline 96
; 	  }
L4:
	.dbline 94
	in R2,0x2d
	sbrs R2,7
	rjmp L3
X1:
L5:
	.dbline -2
L2:
	.dbline 0 ; func end
	adiw R28,8
	ret
	.dbsym l cnt 0 L
	.dbsym r cData 16 c
	.dbend
	.dbfunc e SPI_MasterReceive _SPI_MasterReceive fc
;            cnt -> y+0
	.even
_SPI_MasterReceive::
	sbiw R28,8
	.dbline -1
	.dbline 101
; }
; 
; // TODO - break if no reception
; unsigned char SPI_MasterReceive(void)
; {
	.dbline 104
;     long cnt;
; 	
; 	cnt = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	.dbline 106
;     // Wait for reception to complete
; 	SPDR = 0x00;
	clr R2
	out 0x2e,R2
	xjmp L10
L9:
	.dbline 107
; 	while(!(SPSR & 0x80)) {
	.dbline 108
; 	  if(cnt++>10000) break;
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldi R24,1
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	add R2,R24
	adc R3,R25
	adc R4,R26
	adc R5,R27
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R24,16
	ldi R25,39
	ldi R26,0
	ldi R27,0
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	cp R24,R2
	cpc R25,R3
	cpc R26,R4
	cpc R27,R5
	brge L12
X2:
	.dbline 108
	xjmp L11
L12:
	.dbline 109
; 	  }
L10:
	.dbline 107
	in R2,0x2d
	sbrs R2,7
	rjmp L9
X3:
L11:
	.dbline 111
; 	
; 	return SPDR;
	in R16,0x2e
	.dbline -2
L8:
	.dbline 0 ; func end
	adiw R28,8
	ret
	.dbsym l cnt 0 L
	.dbend
; }
