	.module P1_AVR_SPI_Flash.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
	.dbfunc e FlashChipSelect _FlashChipSelect fV
;           mode -> R18
;         chipno -> R16
	.even
_FlashChipSelect::
	.dbline -1
	.dbline 88
; /**************************************************************
; 
;    Program Title:  P1 AVR Boot/Monitor
;    
;    Program Name:  P1_AVR_SPI_Flash.c	Version: 0.88
;    
;    Author:  SS	  					  Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    The AVR SPI lines are connected to two serial flash devices U2 
;    and U5.  The Blackfin boots from U2 when set to boot mode 3 as 
;    an SPI Master.  If the AVR needs to communicate with the Serial 
;    Flash devices the Blackfin must relinquish control of the SPI 
;    lines.  This version of the code does not support cooperative sharing
;    of the SPI lines so the Blackfin is reset and forced to boot under 
;    mode 0 freeing the SPI lines.
;    
;    Serial flash devices compatible with the P1 are the AT45DB041
;    (512kx8), AT45DB081 (1Mx8), AT45DB161 (2Mx8), AT45DB321 (4Mx8)
;    or AT45DB642 (8Mx8).
;    
;    The Serial Flash chips are page oriented with 2 SRAM buffers of 264,
;    528 or 1024 bytes each.  The AVR programs the serial flash devices by 
;    loading files via the serial line (in IntelHex32 format) into the RAM 
;    buffers before transfer to the appropriate page.  Page erase/programming 
;    requires about 30msec per page. The routines in this file perform these 
;    functions.  The host terminal program must support XON/XOFF flow control.
;    
;    Copyright 2004-2007, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright (C) 2007 by SOC Robotics, Inc. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com
;  */
; 
; /*
;  * $Log: P1_Monitor.c,v $
;  * Revision 0.88  2007/07/23 16:40:20  SS
;  *    2-wire interface, 8MHz clock, Serial Flash Writer, XON/XOFF
;  * Revision 0.85  2006/01/08 16:40:20  SS
;  *    2-wire interface, 8MHz clock, Serial Flash Writer, XON/XOFF
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "P1_AVR_Uart.h"
; #include "P1_AVR_Defines.h"
; #include "P1_AVR_Extern.h"
; 
; // Set Serial Flash chip select state
; void FlashChipSelect(unsigned char chipno,unsigned char mode)
; {
	.dbline 89
;  	 if(chipno==FLASHCHIP_1) {
	cpi R16,1
	brne L2
X0:
	.dbline 89
	.dbline 90
; 	 	if(mode==LOW) PORTC &= 0xEF; 
	cpi R18,2
	brne L4
X1:
	.dbline 90
	in R24,0x8
	andi R24,239
	out 0x8,R24
	xjmp L3
L4:
	.dbline 91
; 		else PORTC |= 0x10;  
	sbi 0x8,4
	.dbline 92
; 		}
	xjmp L3
L2:
	.dbline 93
; 	 else if(chipno==FLASHCHIP_2) {
	cpi R16,2
	brne L6
X2:
	.dbline 93
	.dbline 94
; 	 	if(mode==LOW) PORTD &= 0xFB; 
	cpi R18,2
	brne L8
X3:
	.dbline 94
	in R24,0xb
	andi R24,251
	out 0xb,R24
	xjmp L9
L8:
	.dbline 95
; 		else PORTD |= 0x04;  
	sbi 0xb,2
L9:
	.dbline 96
; 	    }
L6:
L3:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r mode 18 c
	.dbsym r chipno 16 c
	.dbend
	.dbfunc e ConvertPower2FlashAddress _ConvertPower2FlashAddress fV
;        address -> y+0
	.even
_ConvertPower2FlashAddress::
	xcall push_arg4
	.dbline -1
	.dbline 102
; }
; 
; //  SPI Flash device address construction function
; //  Read address consists of 4 zero bits+11 page bits+9 byte start bits
; void ConvertPower2FlashAddress(long address)
; {
	.dbline 103
;     FlashAddress[0] = (address>>16)&0x00FF;
	ldi R24,255
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	movw R2,R4
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	sts _FlashAddress,R2
	.dbline 104
;     FlashAddress[1] = (address>>8)&0x00FF;
	ldi R24,8
	ldi R25,0
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R24
	xcall asr32
	movw R2,R16
	movw R4,R18
	ldi R24,255
	ldi R25,0
	ldi R26,0
	ldi R27,0
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	sts _FlashAddress+1,R2
	.dbline 105
;     FlashAddress[2] = address&0x00FF;
	ldi R24,255
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	sts _FlashAddress+2,R2
	.dbline -2
L10:
	.dbline 0 ; func end
	adiw R28,4
	ret
	.dbsym l address 0 L
	.dbend
	.dbfunc e ConvertFlashAddress _ConvertFlashAddress fV
;     superpages -> R10,R11
;      bytestart -> R20,R21
;          pages -> R22,R23
;         inchar -> R10
;        address -> y+6
	.even
_ConvertFlashAddress::
	xcall push_arg4
	xcall push_xgsetF00C
	.dbline -1
	.dbline 111
; }
; 
; //  SPI Flash device address construction function
; //  Read address consists of 4 zero bits+11 page bits+9 byte start bits
; void ConvertFlashAddress(long address)
; {
	.dbline 116
;     unsigned char inchar;
;  	unsigned int pages,bytestart,superpages;
; 	
; 	//  Use simple addressing if 321D or 642D
; 	if((flashpagesize0==512)||(flashpagesize0==1024))  
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	movw R24,R2
	cpi R24,0
	ldi R30,2
	cpc R25,R30
	breq L16
X4:
	cpi R24,0
	ldi R30,4
	cpc R25,R30
	brne L14
X5:
L16:
	.dbline 117
; 	                    ConvertPower2FlashAddress(address);
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
	xcall _ConvertPower2FlashAddress
	xjmp L15
L14:
	.dbline 118
; 	else {
	.dbline 122
; //	    putchar('=');
; //	    PrintLongHex(address,6);
; //	    putchar(' ');	
; 	    pages = address/flashpagesize0;
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32s
	movw R22,R16
	.dbline 123
; 	    superpages = pages/256;
	movw R10,R22
	mov R10,R11
	clr R11
	.dbline 124
; 	    bytestart = address - (long)pages*flashpagesize0;
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	movw R16,R22
	movw R18,R24
	clr R18
	clr R19
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall empy32s
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	sub R2,R16
	sbc R3,R17
	sbc R4,R18
	sbc R5,R19
	movw R20,R2
	.dbline 125
; 	    inchar = ((superpages&0x00ff)<<1) + ((pages&0x00ff)>>7);
	ldi R18,7
	ldi R19,0
	movw R16,R22
	andi R17,0
	xcall lsr16
	movw R24,R10
	andi R25,0
	mov R10,R24
	lsl R10
	rol R11
	add R10,R16
	adc R11,R17
	.dbline 126
;         FlashAddress[0] = inchar;
	sts _FlashAddress,R10
	.dbline 128
; //	    PrintHex(inchar);
; 	    inchar = ((pages&0x00ff)<<1) + (bytestart>>8);
	movw R2,R20
	mov R2,R3
	clr R3
	movw R24,R22
	andi R25,0
	mov R10,R24
	lsl R10
	rol R11
	add R10,R2
	adc R11,R3
	.dbline 129
; 	    FlashAddress[1] = inchar;
	sts _FlashAddress+1,R10
	.dbline 131
; //	    PrintHex(inchar);
; 	    inchar = bytestart & 0x00FF;
	movw R24,R20
	andi R25,0
	mov R10,R24
	.dbline 132
; 	    FlashAddress[2] = inchar;
	sts _FlashAddress+2,R10
	.dbline 135
; //	    PrintHex(inchar);
; //	    putchar('=');	
; 		}
L15:
	.dbline -2
L13:
	.dbline 0 ; func end
	xcall pop_xgsetF00C
	adiw R28,4
	ret
	.dbsym r superpages 10 i
	.dbsym r bytestart 20 i
	.dbsym r pages 22 i
	.dbsym r inchar 10 c
	.dbsym l address 6 L
	.dbend
	.dbfunc e ProgramPower2 _ProgramPower2 fV
;         chipno -> R10
	.even
_ProgramPower2::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 143
; }
; 
; //  Convert Serial Flash to Power of 2 device
; //  For AT45DB642D  - send 3D 2A 80 A6
; //  For AT45DB321D  - send 3D 2A 80 A6
; //  Function assumes Serial Flash is 642 or 321
; void ProgramPower2(unsigned char chipno)
; {
	.dbline 145
; 	 //  Set PC4 or PD2 low - Flash CS
; 	 FlashChipSelect(chipno,LOW);
	ldi R18,2
	mov R16,R10
	xcall _FlashChipSelect
	.dbline 148
; 
; 	 // Send Power of 2 command sequence
;  	 SPI_MasterTransmit(0x3D);
	ldi R16,61
	xcall _SPI_MasterTransmit
	.dbline 149
;  	 SPI_MasterTransmit(0x2A);
	ldi R16,42
	xcall _SPI_MasterTransmit
	.dbline 150
;  	 SPI_MasterTransmit(0x80);
	ldi R16,128
	xcall _SPI_MasterTransmit
	.dbline 151
;  	 SPI_MasterTransmit(0xA6);
	ldi R16,166
	xcall _SPI_MasterTransmit
	.dbline 154
; 
; 	 // Set PC4 or PD2 high - deselect Flash chip
; 	 FlashChipSelect(chipno,HIGH);
	ldi R18,1
	mov R16,R10
	xcall _FlashChipSelect
	.dbline 156
; 	 
; 	 Delaymsec(20);
	ldi R16,20
	ldi R17,0
	xcall _Delaymsec
	.dbline -2
L19:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r chipno 10 c
	.dbend
	.dbfunc e SPI_GetManufacturerID _SPI_GetManufacturerID fc
;      instatus2 -> R20
;       instatus -> R10
;         chipno -> R12
	.even
_SPI_GetManufacturerID::
	xcall push_xgset30FC
	mov R12,R16
	.dbline -1
	.dbline 161
; }
; 
; //  Get serial flash chip status
; unsigned char SPI_GetManufacturerID(unsigned char chipno)
; {
	.dbline 165
;  	 unsigned char instatus,instatus2;
; 	 
; 	 //  Set PC4 or PD2 low - Flash CS
; 	 FlashChipSelect(chipno,LOW);
	ldi R18,2
	mov R16,R12
	xcall _FlashChipSelect
	.dbline 168
; 
; 	 // Send Continuous read command
;  	 SPI_MasterTransmit(0x9F);
	ldi R16,159
	xcall _SPI_MasterTransmit
	.dbline 170
; 
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R10,R16
	.dbline 171
; 	 printf("Device Id = %x ",instatus);
	mov R18,R10
	clr R19
	ldi R16,<L21
	ldi R17,>L21
	xcall _printf
	.dbline 172
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R10,R16
	.dbline 173
; 	 printf("%x ",instatus);
	mov R18,R10
	clr R19
	ldi R16,<L22
	ldi R17,>L22
	xcall _printf
	.dbline 174
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R14,R16
	mov R10,R14
	.dbline 175
; 	 printf("%x ",instatus);
	mov R18,R10
	clr R19
	ldi R16,<L22
	ldi R17,>L22
	xcall _printf
	.dbline 176
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R14,R16
	mov R10,R14
	.dbline 177
; 	 printf("%x\n\r",instatus);
	mov R18,R10
	clr R19
	ldi R16,<L23
	ldi R17,>L23
	xcall _printf
	.dbline 178
; 	 instatus2 = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R14,R16
	mov R20,R14
	.dbline 181
; 	 
; 	 // Set PC4 or PD2 high - deselect Flash chip
; 	 FlashChipSelect(chipno,HIGH);
	ldi R18,1
	mov R16,R12
	xcall _FlashChipSelect
	.dbline 183
; 	 
; 	 return instatus;
	mov R16,R10
	.dbline -2
L20:
	.dbline 0 ; func end
	xjmp pop_xgset30FC
	.dbsym r instatus2 20 c
	.dbsym r instatus 10 c
	.dbsym r chipno 12 c
	.dbend
	.dbfunc e SPI_SerialFlashStatus _SPI_SerialFlashStatus fc
;      instatus2 -> R14
;       instatus -> R10
;         chipno -> R12
	.even
_SPI_SerialFlashStatus::
	xcall push_xgset00FC
	mov R12,R16
	.dbline -1
	.dbline 188
; }
; 
; //  Get serial flash chip status
; unsigned char SPI_SerialFlashStatus(unsigned char chipno)
; {
	.dbline 192
;  	 unsigned char instatus,instatus2;
; 	 
; 	 //  Set PC4 or PD2 low - Flash CS
; 	 FlashChipSelect(chipno,LOW);
	ldi R18,2
	mov R16,R12
	xcall _FlashChipSelect
	.dbline 195
; 
; 	 // Send Continuous read command
;  	 SPI_MasterTransmit(SF_READ_STATUS);
	ldi R16,215
	xcall _SPI_MasterTransmit
	.dbline 197
; 
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R10,R16
	.dbline 198
; 	 instatus2 = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R14,R16
	.dbline 201
; 	 
; 	 // Set PC4 or PD2 high - deselect Flash chip
; 	 FlashChipSelect(chipno,HIGH);
	ldi R18,1
	mov R16,R12
	xcall _FlashChipSelect
	.dbline 203
; 	 
; 	 return instatus;
	mov R16,R10
	.dbline -2
L24:
	.dbline 0 ; func end
	xjmp pop_xgset00FC
	.dbsym r instatus2 14 c
	.dbsym r instatus 10 c
	.dbsym r chipno 12 c
	.dbend
	.dbfunc e SPI_StartReadFlashPage _SPI_StartReadFlashPage fV
;              i -> R20,R21
;        address -> y+2
	.even
_SPI_StartReadFlashPage::
	xcall push_arg4
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 209
; }
; 
; //  SPI Flash continuous read command for AT45DB041B
; //  The AT45DB041B has 2048 264byte pages
; void SPI_StartReadFlashPage(long address)
; {
	.dbline 213
;  	 int i;
; 	 
; 	 // Send Continuous read command
;  	 SPI_MasterTransmit(SF_READ_CONT);
	ldi R16,232
	xcall _SPI_MasterTransmit
	.dbline 216
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(address);
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	xcall _ConvertFlashAddress
	.dbline 217
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	clr R21
L26:
	.dbline 217
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L27:
	.dbline 217
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 217
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brlt L26
X6:
	.dbline 220
; 	 
; 	 //  32 dummy bits
; 	 for(i=0; i<4; i++)  SPI_MasterTransmit(0x00);
	clr R20
	clr R21
L30:
	.dbline 220
	clr R16
	xcall _SPI_MasterTransmit
L31:
	.dbline 220
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 220
	cpi R20,4
	ldi R30,0
	cpc R21,R30
	brlt L30
X7:
	.dbline -2
L25:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	adiw R28,4
	ret
	.dbsym r i 20 I
	.dbsym l address 2 L
	.dbend
	.dbfunc e SPI_ReadFlashBuffer _SPI_ReadFlashBuffer fV
;              i -> R20,R21
;   buffernumber -> y+6
;        address -> y+2
	.even
_SPI_ReadFlashBuffer::
	xcall push_arg4
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 225
; }
; 
; //  SPI Flash Buffer Read command for AT45DB041B
; void SPI_ReadFlashBuffer(long address,int buffernumber)
; {
	.dbline 229
;  	 int i;
; 	 
; 	 // Send buffer read command
; 	 if(buffernumber==1) SPI_MasterTransmit(SF_READ_BUFFER1);
	ldd R24,y+6
	ldd R25,y+7
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne L35
X8:
	.dbline 229
	ldi R16,84
	xcall _SPI_MasterTransmit
	xjmp L36
L35:
	.dbline 230
; 	 else SPI_MasterTransmit(SF_READ_BUFFER2);
	ldi R16,86
	xcall _SPI_MasterTransmit
L36:
	.dbline 233
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(address);
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	xcall _ConvertFlashAddress
	.dbline 234
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	clr R21
L37:
	.dbline 234
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L38:
	.dbline 234
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 234
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brlt L37
X9:
	.dbline 237
; 	 
; 	 //  8 dummy bits
; 	 SPI_MasterTransmit(0x00);
	clr R16
	xcall _SPI_MasterTransmit
	.dbline -2
L34:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	adiw R28,4
	ret
	.dbsym r i 20 I
	.dbsym l buffernumber 6 I
	.dbsym l address 2 L
	.dbend
	.dbfunc e DisplayExtendedAddress _DisplayExtendedAddress fV
; extendedaddress -> R10,R11
	.even
_DisplayExtendedAddress::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 241
; }
; 
; void DisplayExtendedAddress(unsigned int extendedaddress)
; {
	.dbline 242
; 	puts(":02000004");
	ldi R16,<L42
	ldi R17,>L42
	xcall _puts
	.dbline 243
; 	PrintWordHex(extendedaddress);
	movw R16,R10
	xcall _PrintWordHex
	.dbline 244
; 	puts("FF");  // TBD - calculate correct crc
	ldi R16,<L43
	ldi R17,>L43
	xcall _puts
	.dbline 245
; 	putCRLF();
	xcall _putCRLF
	.dbline -2
L41:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r extendedaddress 10 i
	.dbend
	.dbfunc e DisplayIntelRecord _DisplayIntelRecord fV
;      tempvalue -> R10
;       asciicnt -> R20
;       crcvalue -> R14
;          ascii -> y+0
;           byte -> R22
;              i -> R10
;    bytesonline -> R12
;  recordaddress -> R22,R23
	.even
_DisplayIntelRecord::
	xcall push_xgsetF0FC
	mov R12,R18
	movw R22,R16
	sbiw R28,16
	.dbline -1
	.dbline 249
; }
; 
; void DisplayIntelRecord(unsigned int recordaddress,unsigned char bytesonline)
; {
	.dbline 252
;  	 unsigned char i,byte,ascii[16],asciicnt,crcvalue,tempvalue;
; 	
; 	 crcvalue = 0;
	clr R14
	.dbline 253
; 	 putchar(':');
	ldi R16,58
	xcall _putchar$device_specific$
	.dbline 255
; 	 //  Output bytes on line
; 	 PrintHex(bytesonline);
	mov R16,R12
	xcall _PrintHex
	.dbline 256
; 	 crcvalue += bytesonline;
	add R14,R12
	.dbline 258
; 	 //  Output hex start address
; 	 PrintWordHex(recordaddress);
	movw R16,R22
	xcall _PrintWordHex
	.dbline 259
;      tempvalue = (recordaddress&0xff00)>>8;
	movw R24,R22
	andi R24,0
	movw R10,R24
	mov R10,R11
	clr R11
	.dbline 260
; 	 crcvalue += tempvalue;
	add R14,R10
	.dbline 261
; 	 tempvalue = recordaddress&0x00ff;
	movw R24,R22
	andi R25,0
	.dbline 262
; 	 crcvalue += tempvalue;
	add R14,R24
	.dbline 264
; 	 //  Output record type 0
; 	 puts("00");
	ldi R16,<L45
	ldi R17,>L45
	xcall _puts
	.dbline 266
; 	 //  Output data
; 	 for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L49
L46:
	.dbline 266
	.dbline 267
; 	     byte = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R22,R16
	.dbline 268
; 		 ascii[asciicnt++] = byte;
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	movw R24,R28
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 269
; 		 crcvalue += byte;
	add R14,R16
	.dbline 270
; 	     PrintHex(byte);
	xcall _PrintHex
	.dbline 271
; 	     }
L47:
	.dbline 266
	inc R10
L49:
	.dbline 266
	cp R10,R12
	brlo L46
X10:
	.dbline 273
; 	 // Output CRC
; 	 PrintHex((~crcvalue)+0x01);
	mov R16,R14
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 274
; 	 asciicnt = 0;
	clr R20
	.dbline 275
; 	 if(showascii==YES)  {
	lds R24,_showascii
	cpi R24,1
	brne L50
X11:
	.dbline 275
	.dbline 276
; 		 puts("  ");
	ldi R16,<L52
	ldi R17,>L52
	xcall _puts
	.dbline 277
; 		 for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L56
L53:
	.dbline 277
	.dbline 278
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putchar(ascii[i]);
	movw R24,R28
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L57
X12:
	cpi R20,128
	brsh L57
X13:
	.dbline 278
	movw R24,R28
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putchar$device_specific$
	xjmp L58
L57:
	.dbline 279
; 			 else putchar('.');
	ldi R16,46
	xcall _putchar$device_specific$
L58:
	.dbline 280
; 			 }
L54:
	.dbline 277
	inc R10
L56:
	.dbline 277
	cp R10,R12
	brlo L53
X14:
	.dbline 281
; 		 }
L50:
	.dbline 282
; 	 putCRLF();  
	xcall _putCRLF
	.dbline -2
L44:
	.dbline 0 ; func end
	adiw R28,16
	xjmp pop_xgsetF0FC
	.dbsym r tempvalue 10 c
	.dbsym r asciicnt 20 c
	.dbsym r crcvalue 14 c
	.dbsym l ascii 0 A[16:16]c
	.dbsym r byte 22 c
	.dbsym r i 10 c
	.dbsym r bytesonline 12 c
	.dbsym r recordaddress 22 i
	.dbend
	.dbfunc e DisplaySerialFlash _DisplaySerialFlash fV
;      tempvalue -> <dead>
;       crcvalue -> <dead>
;       asciicnt -> <dead>
;          ascii -> y+10
; bytesonlastline -> <dead>
;           byte -> <dead>
;              i -> <dead>
; oldextendedaddress -> y+26
;     endaddress -> y+6
;  recordaddress -> R14,R15
;    firstrecord -> R10
;        address -> y+2
; extendedaddress -> R12,R13
;       readmode -> R10
;       numbytes -> y+42
;   startaddress -> y+38
	.even
_DisplaySerialFlash::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,28
	ldd R10,y+46
	.dbline -1
	.dbline 288
; }
; 
; //  Display P1 Blackfin Flash memory
; //    Blackfin must be reset
; void DisplaySerialFlash(long startaddress,long numbytes,char readmode)
; {
	.dbline 295
;  	 char firstrecord;
;  	 unsigned char i,byte,bytesonlastline,ascii[16],asciicnt,crcvalue,tempvalue;
; 	 unsigned int extendedaddress,oldextendedaddress,recordaddress;
; 	 long address,endaddress;
; 
; 	 //  Set PC4 low - Flash CS
; 	 FlashChipSelect(FLASHCHIP_1,LOW);  
	ldi R18,2
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 297
; 
; 	 if(readmode==READCONTINUOUS) {
	mov R24,R10
	cpi R24,1
	brne L60
X15:
	.dbline 297
	.dbline 299
; 	 	 //puts("Continuous Read\n\r");
; 	     SPI_StartReadFlashPage(startaddress);
	ldd R16,y+38
	ldd R17,y+39
	ldd R18,y+40
	ldd R19,y+41
	xcall _SPI_StartReadFlashPage
	.dbline 300
; 		 } 
	xjmp L61
L60:
	.dbline 301
; 	 else if(readmode==READBUFFER) SPI_ReadFlashBuffer(startaddress,1);
	mov R24,R10
	cpi R24,2
	brne L62
X16:
	.dbline 301
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldd R16,y+38
	ldd R17,y+39
	ldd R18,y+40
	ldd R19,y+41
	xcall _SPI_ReadFlashBuffer
L62:
L61:
	.dbline 303
; 	 
; 	 address = startaddress; 
	ldd R2,y+38
	ldd R3,y+39
	ldd R4,y+40
	ldd R5,y+41
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	.dbline 304
; 	 endaddress = startaddress+numbytes;
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	ldd R6,y+38
	ldd R7,y+39
	ldd R8,y+40
	ldd R9,y+41
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+6,R6
	std y+7,R7
	std y+8,R8
	std y+9,R9
	.dbline 305
; 	 oldextendedaddress = address/65536;
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall div32s
	std y+27,R17
	std y+26,R16
	.dbline 306
; 	 bytesonline = 16;	
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 307
; 	 firstrecord = YES;
	clr R10
	inc R10
	xjmp L65
L64:
	.dbline 309
; 	 
; 	 while(address<endaddress) {
	.dbline 310
; 	 	 extendedaddress = address/65536;
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall div32s
	movw R12,R16
	.dbline 311
; 	     recordaddress = address - extendedaddress*65536; 
	movw R2,R12
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	sub R2,R16
	sbc R3,R17
	sbc R4,R18
	sbc R5,R19
	movw R14,R2
	.dbline 314
; 		 
; 		 // Output extended record if start address > 65536
; 		 if((firstrecord==YES)&&(extendedaddress>0))  {
	mov R24,R10
	cpi R24,1
	brne L67
X17:
	tst R12
	brne X18
	tst R13
	breq L67
X18:
	.dbline 314
	.dbline 316
; 			 //puts("-1-");
; 			 firstrecord = NO;
	clr R10
	.dbline 317
; 		     DisplayExtendedAddress(extendedaddress);
	movw R16,R12
	xcall _DisplayExtendedAddress
	.dbline 318
; 			 }	
	xjmp L68
L67:
	.dbline 321
; 			 
; 		 // Traversed 65536 boundary?			 
; 	     else if(extendedaddress>oldextendedaddress) {
	ldd R0,y+26
	ldd R1,y+27
	cp R0,R12
	cpc R1,R13
	brsh L69
X19:
	.dbline 321
	.dbline 323
; 			 //puts("-2-");
; 		     oldextendedaddress = extendedaddress;
	std y+27,R13
	std y+26,R12
	.dbline 324
; 			 DisplayExtendedAddress(extendedaddress);
	movw R16,R12
	xcall _DisplayExtendedAddress
	.dbline 325
; 		 	 }
	xjmp L70
L69:
	.dbline 328
; 		
; 		 // Generate current Hex record
; 		 else {
	.dbline 329
; 		     firstrecord = NO;
	clr R10
	.dbline 330
; 		     if(((long)recordaddress+bytesonline)>65536) {
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	clr R4
	clr R5
	movw R6,R14
	clr R8
	clr R9
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	cp R20,R6
	cpc R21,R7
	cpc R22,R8
	cpc R23,R9
	brge L71
X20:
	.dbline 330
	.dbline 332
; 				 //puts("-3-");
; 			     bytesonline = (65536 - recordaddress);
	movw R2,R14
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	sub R20,R2
	sbc R21,R3
	sbc R22,R4
	sbc R23,R5
	movw R2,R20
	sts _bytesonline+1,R3
	sts _bytesonline,R2
	.dbline 333
; 			     DisplayIntelRecord(recordaddress,bytesonline);
	mov R18,R20
	movw R16,R14
	xcall _DisplayIntelRecord
	.dbline 334
; 			     address += (long) bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	clr R4
	clr R5
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+2,R6
	std y+3,R7
	std y+4,R8
	std y+5,R9
	.dbline 335
; 				 bytesonline = 16;
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 336
; 				 }
	xjmp L72
L71:
	.dbline 337
; 			 else if(((long)recordaddress+(long)bytesonline+(long)extendedaddress*65536)>endaddress) {
	movw R2,R12
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	clr R4
	clr R5
	movw R6,R14
	clr R8
	clr R9
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	add R6,R16
	adc R7,R17
	adc R8,R18
	adc R9,R19
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brlt X23
	xjmp L73
X23:
X21:
	.dbline 337
	.dbline 339
; 				 //puts("-3-3-");
; 			     bytesonline = endaddress - ((long)recordaddress+(long)extendedaddress*65536);
	movw R2,R12
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	movw R2,R14
	clr R4
	clr R5
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	ldd R6,y+6
	ldd R7,y+7
	ldd R8,y+8
	ldd R9,y+9
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	sts _bytesonline+1,R7
	sts _bytesonline,R6
	.dbline 340
; 			     DisplayIntelRecord(recordaddress,bytesonline);
	mov R18,R6
	movw R16,R14
	xcall _DisplayIntelRecord
	.dbline 341
; 			     address += (long) bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	clr R4
	clr R5
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+2,R6
	std y+3,R7
	std y+4,R8
	std y+5,R9
	.dbline 342
; 				 bytesonline = 16;
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 343
; 				 }
	xjmp L74
L73:
	.dbline 344
; 			 else {  
	.dbline 345
; 			     DisplayIntelRecord(recordaddress,bytesonline); 
	lds R18,_bytesonline
	movw R16,R14
	xcall _DisplayIntelRecord
	.dbline 346
; 			     address += (long) bytesonline; 
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	clr R4
	clr R5
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+2,R6
	std y+3,R7
	std y+4,R8
	std y+5,R9
	.dbline 347
; 				 }
L74:
L72:
	.dbline 348
; 			 }
L70:
L68:
	.dbline 349
; 		}			 
L65:
	.dbline 309
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brge X24
	xjmp L64
X24:
X22:
	.dbline 352
; 		 
; 	 // Set PC4 high - deselect Flash chip
; 	 FlashChipSelect(FLASHCHIP_1,HIGH);  
	ldi R18,1
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 353
; 	 puts(":00000001FF\n\r");
	ldi R16,<L75
	ldi R17,>L75
	xcall _puts
	.dbline -2
L59:
	.dbline 0 ; func end
	adiw R28,28
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l tempvalue 3 c
	.dbsym l crcvalue 3 c
	.dbsym l asciicnt 3 c
	.dbsym l ascii 10 A[16:16]c
	.dbsym l bytesonlastline 3 c
	.dbsym l byte 3 c
	.dbsym l i 3 c
	.dbsym l oldextendedaddress 26 i
	.dbsym l endaddress 6 L
	.dbsym r recordaddress 14 i
	.dbsym r firstrecord 10 c
	.dbsym l address 2 L
	.dbsym r extendedaddress 12 i
	.dbsym r readmode 10 c
	.dbsym l numbytes 42 L
	.dbsym l startaddress 38 L
	.dbend
	.dbfunc e ProgramBuffertoPageErase _ProgramBuffertoPageErase fV
;              i -> R20
;       bufferid -> y+5
;   startaddress -> y+1
	.even
_ProgramBuffertoPageErase::
	xcall push_arg4
	st -y,R20
	.dbline -1
	.dbline 359
; }
; 
; // Transfer buffer n to flash memory with built-in erase
; //  This operation takes about 20msec max
; void  ProgramBuffertoPageErase(long startaddress,unsigned char bufferid)
; {
	.dbline 365
;      unsigned char i;
; 	 
; 	 //puts("+p b p e+");
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(FLASHCHIP_1,LOW);    
	ldi R18,2
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 368
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1) SPI_MasterTransmit(SF_BUF1_TO_FLASH_ERASE);
	ldd R24,y+5
	cpi R24,1
	brne L77
X25:
	.dbline 368
	ldi R16,131
	xcall _SPI_MasterTransmit
	xjmp L78
L77:
	.dbline 369
; 	 else SPI_MasterTransmit(SF_BUF2_TO_FLASH_ERASE);
	ldi R16,134
	xcall _SPI_MasterTransmit
L78:
	.dbline 373
; 	 
; //	 puts(" write page at ");
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(startaddress);
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	xcall _ConvertFlashAddress
	.dbline 376
; 	 
; 	 //FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L82
L79:
	.dbline 376
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L80:
	.dbline 376
	inc R20
L82:
	.dbline 376
	cpi R20,3
	brlo L79
X26:
	.dbline 379
; 	 
; 	 // Serial Flash CS high - start erase
; 	 FlashChipSelect(FLASHCHIP_1,HIGH);   	 
	ldi R18,1
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L76:
	.dbline 0 ; func end
	ld R20,y+
	adiw R28,4
	ret
	.dbsym r i 20 c
	.dbsym l bufferid 5 c
	.dbsym l startaddress 1 L
	.dbend
	.dbfunc e EraseFlashPage _EraseFlashPage fV
;              i -> R20
;   startaddress -> y+1
	.even
_EraseFlashPage::
	xcall push_arg4
	st -y,R20
	.dbline -1
	.dbline 384
; }
; 
; // Maximum erase time is 20msec
; void  EraseFlashPage(long startaddress)
; {
	.dbline 390
;      unsigned char i;
; 	 
; 	 //puts("+e f p+");
; 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(FLASHCHIP_1,LOW);    
	ldi R18,2
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 393
; 	 
; 	 //  Buffer write
; 	 SPI_MasterTransmit(SF_PAGE_ERASE);
	ldi R16,129
	xcall _SPI_MasterTransmit
	.dbline 396
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(startaddress);
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	xcall _ConvertFlashAddress
	.dbline 397
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L87
L84:
	.dbline 397
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L85:
	.dbline 397
	inc R20
L87:
	.dbline 397
	cpi R20,3
	brlo L84
X27:
	.dbline 400
; 	 
; 	 // Serial Flash CS high - start erase
; 	 FlashChipSelect(FLASHCHIP_1,HIGH);   	 
	ldi R18,1
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L83:
	.dbline 0 ; func end
	ld R20,y+
	adiw R28,4
	ret
	.dbsym r i 20 c
	.dbsym l startaddress 1 L
	.dbend
	.dbfunc e ProgramFlashBuffer _ProgramFlashBuffer fV
;              i -> R20
;       bufferid -> y+5
;   startaddress -> y+1
	.even
_ProgramFlashBuffer::
	xcall push_arg4
	st -y,R20
	.dbline -1
	.dbline 405
; }
; 
; //  Load data into flash chip RAM buffer
; void ProgramFlashBuffer(long startaddress,unsigned char bufferid)
; {
	.dbline 411
;      unsigned char i;
; 	 
; 	 //puts("+p f b+");
; 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(FLASHCHIP_1,LOW);    
	ldi R18,2
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 414
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1)  SPI_MasterTransmit(SF_WRITE_BUFFER1);
	ldd R24,y+5
	cpi R24,1
	brne L89
X28:
	.dbline 414
	ldi R16,132
	xcall _SPI_MasterTransmit
	xjmp L90
L89:
	.dbline 415
; 	 else  SPI_MasterTransmit(SF_WRITE_BUFFER2);
	ldi R16,135
	xcall _SPI_MasterTransmit
L90:
	.dbline 418
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(startaddress);
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	xcall _ConvertFlashAddress
	.dbline 420
; 	 //FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L94
L91:
	.dbline 420
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L92:
	.dbline 420
	inc R20
L94:
	.dbline 420
	cpi R20,3
	brlo L91
X29:
	.dbline 422
; 	 
; 	 for(i=0; i<bytesonline; i++)  SPI_MasterTransmit(intelbinary[i]);
	clr R20
	xjmp L98
L95:
	.dbline 422
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L96:
	.dbline 422
	inc R20
L98:
	.dbline 422
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R20
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L95
X30:
	.dbline 425
; 	 
; 	 // Serial Flash CS high
; 	 FlashChipSelect(FLASHCHIP_1,HIGH);
	ldi R18,1
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L88:
	.dbline 0 ; func end
	ld R20,y+
	adiw R28,4
	ret
	.dbsym r i 20 c
	.dbsym l bufferid 5 c
	.dbsym l startaddress 1 L
	.dbend
	.dbfunc e LoadFlashPage _LoadFlashPage fV
;              i -> R20
;       bufferid -> y+5
;   startaddress -> y+1
	.even
_LoadFlashPage::
	xcall push_arg4
	st -y,R20
	.dbline -1
	.dbline 429
; }
; 
; void LoadFlashPage(long startaddress,unsigned char bufferid)
; {
	.dbline 434
;      unsigned char i;
; 	 
; 	 //puts("+l f p+");
; 	 // Serial Flash CS low
; 	 FlashChipSelect(FLASHCHIP_1,LOW);    
	ldi R18,2
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 437
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1)  SPI_MasterTransmit(SF_FLASH_TO_BUF1);
	ldd R24,y+5
	cpi R24,1
	brne L100
X31:
	.dbline 437
	ldi R16,83
	xcall _SPI_MasterTransmit
	xjmp L101
L100:
	.dbline 438
; 	 else  SPI_MasterTransmit(SF_FLASH_TO_BUF2);
	ldi R16,85
	xcall _SPI_MasterTransmit
L101:
	.dbline 441
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(startaddress);
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	xcall _ConvertFlashAddress
	.dbline 442
; 	 FlashAddress[0] = 0x00;
	clr R2
	sts _FlashAddress,R2
	.dbline 443
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L105
L102:
	.dbline 443
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L103:
	.dbline 443
	inc R20
L105:
	.dbline 443
	cpi R20,3
	brlo L102
X32:
	.dbline 446
; 	 
; 	 // Serial Flash CS high
; 	 FlashChipSelect(FLASHCHIP_1,HIGH);
	ldi R18,1
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L99:
	.dbline 0 ; func end
	ld R20,y+
	adiw R28,4
	ret
	.dbsym r i 20 c
	.dbsym l bufferid 5 c
	.dbsym l startaddress 1 L
	.dbend
	.dbfunc e WaitForFlashFree _WaitForFlashFree fV
;         chipno -> R10
	.even
_WaitForFlashFree::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 451
;     
; }
; 
; void  WaitForFlashFree(unsigned char chipno)
; { 	  
L107:
	.dbline 452
; 	  while(!(SPI_SerialFlashStatus(chipno)&0x80)) ;
L108:
	.dbline 452
	mov R16,R10
	xcall _SPI_SerialFlashStatus
	sbrs R16,7
	rjmp L107
X33:
	.dbline -2
L106:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r chipno 10 c
	.dbend
	.dbfunc e ProgramSerialFlash _ProgramSerialFlash fV
;   shortaddress -> y+5
;       newpage2 -> R10,R11
;     newbytecnt -> R14,R15
;        newpage -> R12,R13
;  globaladdress -> y+1
;   shortbytecnt -> y+9
;              i -> R12,R13
	.even
_ProgramSerialFlash::
	xcall push_xgsetF0FC
	sbiw R28,11
	.dbline -1
	.dbline 478
; 	  //Delaymsec(30);
; }
; 
; int totalbytecnt;
; 
; //  Main Serial Flash programming state controller
; //
; //  Serial flash chips are programmed one page at a time.  A serial flash chip
; //  has two SRAM buffers.  Due to AVR limitations programming data is first
; //  loaded into the SRAM buffers then transferred to Flash.  SRAM buffers 
; //  range in size from 264 to 1056 bytes so the state machine must keep track
; //  of different buffer sizes.  IntelHex records range in size from 1 to 32
; //  bytes (AVR limitation) and can arrive at any start address.
; //
; //  As IntelHex records are received on the serial channel they are first
; //  loaded into Flash SRAM (AVR doesn't have enough SRAM available) and then
; //  written to a Flash page if a termination record is received or the SRAM 
; //  buffer becomes full.  To prevent Flash overwrite a Flash page is first 
; //  loaded into SRAM and new data overwritten in SRAM.  
; //
; //  To reduce variable use bytesonline, inteladdress and intelsuperaddress
; //  are global variables.
; //
; //  TBD - support for two flash chips
; void ProgramSerialFlash(void)
; {
	.dbline 482
;  	 long globaladdress,shortaddress;
; 	 unsigned int newpage,newpage2,shortbytecnt,newbytecnt,i;
; 	 
; 	 globaladdress = intelextendedaddress*65536 + inteladdress;
	lds R2,_intelextendedaddress
	lds R3,_intelextendedaddress+1
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	movw R2,R16
	movw R4,R18
	lds R6,_inteladdress
	lds R7,_inteladdress+1
	clr R8
	clr R9
	add R2,R6
	adc R3,R7
	adc R4,R8
	adc R5,R9
	std y+1,R2
	std y+2,R3
	std y+3,R4
	std y+4,R5
	.dbline 484
; 	 //puts("=1="); PrintLongHex(globaladdress,6); puts("=1="); 
; 	 newpage = globaladdress/flashpagesize0;
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32s
	movw R12,R16
	.dbline 487
; 	 
;      // Always load flash page for first record
;  	 if(flashprogrammingactive==NO) {
	lds R2,_flashprogrammingactive
	tst R2
	brne L111
X34:
	.dbline 487
	.dbline 488
; 	     totalbytecnt = 0;
	clr R2
	clr R3
	sts _totalbytecnt+1,R3
	sts _totalbytecnt,R2
	.dbline 489
; 		 LoadFlashPage(globaladdress,1);
	ldi R24,1
	std y+0,R24
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	xcall _LoadFlashPage
	.dbline 490
; 		 WaitForFlashFree(1);  // wait for transfer to complete - 300usec
	ldi R16,1
	xcall _WaitForFlashFree
	.dbline 491
; 	     flashprogrammingactive = YES;
	ldi R24,1
	sts _flashprogrammingactive,R24
	.dbline 492
; 		 flashpageloaded = YES;
	sts _flashpageloaded,R24
	.dbline 493
; 		 oldpage = newpage;
	sts _oldpage+1,R13
	sts _oldpage,R12
	.dbline 494
; 		 }
	xjmp L112
L111:
	.dbline 498
; 
;  	 // See if flash page was loaded - preserves old data not in the new
; 	 // record from being overwritten
;  	 else if(flashpageloaded==NO)  {
	lds R2,_flashpageloaded
	tst R2
	brne L113
X35:
	.dbline 498
	.dbline 500
; //	     puts(" load page ");
; 	     LoadFlashPage(globaladdress,1);
	ldi R24,1
	std y+0,R24
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	xcall _LoadFlashPage
	.dbline 501
; 		 WaitForFlashFree(1);  // wait for programming to complete - 20msec
	ldi R16,1
	xcall _WaitForFlashFree
	.dbline 502
; 		 flashpageloaded = YES;
	ldi R24,1
	sts _flashpageloaded,R24
	.dbline 503
; 		 }
L113:
L112:
	.dbline 506
; 		 
; 	 // See if number of bytes in record causes a page boundary traverse
; 	 newbytecnt = bytesonline;
	lds R14,_bytesonline
	lds R15,_bytesonline+1
	.dbline 507
; 	 newpage2 = (globaladdress+bytesonline)/flashpagesize0;
	movw R2,R14
	clr R4
	clr R5
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	add R16,R2
	adc R17,R3
	adc R18,R4
	adc R19,R5
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32s
	movw R10,R16
	.dbline 508
; 	 if(newpage!=newpage2) {
	cp R12,R16
	cpc R13,R17
	brne X42
	xjmp L115
X42:
X36:
	.dbline 508
	.dbline 509
; 		 shortaddress = newpage*flashpagesize0;	 
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R12
	xcall empy16s
	movw R2,R16
	clr R4
	clr R5
	std y+5,R2
	std y+6,R3
	std y+7,R4
	std y+8,R5
	.dbline 510
; 		 shortbytecnt = flashpagesize0 - (globaladdress - shortaddress);
	ldd R2,y+5
	ldd R3,y+6
	ldd R4,y+7
	ldd R5,y+8
	ldd R6,y+1
	ldd R7,y+2
	ldd R8,y+3
	ldd R9,y+4
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	sub R2,R6
	sbc R3,R7
	sbc R4,R8
	sbc R5,R9
	std y+10,R3
	std y+9,R2
	.dbline 511
; 		 newbytecnt = bytesonline - shortbytecnt;
	lds R14,_bytesonline
	lds R15,_bytesonline+1
	movw R0,R2
	sub R14,R2
	sbc R15,R3
	.dbline 512
; 		 bytesonline = shortbytecnt;
	sts _bytesonline+1,R1
	sts _bytesonline,R0
	.dbline 513
; 		 if(newbytecnt>0) flashpageboundarytraversed = YES;
	tst R14
	brne X37
	tst R15
	breq L117
X37:
	.dbline 513
	ldi R24,1
	sts _flashpageboundarytraversed,R24
L117:
	.dbline 516
; //		 puts(" shortcnt="); printint(shortbytecnt,3,' ');
; //		 puts(" newbytcnt="); printint(newbytecnt,3,' ');
; 		 }
L115:
	.dbline 518
; 	 
; 	 totalbytecnt += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	lds R4,_totalbytecnt
	lds R5,_totalbytecnt+1
	add R4,R2
	adc R5,R3
	sts _totalbytecnt+1,R5
	sts _totalbytecnt,R4
	.dbline 519
; 	 ProgramFlashBuffer(globaladdress,1);  //puts(" l buf="); printint(totalbytecnt,5,' ');
	ldi R24,1
	std y+0,R24
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	xcall _ProgramFlashBuffer
	.dbline 520
; 	 flashdatainbuffer = YES;
	ldi R24,1
	sts _flashdatainbuffer,R24
	.dbline 523
; 	 
; 	 //  If Buffer full or boundary traversed transfer buffer to flash
; 	 if((newbytecnt==0)||(flashpageboundarytraversed==YES))  {
	tst R14
	brne X38
	tst R15
	breq L121
X38:
	lds R24,_flashpageboundarytraversed
	cpi R24,1
	brne L119
X39:
L121:
	.dbline 523
	.dbline 524
; 	     ProgramBuffertoPageErase(globaladdress,1);  //puts(" write page ");
	ldi R24,1
	std y+0,R24
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	xcall _ProgramBuffertoPageErase
	.dbline 525
; 		 WaitForFlashFree(1);  // wait for programming to complete - 20msec
	ldi R16,1
	xcall _WaitForFlashFree
	.dbline 526
; 		 flashpageloaded = NO;
	clr R2
	sts _flashpageloaded,R2
	.dbline 527
; 		 flashdatainbuffer = NO;
	sts _flashdatainbuffer,R2
	.dbline 529
; //		 puts(" p page="); printint(newpage,3,' '); putchar(' ');
; 		 }
L119:
	.dbline 532
; 	 
; 	 //  If record caused a page boundary traversal load next page
; 	 if(flashpageboundarytraversed==YES) {
	lds R24,_flashpageboundarytraversed
	cpi R24,1
	breq X43
	xjmp L122
X43:
X40:
	.dbline 532
	.dbline 533
; 	     newpage++;       // goto next page
	movw R24,R12
	adiw R24,1
	movw R12,R24
	.dbline 534
; 		 oldpage = newpage;
	sts _oldpage+1,R13
	sts _oldpage,R12
	.dbline 536
; //		 puts(" t page="); printint(newpage,3,' '); putchar(' ');
; 		 globaladdress = newpage*flashpagesize0;  // start address at page bdry
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R24
	xcall empy16s
	movw R2,R16
	clr R4
	clr R5
	std y+1,R2
	std y+2,R3
	std y+3,R4
	std y+4,R5
	.dbline 537
; 		 lastaddress = globaladdress;
	ldd R2,y+1
	ldd R3,y+2
	ldd R4,y+3
	ldd R5,y+4
	sts _lastaddress+1,R3
	sts _lastaddress,R2
	sts _lastaddress+2+1,R5
	sts _lastaddress+2,R4
	.dbline 538
; 		 LoadFlashPage(globaladdress,1);   // Load the new page - this may be last record
	ldi R24,1
	std y+0,R24
	movw R16,R2
	movw R18,R4
	xcall _LoadFlashPage
	.dbline 540
; 		                     // So don't overwrite remaining content in page
; 		 WaitForFlashFree(1);
	ldi R16,1
	xcall _WaitForFlashFree
	.dbline 541
; 		 flashpageloaded = YES;  // Page loaded so don't do it again next recrd
	ldi R24,1
	sts _flashpageloaded,R24
	.dbline 542
; 		 for(i=0; i<shortbytecnt; i++)  // Shift record data to start
	clr R12
	clr R13
	xjmp L127
L124:
	.dbline 543
; 		      intelbinary[i] = intelbinary[shortbytecnt+i];
	ldd R30,y+9
	ldd R31,y+10
	add R30,R12
	adc R31,R13
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	movw R30,R12
	add R30,R24
	adc R31,R25
	std z+0,R2
L125:
	.dbline 542
	movw R24,R12
	adiw R24,1
	movw R12,R24
L127:
	.dbline 542
	ldd R0,y+9
	ldd R1,y+10
	cp R12,R0
	cpc R13,R1
	brlo L124
X41:
	.dbline 544
; 		 bytesonline = shortbytecnt;  // Only write new data in record
	sts _bytesonline+1,R1
	sts _bytesonline,R0
	.dbline 545
; 	 	 totalbytecnt += bytesonline;
	lds R4,_totalbytecnt
	lds R5,_totalbytecnt+1
	add R4,R0
	adc R5,R1
	sts _totalbytecnt+1,R5
	sts _totalbytecnt,R4
	.dbline 546
; 		 ProgramFlashBuffer(globaladdress,1);  // write remaining record to RAM buffer
	ldi R24,1
	std y+0,R24
	ldd R16,y+1
	ldd R17,y+2
	ldd R18,y+3
	ldd R19,y+4
	xcall _ProgramFlashBuffer
	.dbline 547
; 		 flashdatainbuffer = YES;
	ldi R24,1
	sts _flashdatainbuffer,R24
	.dbline 548
; 		 flashpageboundarytraversed = NO;
	clr R2
	sts _flashpageboundarytraversed,R2
	.dbline 549
; 	     }
L122:
	.dbline 550
; 	 lastaddress = globaladdress;
	ldd R2,y+1
	ldd R3,y+2
	ldd R4,y+3
	ldd R5,y+4
	sts _lastaddress+1,R3
	sts _lastaddress,R2
	sts _lastaddress+2+1,R5
	sts _lastaddress+2,R4
	.dbline -2
L110:
	.dbline 0 ; func end
	adiw R28,11
	xjmp pop_xgsetF0FC
	.dbsym l shortaddress 5 L
	.dbsym r newpage2 10 i
	.dbsym r newbytecnt 14 i
	.dbsym r newpage 12 i
	.dbsym l globaladdress 1 L
	.dbsym l shortbytecnt 9 i
	.dbsym r i 12 i
	.dbend
	.dbfunc e FlashPageSize _FlashPageSize fI
;       sizecode -> R16
	.even
_FlashPageSize::
	.dbline -1
	.dbline 556
; }
; 
; // Return Serial Flash page size
; //  Assume 321D and 642D are programmed as Power 2 devices
; int FlashPageSize(unsigned char sizecode)
; {
	.dbline 558
;      //printf("Flash code = %x\n",sizecode);
;  	 if((sizecode==AT45DB041ID)||(sizecode==AT45DB081ID))  return 264;
	cpi R16,28
	breq L131
X44:
	cpi R16,36
	brne L129
X45:
L131:
	.dbline 558
	ldi R16,264
	ldi R17,1
	xjmp L128
L129:
	.dbline 559
; 	 else if(sizecode==AT45DB161ID) return 528;
	cpi R16,44
	brne L132
X46:
	.dbline 559
	ldi R16,528
	ldi R17,2
	xjmp L128
L132:
	.dbline 560
; 	 else if(sizecode==AT45DB321ID) return 512; // Must program as Power 2
	cpi R16,52
	brne L134
X47:
	.dbline 560
	ldi R16,512
	ldi R17,2
	xjmp L128
L134:
	.dbline 561
; 	 else if(sizecode==AT45DB642ID) return 1024; // Must program as Power 2
	cpi R16,60
	brne L136
X48:
	.dbline 561
	ldi R16,1024
	ldi R17,4
	xjmp L128
L136:
	.dbline 562
; 	 else return 0;
	clr R16
	clr R17
	.dbline -2
L128:
	.dbline 0 ; func end
	ret
	.dbsym r sizecode 16 c
	.dbend
	.dbfunc e CheckPower2 _CheckPower2 fV
;         status -> R12
;         chipid -> R10
	.even
_CheckPower2::
	st -y,R10
	st -y,R12
	mov R12,R18
	mov R10,R16
	.dbline -1
	.dbline 566
; }
; 
; void CheckPower2(unsigned char chipid,unsigned char status)
; {
	.dbline 567
;  	 if(status&0x01) return;  // If bit 0 set then Power 2 enabled 
	sbrs R12,0
	rjmp L139
X49:
	.dbline 567
	xjmp L138
L139:
	.dbline 568
; 	 if(((status&0x3C)==AT45DB321ID)||((status&0x3C)==AT45DB642ID)) {
	mov R24,R12
	clr R25
	andi R24,60
	andi R25,0
	movw R2,R24
	cpi R24,52
	ldi R30,0
	cpc R25,R30
	breq L143
X50:
	cpi R24,60
	ldi R30,0
	cpc R25,R30
	brne L141
X51:
L143:
	.dbline 568
	.dbline 569
; 	     printf("Program power 2 in chip %d\n\r",chipid);
	mov R18,R10
	clr R19
	ldi R16,<L144
	ldi R17,>L144
	xcall _printf
	.dbline 570
; 	     ProgramPower2(chipid);
	mov R16,R10
	xcall _ProgramPower2
	.dbline 571
; 		 }
L141:
	.dbline -2
L138:
	.dbline 0 ; func end
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r status 12 c
	.dbsym r chipid 10 c
	.dbend
	.dbfunc e CheckFlashTypes _CheckFlashTypes fV
	.even
_CheckFlashTypes::
	st -y,R10
	st -y,R11
	.dbline -1
	.dbline 578
; }
; 
; //  Search for serial flash chips U2, U5
; //  U2 is always present while U5 is optional
; //  This routine initializes SPI and resets Blackfin
; void  CheckFlashTypes()
; {
	.dbline 579
; 	Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 580
; 	ResetBlackfinBootMode(BOOTMODE0);
	ldi R16,48
	xcall _ResetBlackfinBootMode
	.dbline 582
; //	SPI_GetManufacturerID(FLASHCHIP_1);
; 	flashtype0 = SPI_SerialFlashStatus(FLASHCHIP_1);
	ldi R16,1
	xcall _SPI_SerialFlashStatus
	sts _flashtype0,R16
	.dbline 584
;     //printf("Flashtype0 = %x\n\r",flashtype0);
; 	if(flashtype0==0xff) flashpagesize0 = 0;
	cpi R16,255
	brne L146
X52:
	.dbline 584
	clr R2
	clr R3
	sts _flashpagesize0+1,R3
	sts _flashpagesize0,R2
	xjmp L147
L146:
	.dbline 585
; 	else {
	.dbline 586
; 		CheckPower2(FLASHCHIP_1,flashtype0);  // Convert to Power 2
	lds R18,_flashtype0
	ldi R16,1
	xcall _CheckPower2
	.dbline 587
; 	    flashtype0 &= FLASHIDMASK;
	lds R24,_flashtype0
	andi R24,60
	sts _flashtype0,R24
	.dbline 588
; 	    flashpagesize0 = FlashPageSize(flashtype0);
	mov R16,R24
	xcall _FlashPageSize
	sts _flashpagesize0+1,R17
	sts _flashpagesize0,R16
	.dbline 589
; 		}
L147:
	.dbline 591
; 		
; 	flashtype1 = SPI_SerialFlashStatus(FLASHCHIP_2);
	ldi R16,2
	xcall _SPI_SerialFlashStatus
	mov R10,R16
	sts _flashtype1,R10
	.dbline 593
;     //printf("Flashtype1 = %x\n\r",flashtype1);
; 	if(flashtype1==0xff) flashpagesize1 = 0;
	cpi R16,255
	brne L148
X53:
	.dbline 593
	clr R2
	clr R3
	sts _flashpagesize1+1,R3
	sts _flashpagesize1,R2
	xjmp L149
L148:
	.dbline 594
; 	else  {
	.dbline 595
; 		CheckPower2(FLASHCHIP_2,flashtype1);  // Convert to Power 2
	lds R18,_flashtype1
	ldi R16,2
	xcall _CheckPower2
	.dbline 596
; 	    flashtype1 &= FLASHIDMASK;
	lds R24,_flashtype1
	andi R24,60
	sts _flashtype1,R24
	.dbline 597
; 	    flashpagesize1 = FlashPageSize(flashtype1);	
	mov R16,R24
	xcall _FlashPageSize
	movw R10,R16
	sts _flashpagesize1+1,R11
	sts _flashpagesize1,R10
	.dbline 598
; 		}
L149:
	.dbline 599
; 	Release_SPI();
	xcall _Release_SPI
	.dbline 600
; 	ResetBlackfinBootMode(BOOTMODE3);
	ldi R16,51
	xcall _ResetBlackfinBootMode
	.dbline -2
L145:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbend
	.dbfunc e EraseSerialFlash _EraseSerialFlash fV
;              i -> R20,R21
	.even
_EraseSerialFlash::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 604
; }
; 
; void EraseSerialFlash()
; {
	.dbline 607
;     int i;
; 	
; 	Release_SPI();
	xcall _Release_SPI
	.dbline 608
; 	ResetBlackfinBootMode(BOOTMODE0);
	ldi R16,48
	xcall _ResetBlackfinBootMode
	.dbline 609
; 	Init_SPI_Master();	
	xcall _Init_SPI_Master
	.dbline 610
; 	for(i=0; i<20; i++) {
	clr R20
	clr R21
L151:
	.dbline 610
	.dbline 612
; 	    //inteladdress = i*flashpagesize0;
; 		EraseFlashPage((long)(i*flashpagesize0));
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R20
	xcall empy16s
	clr R18
	sbrc R17,7
	com R18
	clr R19
	sbrc R18,7
	com R19
	xcall _EraseFlashPage
	.dbline 613
; 		WaitForFlashFree(1);
	ldi R16,1
	xcall _WaitForFlashFree
	.dbline 614
; 		}
L152:
	.dbline 610
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 610
	cpi R20,20
	ldi R30,0
	cpc R21,R30
	brlt L151
X54:
	.dbline 615
; 	Release_SPI();
	xcall _Release_SPI
	.dbline 616
; 	ResetBlackfinBootMode(BOOTMODE3);
	ldi R16,51
	xcall _ResetBlackfinBootMode
	.dbline -2
L150:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r i 20 I
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
_totalbytecnt::
	.blkb 2
	.dbsym e totalbytecnt _totalbytecnt I
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
L144:
	.blkb 29
	.area idata
	.byte 'P,'r,'o,'g,'r,'a,'m,32,'p,'o,'w,'e,'r,32,50,32
	.byte 'i,'n,32,'c,'h,'i,'p,32,37,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
L75:
	.blkb 14
	.area idata
	.byte 58,48,48,48,48,48,48,48,49,'F,'F,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
L52:
	.blkb 3
	.area idata
	.byte 32,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
L45:
	.blkb 3
	.area idata
	.byte 48,48,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
L43:
	.blkb 3
	.area idata
	.byte 'F,'F,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
L42:
	.blkb 10
	.area idata
	.byte 58,48,50,48,48,48,48,48,52,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
L23:
	.blkb 5
	.area idata
	.byte 37,'x,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
L22:
	.blkb 4
	.area idata
	.byte 37,'x,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
L21:
	.blkb 16
	.area idata
	.byte 'D,'e,'v,'i,'c,'e,32,'I,'d,32,61,32,37,'x,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_SPI_Flash.c
; }
; 
