	.module P1_AVR_Uart.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_Uart.c
	.dbfunc e putchar _putchar$device_specific$ fI
;        tmphead -> R20
;           data -> R16
	.even
_putchar$device_specific$::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 71
; /**************************************************************
; 
;    Program Title:  P1 AVR Boot/Monitor
;    
;    Program Name:  P1_AVR_Uart.c	Version: 0.88
;    
;    Author:  SS	  			    Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    This file contains routines that implement basic Uart put/get functions.
;    
;    Copyright 2004-2007, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright (C) 2005-2007 by SOC Robotics, Inc. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com
;  */
; 
; /*
;  * $Log: P1_Monitor.c,v $
;  * Revision 0.88  2007/07/23 16:40:20  SS
;  *    Port to ATmega644
;  * Revision 0.55  2005/07/17 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "P1_AVR_Uart.h"
; #include "P1_AVR_Defines.h"
; #include "P1_AVR_Extern.h"
; 
; int putchar(unsigned char data)
; //void putchar(unsigned char data)
; {
	.dbline 75
; 	unsigned char tmphead;
; 	
; 	// Calculate buffer index
; 	tmphead = (UART_TxHead + 1) & UART_TX_BUFFER_MASK; 
	lds R20,_UART_TxHead
	subi R20,255    ; addi 1
	andi R20,31
L2:
	.dbline 78
; 		
; 	// Wait for free space in buffer
; 	while(tmphead == UART_TxTail) ;
L3:
	.dbline 78
	lds R2,_UART_TxTail
	cp R20,R2
	breq L2
X0:
	.dbline 80
; 	
; 	UART_TxBuf[tmphead] = data; // store data in buffer
	ldi R24,<_UART_TxBuf
	ldi R25,>_UART_TxBuf
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 81
; 	UART_TxHead = tmphead;      // store new index
	sts _UART_TxHead,R20
	.dbline 83
; 	
; 	UCSR0B |= (1<<UDRIE0);        // Fire TX UDRIE interrupt
	lds R24,193
	ori R24,32
	sts 193,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r tmphead 20 c
	.dbsym r data 16 c
	.dbend
	.dbfunc e getcharnw _getcharnw fc
;          rxtmp -> <dead>
;        tmptail -> R16
	.even
_getcharnw::
	.dbline -1
	.dbline 88
; }
; 
; // Read and write functions
; unsigned char getcharnw(void)
; {
	.dbline 91
; 	unsigned char tmptail,rxtmp;
; 
; 	if(UART_RxHead==UART_RxTail) return 0; // nothing to get
	lds R2,_UART_RxTail
	lds R3,_UART_RxHead
	cp R3,R2
	brne L6
X1:
	.dbline 91
	clr R16
	xjmp L5
L6:
	.dbline 93
; 		
; 	tmptail = (UART_RxTail+1)&UART_RX_BUFFER_MASK;  // calculate buffer index
	lds R16,_UART_RxTail
	subi R16,255    ; addi 1
	andi R16,31
	.dbline 94
; 	UART_RxTail = tmptail;     // store new index
	sts _UART_RxTail,R16
	.dbline 97
; 	
; //	_CLI();
; 	rxcnt--;
	lds R24,_rxcnt
	subi R24,1
	sts _rxcnt,R24
	.dbline 114
; //	if(rxcnt<0) rxcnt = 0;
; //	rxtmp = rxcnt;
; //	_SEI();    // Enable interrupts => enable UART interrupts
; 
; //	if(rxtmp < 0) putchar('<');
; //	if(rxtmp > 0x3f) putchar('>');
; 
; 	// Allow tx at remote serial device again - buffer has more space
; //	if((rxtmp<(UART_RX_BUFFER_SIZE-40))&&(xoffsent==YES)&&(enablexonoff==YES)) {
; //		if(xonsent==NO) {
; //			putchar(XON);
; // 			putchar('$');
; //			xonsent = YES;
; //			}
; //		}
; 
; 	return UART_RxBuf[tmptail];   // return data
	ldi R24,<_UART_RxBuf
	ldi R25,>_UART_RxBuf
	mov R30,R16
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbsym l rxtmp 1 c
	.dbsym r tmptail 16 c
	.dbend
	.dbfunc e getchar _getchar$device_specific$ fI
;         inchar -> R10
	.even
_getchar$device_specific$::
	st -y,R10
	.dbline -1
	.dbline 120
; }
; 
; // Getchar waits until a valid character is received
; int getchar(void)
; //unsigned char getchar(void)
; {
L9:
	.dbline 123
;     unsigned char inchar;
; 	
;  	while(!(inchar=getcharnw())) ;
L10:
	.dbline 123
	xcall _getcharnw
	mov R10,R16
	tst R10
	breq L9
X2:
	.dbline 124
; 	return inchar;
	clr R17
	.dbline -2
L8:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e InittUART _InittUART fV
;       baudrate -> R16
	.even
_InittUART::
	.dbline -1
	.dbline 129
; }
; 
; /* Initialize UART */
; void InittUART(unsigned char baudrate)
; {
	.dbline 131
;  	/* set the baud rate */
; 	UBRR0H = 0x00;
	clr R2
	sts 197,R2
	.dbline 132
; 	UBRR0L = baudrate; 
	sts 196,R16
	.dbline 133
; 	UCSR0B = BIT(RXEN0) | BIT(TXEN0); /* enable UART receiver and transmitter */
	ldi R24,24
	sts 193,R24
	.dbline 137
;     //  8 data bits, 2 stop bits
; //	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
;     //  8 data bits, 1 stop bit
; 	UCSR0C = (1<<UMSEL01)|(3<<UCSZ01);
	ldi R24,140
	sts 194,R24
	.dbline -2
L12:
	.dbline 0 ; func end
	ret
	.dbsym r baudrate 16 c
	.dbend
	.dbfunc e ReceiveByte _ReceiveByte fc
	.even
_ReceiveByte::
	.dbline -1
	.dbline 142
; }
; 
; // Polled receive function - non-wait
; unsigned char ReceiveByte(void)
; {
	.dbline 143
; 	if((UCSR0A & (1<<RXC0))) return UDR0;
	lds R2,192
	sbrs R2,7
	rjmp L14
X3:
	.dbline 143
	lds R16,198
	xjmp L13
L14:
	.dbline 144
; 	else return 0x00;
	clr R16
	.dbline -2
L13:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TransmitByte _TransmitByte fV
;           data -> R16
	.even
_TransmitByte::
	.dbline -1
	.dbline 149
; }
; 
; // Polled transmit function
; void TransmitByte(unsigned char data)
; {
L17:
	.dbline 151
; 	while ( !(UCSR0A & (1<<UDRE0)) )
; 		; /* wait for empty transmit buffer */
L18:
	.dbline 150
	lds R2,192
	sbrs R2,5
	rjmp L17
X4:
	.dbline 152
; 	UDR0 = data; /* start transmission */
	sts 198,R16
	.dbline -2
L16:
	.dbline 0 ; func end
	ret
	.dbsym r data 16 c
	.dbend
	.dbfunc e puttchar _puttchar fV
;           data -> R10
	.even
_puttchar::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 157
; }
; 
; //  Buffered write to UART - wait until transmitted
; void puttchar(unsigned char data)
; {
	.dbline 158
;  	 TransmitByte(data);
	mov R16,R10
	xcall _TransmitByte
	.dbline -2
L20:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r data 10 c
	.dbend
	.dbfunc e gettchar _gettchar fc
;         inchar -> R10
	.even
_gettchar::
	st -y,R10
	.dbline -1
	.dbline 164
; }
; 
; //  Buffered character read from UART - don't return if 
; //  character is Null
; unsigned char gettchar(void)
; {
L22:
	.dbline 167
;      unsigned char inchar;
; 	 
;  	 while(!(inchar=ReceiveByte())) ;
L23:
	.dbline 167
	xcall _ReceiveByte
	mov R10,R16
	tst R10
	breq L22
X5:
	.dbline 168
;  	 return inchar;
	.dbline -2
L21:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e printint _printint fV
;           tens -> R20,R21
;       hundreds -> R12,R13
;      thousands -> R10,R11
;   tenthousands -> R14,R15
;         nolead -> R22
;       outvalue -> y+0
;              i -> R20,R21
;   leadchartype -> y+20
;        charcnt -> y+18
;       intvalue -> y+16
	.even
_printint::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,6
	.dbline -1
	.dbline 173
; }
; 
; //  Convert binary value to ASCII int
; void printint(unsigned int intvalue,char charcnt,char leadchartype)
; {
	.dbline 177
;  	 char outvalue[6],nolead;
;  	 int  i,tenthousands, thousands, hundreds, tens;
; 	 
; 	 if(intvalue >= 0) ;  //putchar(' ');
	ldi R24,1
	tst R24
	breq L26
X6:
	.dbline 177
	xjmp L27
L26:
	.dbline 178
; 	 else {
	.dbline 179
; 	 	  putchar('-');
	ldi R16,45
	xcall _putchar$device_specific$
	.dbline 180
; 	 	  intvalue *= -1;
	ldi R18,-1
	ldi R19,-1
	ldd R16,y+16
	ldd R17,y+17
	xcall empy16s
	std y+17,R17
	std y+16,R16
	.dbline 181
; 		  }
L27:
	.dbline 182
; 	 tenthousands = intvalue/10000;
	ldi R18,10000
	ldi R19,39
	ldd R16,y+16
	ldd R17,y+17
	xcall div16u
	movw R14,R16
	.dbline 183
; 	 intvalue -= (tenthousands*10000);
	ldi R16,10000
	ldi R17,39
	movw R18,R14
	xcall empy16s
	ldd R0,y+16
	ldd R1,y+17
	sub R0,R16
	sbc R1,R17
	std y+17,R1
	std y+16,R0
	.dbline 184
; 	 thousands = intvalue/1000;
	ldi R18,1000
	ldi R19,3
	movw R16,R0
	xcall div16u
	movw R10,R16
	.dbline 185
; 	 intvalue -= (thousands*1000);
	ldi R16,1000
	ldi R17,3
	movw R18,R10
	xcall empy16s
	ldd R0,y+16
	ldd R1,y+17
	sub R0,R16
	sbc R1,R17
	std y+17,R1
	std y+16,R0
	.dbline 186
; 	 hundreds = intvalue/100;
	ldi R18,100
	ldi R19,0
	movw R16,R0
	xcall div16u
	movw R12,R16
	.dbline 187
; 	 intvalue -= (hundreds*100);
	ldi R16,100
	ldi R17,0
	movw R18,R12
	xcall empy16s
	ldd R0,y+16
	ldd R1,y+17
	sub R0,R16
	sbc R1,R17
	std y+17,R1
	std y+16,R0
	.dbline 188
; 	 tens = intvalue/10;
	ldi R18,10
	ldi R19,0
	movw R16,R0
	xcall div16u
	movw R20,R16
	.dbline 189
; 	 nolead = 0x00;
	clr R22
	.dbline 191
; 	 // TODO - suppress only leading zero's
; 	 if(tenthousands)  {outvalue[0] = '0' + tenthousands; nolead=0x01;}
	tst R14
	brne X7
	tst R15
	breq L28
X7:
	.dbline 191
	.dbline 191
	movw R24,R14
	adiw R24,48
	std y+0,R24
	.dbline 191
	ldi R22,1
	.dbline 191
	xjmp L29
L28:
	.dbline 192
; 	 else outvalue[0] = leadchartype;
	ldd R0,y+20
	std y+0,R0
L29:
	.dbline 193
; 	 if(thousands|nolead) {outvalue[1] = '0' + thousands;nolead=0x01;}
	mov R2,R22
	clr R3
	movw R4,R10
	or R4,R2
	or R5,R3
	tst R4
	brne X8
	tst R5
	breq L30
X8:
	.dbline 193
	.dbline 193
	movw R24,R10
	adiw R24,48
	std y+1,R24
	.dbline 193
	ldi R22,1
	.dbline 193
	xjmp L31
L30:
	.dbline 194
; 	 else outvalue[1] = leadchartype;
	ldd R0,y+20
	std y+1,R0
L31:
	.dbline 195
; 	 if(hundreds|nolead) {outvalue[2] = '0' + hundreds;nolead=0x01;}
	mov R2,R22
	clr R3
	movw R4,R12
	or R4,R2
	or R5,R3
	tst R4
	brne X9
	tst R5
	breq L34
X9:
	.dbline 195
	.dbline 195
	movw R24,R12
	adiw R24,48
	std y+2,R24
	.dbline 195
	ldi R22,1
	.dbline 195
	xjmp L35
L34:
	.dbline 196
; 	 else outvalue[2] = leadchartype;
	ldd R0,y+20
	std y+2,R0
L35:
	.dbline 197
; 	 if(tens|nolead) outvalue[3] = '0' + tens;
	mov R2,R22
	clr R3
	movw R4,R20
	or R4,R2
	or R5,R3
	tst R4
	brne X10
	tst R5
	breq L38
X10:
	.dbline 197
	movw R24,R20
	adiw R24,48
	std y+3,R24
	xjmp L39
L38:
	.dbline 198
; 	 else outvalue[3] = leadchartype;
	ldd R0,y+20
	std y+3,R0
L39:
	.dbline 199
; 	 outvalue[4] = '0' + intvalue%10; 
	ldi R18,10
	ldi R19,0
	ldd R16,y+16
	ldd R17,y+17
	xcall mod16u
	movw R24,R16
	adiw R24,48
	std y+4,R24
	.dbline 200
; 	 outvalue[5] = 0x00;
	clr R2
	std y+5,R2
	.dbline 201
; 	 for(i=0; i<charcnt; i++) putchar(outvalue[(5-charcnt)+i]);
	clr R20
	clr R21
	xjmp L47
L44:
	.dbline 201
	ldd R2,y+18
	clr R3
	ldi R30,5
	ldi R31,0
	sub R30,R2
	sbc R31,R3
	add R30,R20
	adc R31,R21
	movw R24,R28
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putchar$device_specific$
L45:
	.dbline 201
	subi R20,255  ; offset = 1
	sbci R21,255
L47:
	.dbline 201
	ldd R2,y+18
	clr R3
	cp R20,R2
	cpc R21,R3
	brlt L44
X11:
	.dbline -2
L25:
	.dbline 0 ; func end
	adiw R28,6
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym r tens 20 I
	.dbsym r hundreds 12 I
	.dbsym r thousands 10 I
	.dbsym r tenthousands 14 I
	.dbsym r nolead 22 c
	.dbsym l outvalue 0 A[6:6]c
	.dbsym r i 20 I
	.dbsym l leadchartype 20 c
	.dbsym l charcnt 18 c
	.dbsym l intvalue 16 i
	.dbend
	.dbfunc e puts _puts fI
;              i -> R20,R21
;        outstrg -> R10,R11
	.even
_puts::
	xcall push_xgset300C
	movw R10,R16
	.dbline -1
	.dbline 206
; }
; 
; int puts(char *outstrg)
; //void puts(char *outstrg)
; {
	.dbline 209
;  	 int i;
; 	 
; 	 for(i=0; i<strlen(outstrg); i++)  putchar(outstrg[i]);
	clr R20
	clr R21
	xjmp L52
L49:
	.dbline 209
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R16,z+0
	xcall _putchar$device_specific$
L50:
	.dbline 209
	subi R20,255  ; offset = 1
	sbci R21,255
L52:
	.dbline 209
	movw R16,R10
	xcall _strlen
	cp R20,R16
	cpc R21,R17
	brlo L49
X12:
	.dbline -2
L48:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r i 20 I
	.dbsym r outstrg 10 pc
	.dbend
	.dbfunc e putCRLF _putCRLF fV
	.even
_putCRLF::
	.dbline -1
	.dbline 213
; }
; 
; void putCRLF()
; {
	.dbline 214
;  	 puts("\n\r");
	ldi R16,<L54
	ldi R17,>L54
	xcall _puts
	.dbline -2
L53:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e putfs _putfs fV
;              i -> R20,R21
;         inchar -> R10
;        signon1 -> R12,R13
	.even
_putfs::
	xcall push_xgset303C
	movw R12,R16
	.dbline -1
	.dbline 220
; }
; 
; 
; //  Load string constant from Flash (conserves RAM)
; void putfs(const char *signon1)
; { 	
	.dbline 224
; 	char inchar;
;     int i;
; 	
; 	i = 0;
	clr R20
	clr R21
	xjmp L57
L56:
	.dbline 225
; 	while((inchar=*(signon1+i++))!=0x00)  putchar(inchar);
	mov R16,R10
	xcall _putchar$device_specific$
L57:
	.dbline 225
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R30,R2
	add R30,R12
	adc R31,R13
	lpm R2,Z
	mov R10,R2
	tst R10
	brne L56
X13:
	.dbline -2
L55:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 20 I
	.dbsym r inchar 10 c
	.dbsym r signon1 12 pkc
	.dbend
	.dbfunc e bytetohex _bytetohex fV
;         inchar -> <dead>
;         inbyte -> R20
;           byte -> R16
	.even
_bytetohex::
	st -y,R20
	.dbline -1
	.dbline 230
; }
; 
; //  Convert byte to ASCII hex
; void bytetohex(unsigned char byte)
; {
	.dbline 233
;     unsigned char inbyte,inchar;
; 	
; 	inbyte = byte & 0x0f;
	mov R20,R16
	andi R20,15
	.dbline 234
; 	if(inbyte > 9) hexbyte[1] = (inbyte - 9) + 0x40;
	ldi R24,9
	cp R24,R20
	brsh L60
X14:
	.dbline 234
	mov R24,R20
	subi R24,9
	subi R24,192    ; addi 64
	sts _hexbyte+1,R24
	xjmp L61
L60:
	.dbline 235
; 	else hexbyte[1] = 0x30 + inbyte;
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte+1,R24
L61:
	.dbline 236
; 	inbyte = byte & 0xf0;
	mov R20,R16
	andi R20,240
	.dbline 237
; 	inbyte >>= 4;
	mov R24,R20
	swap R24
	andi R24,#0x0F
	mov R20,R24
	.dbline 238
; 	if(inbyte >9) hexbyte[0] = (inbyte - 9) + 0x40;
	ldi R24,9
	cp R24,R20
	brsh L64
X15:
	.dbline 238
	mov R24,R20
	subi R24,9
	subi R24,192    ; addi 64
	sts _hexbyte,R24
	xjmp L65
L64:
	.dbline 239
; 	else hexbyte[0] = 0x30 + inbyte;
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte,R24
L65:
	.dbline 240
;     hexbyte[2] = 0x00;
	clr R2
	sts _hexbyte+2,R2
	.dbline -2
L59:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym l inchar 1 c
	.dbsym r inbyte 20 c
	.dbsym r byte 16 c
	.dbend
	.dbfunc e addresstohex _addresstohex fV
;        intbyte -> R10,R11
;       highbyte -> R10
;        lowbyte -> R10
;        address -> R20,R21
	.even
_addresstohex::
	xcall push_xgset300C
	movw R20,R16
	.dbline -1
	.dbline 245
; }
; 
; // Convert word to ASCII Hex
; void addresstohex(unsigned int address)
; {
	.dbline 249
;  	 unsigned char lowbyte,highbyte;
; 	 unsigned int intbyte;
; 	 
; 	 lowbyte = address & 0x00FF;
	movw R24,R20
	andi R25,0
	.dbline 250
; 	 bytetohex(lowbyte);
	mov R16,R24
	xcall _bytetohex
	.dbline 251
; 	 hexaddress[2] = hexbyte[0];
	lds R2,_hexbyte
	sts _hexaddress+2,R2
	.dbline 252
; 	 hexaddress[3] = hexbyte[1];
	lds R2,_hexbyte+1
	sts _hexaddress+3,R2
	.dbline 253
; 	 intbyte = address;
	movw R10,R20
	.dbline 254
; 	 highbyte = address/256;
	mov R10,R11
	clr R11
	.dbline 255
; 	 bytetohex(highbyte);
	mov R16,R10
	xcall _bytetohex
	.dbline 256
; 	 hexaddress[0] = hexbyte[0];
	lds R2,_hexbyte
	sts _hexaddress,R2
	.dbline 257
; 	 hexaddress[1] = hexbyte[1];
	lds R2,_hexbyte+1
	sts _hexaddress+1,R2
	.dbline 258
; 	 hexaddress[4] = 0x00;
	clr R2
	sts _hexaddress+4,R2
	.dbline -2
L67:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r intbyte 10 i
	.dbsym r highbyte 10 c
	.dbsym r lowbyte 10 c
	.dbsym r address 20 i
	.dbend
	.dbfunc e converttohex _converttohex fc
;      lownibble -> R20
;     highnibble -> R22
;         instrg -> R16,R17
	.even
_converttohex::
	xcall push_xgsetF03C
	.dbline -1
	.dbline 264
; }
; 
; 
; // Convert ASCII hex to binary
; unsigned char converttohex(char *instrg)
; {
	.dbline 267
;  	 unsigned char lownibble, highnibble;
; 	 
; 	 if((instrg[0] >= 'A')&(instrg[0]<='F')) highnibble = instrg[0] - 'A' + 10;
	movw R30,R16
	ldd R24,z+0
	cpi R24,65
	brlo L77
X16:
	ldi R22,1
	ldi R23,0
	xjmp L78
L77:
	clr R22
	clr R23
L78:
	ldi R24,70
	movw R30,R16
	ldd R2,z+0
	cp R24,R2
	brlo L79
X17:
	ldi R20,1
	ldi R21,0
	xjmp L80
L79:
	clr R20
	clr R21
L80:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X18
	tst R3
	breq L75
X18:
	.dbline 267
	movw R30,R16
	ldd R22,z+0
	subi R22,65
	subi R22,246    ; addi 10
L75:
	.dbline 268
; 	 if((instrg[0] >= 'a')&(instrg[0]<='f')) highnibble = instrg[0] - 'a' + 10;
	movw R30,R16
	ldd R24,z+0
	cpi R24,97
	brlo L83
X19:
	ldi R24,1
	ldi R25,0
	movw R10,R24
	xjmp L84
L83:
	clr R10
	clr R11
L84:
	ldi R24,102
	movw R30,R16
	ldd R2,z+0
	cp R24,R2
	brlo L85
X20:
	ldi R20,1
	ldi R21,0
	xjmp L86
L85:
	clr R20
	clr R21
L86:
	movw R2,R10
	and R2,R20
	and R3,R21
	tst R2
	brne X21
	tst R3
	breq L81
X21:
	.dbline 268
	movw R30,R16
	ldd R22,z+0
	subi R22,97
	subi R22,246    ; addi 10
	xjmp L82
L81:
	.dbline 269
; 	 else highnibble = instrg[0] - '0';
	movw R30,R16
	ldd R22,z+0
	subi R22,48
L82:
	.dbline 271
; 	 
; 	 if((instrg[1] >= 'A')&(instrg[1]<='F')) lownibble = instrg[1] - 'A' + 10;
	movw R30,R16
	ldd R24,z+1
	cpi R24,65
	brlo L89
X22:
	ldi R24,1
	ldi R25,0
	movw R10,R24
	xjmp L90
L89:
	clr R10
	clr R11
L90:
	ldi R24,70
	movw R30,R16
	ldd R2,z+1
	cp R24,R2
	brlo L91
X23:
	ldi R20,1
	ldi R21,0
	xjmp L92
L91:
	clr R20
	clr R21
L92:
	movw R2,R10
	and R2,R20
	and R3,R21
	tst R2
	brne X24
	tst R3
	breq L87
X24:
	.dbline 271
	movw R30,R16
	ldd R20,z+1
	subi R20,65
	subi R20,246    ; addi 10
	xjmp L88
L87:
	.dbline 272
; 	 else if((instrg[1] >= 'a')&(instrg[1]<='f')) lownibble = instrg[1] - 'a' + 10;
	movw R30,R16
	ldd R24,z+1
	cpi R24,97
	brlo L95
X25:
	ldi R24,1
	ldi R25,0
	movw R12,R24
	xjmp L96
L95:
	clr R12
	clr R13
L96:
	ldi R24,102
	movw R30,R16
	ldd R2,z+1
	cp R24,R2
	brlo L97
X26:
	ldi R24,1
	ldi R25,0
	movw R10,R24
	xjmp L98
L97:
	clr R10
	clr R11
L98:
	movw R2,R12
	and R2,R10
	and R3,R11
	tst R2
	brne X27
	tst R3
	breq L93
X27:
	.dbline 272
	movw R30,R16
	ldd R20,z+1
	subi R20,97
	subi R20,246    ; addi 10
	xjmp L94
L93:
	.dbline 273
; 	 else lownibble = instrg[1] - '0';
	movw R30,R16
	ldd R20,z+1
	subi R20,48
L94:
L88:
	.dbline 275
; 	 
; 	 highnibble = highnibble<<4;
	mov R24,R22
	andi R24,#0x0F
	swap R24
	mov R22,R24
	.dbline 276
; 	 return highnibble + lownibble;
	mov R16,R24
	add R16,R20
	.dbline -2
L74:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym r lownibble 20 c
	.dbsym r highnibble 22 c
	.dbsym r instrg 16 pc
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_Uart.c
L54:
	.blkb 3
	.area idata
	.byte 10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_Uart.c
; }
; 
