/**************************************************************

   Program Title:  P1 AVR Boot/Monitor
   
   Program Name:  P1_AVR_Monitor.h		  Version: 0.87
   
   Author:  SS	  				  		  Date:  August 10, 2005
   
   Compiled with ImageCraft ICCAVR Standard V7.02
   
   Copyright 2004-2005, SOC Robotics, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright (C) 2005 by SOC Robotics, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Machines, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-machines.com
 */
/*
 * $Log: P1_Monitor.c,v $
 * Revision 0.85  2005/07/17 16:40:20  SS
 *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
 * Revision 0.52  2005/06/04 18:36:42  SS
 * Preview release
 *
 */

//  Variable declarations
extern unsigned int bytesonline,inteladdress,intelextendedaddress;
extern long  lastaddress;
extern unsigned char programmode,crc,intelbinary[48];  // length can vary
extern unsigned char hexbyte[3],hexaddress[5],intelrecordcommand;
extern unsigned char seconds,minutes,hours,days,rtcclockcnt;
extern unsigned char flashtype0,flashtype1,flashpageloaded;
extern unsigned char flashprogrammingactive,flashpageboundarytraversed;
extern unsigned char flashprogrammingactive,flashdatainbuffer;
extern unsigned char xofftransmitted,FlashAddress[3],showascii;
extern int flashpagesize0,flashpagesize1,startaddress,currrentaddress;
extern int oldpage,oldbyteoffset,totalrxcnt;
extern int rtccountdown1,rtccountdown2,rtccountdown3,rtccountdown4;
extern int mseccountdown1,mseccountdown2,mseccountdown3,flashcountdown;

extern int _textmode;

// Static Variables
extern unsigned char UART_RxBuf[UART_RX_BUFFER_SIZE];
extern unsigned char UART_RxHead;
extern unsigned char UART_RxTail;
extern unsigned char UART_TxBuf[UART_TX_BUFFER_SIZE];
extern unsigned char UART_TxHead;
extern unsigned char UART_TxTail;
extern char  xoffsent, xonsent, enablexonoff, echoinchars, sendxonxoff;
extern char  rxcnt,checkflag,rxcntmax;
extern unsigned char  ip[5],ipmask[5],ipgate[5],instrg[8];

extern const char signon1[];
extern const char signon2[];
extern const char signon3[];
extern const char signon4[];
extern const char signon5[];
extern const char signon6[];
extern const char signon63[];
extern const char signon65[];
extern const char signon66[];
extern const char signon67[];
extern const char signon7[];
extern const char signon8[];
extern const char signon82[];
extern const char signon83[];
extern const char signon85[];
extern const char signon9[];
extern const char signon10[];
extern const char signon11[];
extern const char signon12[];
extern const char signon121[];
extern const char signon122[];
extern const char signon123[];
extern const char signon124[];
extern const char signon125[];
extern const char signon126[];
extern const char crlfbar[];

extern const char displaymessage1[];
extern const char displaymessage2[];
extern const char displaymessage3[];
extern const char displaymessage33[];

extern const char progmessage[];

extern const char displaymessage4[];
extern const char displaymessage5[];
extern const char displaymessage6[];

extern const char loadmessage1[];
extern const char loadmessage2[];
extern const char loadmessage3[];

extern const char calmessage1[];
extern const char calmessage2[];
extern const char calmessage3[];
extern const char changebaudmessage[];

// Function declarations
extern unsigned char EEPROMwrite(int,unsigned char);
extern unsigned char EEPROMread(int);
extern int printf(CONST char *, ...);
extern int sprintf(char *, CONST char *, ...);
extern int scanf(CONST char *, ...);
extern int sscanf(char *, CONST char *, ...);

extern void InitUART(unsigned char baudrate);
extern void InitADC(void);
extern void InitRealTimeClock(void);
extern void Init_Timer0(void);
extern void InitWatchdog(void);
extern void Init_SPI_Master(void);
extern void Init_AVR(void);
extern void Delay(void);
extern void shortdelay(int cnt);
extern void LongDelay(int cnt);
extern void Delaymsec(int delayvalue);
extern void GREEN_LED(unsigned char mode);
extern void RED_LED(unsigned char mode);
extern void WriteEEPROM(int location, unsigned char *strg);
extern void ShortBlackfinReset(void);
extern void HaltBlackfin(char mode);
extern void ReleaseBlackfin(char mode);
extern void ResetBlackfin(char mode);
extern void BlinkGreen(int period);
extern void BlinkRed(int period);
extern void PiranaMorse(void);
extern void BlackfinBootMode(unsigned char bootmode);
extern void ResetBlackfinBootMode(unsigned char bootmode);
extern void EEPROMSetup(void);
extern void getsettime(void);
extern char getint(void);
extern unsigned char ReadAVRFlash(int address);
extern void signon(void);
extern void DisplayEEPROM(long address,long numbytes);
extern void DisplayAVRFlash(long address,long numbytes);
extern void DisplayMemory(void);
extern void DebugDisplayIntelHex(void);
extern int checkcrc(unsigned char);
extern int DecodeIntelHex(void);
extern void ProgramEEPROM(void);
extern void ProgramAVRFlash(void);
extern void ProgramMemory(void);
extern void FlashChipSelect(unsigned char chipno,unsigned char mode);
extern void LoadMemory(void);
extern void ProgramVersion(void);
extern void PrintHex(unsigned char);
extern int  AnalogCh(int ch);
extern void DumpAnalogChs(void);
extern void convertiptobinary(unsigned char *ip);
extern void InternetSettings(void);
extern void TestAVR(void);
extern void SetBlackfinBootMode(void);
extern void Write_RS485_Byte(unsigned char inbyte);
extern unsigned char Read_RS485_Byte(void);
extern void Init_RS485(int baudrate);
extern void Release_SPI(void);
extern void SPI_MasterTransmit(unsigned char cData);
extern unsigned char SPI_MasterReceive(void);
extern void ConvertFlashAddress(long address);
extern void SPI_StartReadFlashPage(long address);
extern void SPI_ReadFlashBuffer(long address,int buffernumber);
extern void EraseFlashPage(long address);
extern void EraseSerialFlash(void);
extern void ProgramBuffertoPageErase(long address,unsigned char bufferid);
extern void DisplaySerialFlash(long address,long numbytes,char readmode);
extern void ProgramSerialFlash(void);
extern unsigned char SPI_SerialFlashStatus(unsigned char chipno);
extern void CleanUpFlashState(void);
extern void Init_TWI_Master(void);
extern void Init_TWI_Slave(unsigned char slaveaddress,char generalcall);
extern void TWI_Error(void);
extern void TWI_Off(void);
extern unsigned char  TWI_Transmit(unsigned char slaveaddress, unsigned char txdata,
                            unsigned char statusmode);
extern unsigned char TWI_Master_Receive(unsigned char slaveaddress);
extern void  TestTWI(void);
extern void TWI_Write_Slave(void);
extern void putchar(unsigned char data);
extern unsigned char getcharnw(void);
extern unsigned char getchar(void);
extern void InittUART(unsigned char baudrate);
extern unsigned char ReceiveByte(void);
extern void TransmitByte(unsigned char data);
extern void puttchar(unsigned char data);
extern unsigned char gettchar(void);
extern void printint(unsigned int intvalue,char charcnt,char leadchartype);
extern void puts(char *outstrg);
extern void putCRLF(void);
extern void putfs(const char *signon1);
extern void bytetohex(unsigned char byte);
extern void addresstohex(unsigned int address);
extern unsigned char converttohex(char *instrg);
extern void CalibrateOsc(unsigned char mode);
extern void ChangeBaudRate(unsigned char baudrate);
extern void EnterNewBaudRate(void);
extern void SetNewBaudRate(unsigned char baudchar);

