	.module P1_AVR_Utilities.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
	.dbfunc e Delay _Delay fV
;              a -> R16
;              b -> R18
	.even
_Delay::
	.dbline -1
	.dbline 76
; /**************************************************************
; 
;    Program Title:  P1 AVR Boot/Monitor
;    
;    Program Name:  P1_AVR_Utilities.c	Version: 0.87
;    
;    Author:  SS	  					  Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    This file contains routines that implement a set of basic utility 
;    functions for the P1 AVR Boot Monitor.
;    
;    Fuse settings:  BOOTSZ1, BOOTSZ0, SUT1, CKSEL3, CKSEL1, CKSEL0
;    
;    Copyright 2004-2005, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright (C) 2005 by SOC Robotics, Inc. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com
;  */
; 
; /*
;  * $Log: P1_Monitor.c,v $
;  * Revision 0.55  2005/07/17 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom32v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "P1_AVR_Uart.h"
; #include "P1_AVR_Defines.h"
; #include "P1_AVR_Extern.h"
; 
; //*********************************************************
; //*********************************************************
; //      Utilities
; //*********************************************************
; //*********************************************************
; void Delay(void)
; {
	.dbline 79
; 	unsigned char a, b;
; 
; 	for (a = 1; a; a++)
	ldi R16,1
	xjmp L5
L2:
	.dbline 80
; 		for (b = 1; b; b++)
	ldi R18,1
	xjmp L9
L6:
	.dbline 81
; 			;
L7:
	.dbline 80
	inc R18
L9:
	.dbline 80
	tst R18
	brne L6
X0:
L3:
	.dbline 79
	inc R16
L5:
	.dbline 79
	tst R16
	brne L2
X1:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r a 16 c
	.dbsym r b 18 c
	.dbend
	.dbfunc e shortdelay _shortdelay fV
;         inbyte -> R22
;              i -> R20,R21
;            cnt -> R16,R17
	.even
_shortdelay::
	xcall push_xgsetF000
	.dbline -1
	.dbline 85
; }
; 
; void shortdelay(int cnt)
; {
	.dbline 89
;  	unsigned char inbyte;
; 	int i;
; 	
;     for(i=0; i<cnt; i++)  {
	clr R20
	clr R21
	xjmp L14
L11:
	.dbline 89
	.dbline 90
; 	    inbyte = 0x55;
	ldi R22,85
	.dbline 91
; 		}
L12:
	.dbline 89
	subi R20,255  ; offset = 1
	sbci R21,255
L14:
	.dbline 89
	cp R20,R16
	cpc R21,R17
	brlt L11
X2:
	.dbline -2
L10:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 22 c
	.dbsym r i 20 I
	.dbsym r cnt 16 I
	.dbend
	.dbfunc e LongDelay _LongDelay fV
;            cnt -> R20,R21
	.even
_LongDelay::
	st -y,R20
	st -y,R21
	movw R20,R16
	.dbline -1
	.dbline 95
; }
; 
; void LongDelay(int cnt)
; {
	xjmp L17
L16:
	.dbline 96
;  	 while(cnt > 0) {
	.dbline 97
; 	 	 Delay();
	xcall _Delay
	.dbline 98
; 		 cnt--;
	subi R20,1
	sbci R21,0
	.dbline 99
; 		 }
L17:
	.dbline 96
	clr R2
	clr R3
	cp R2,R20
	cpc R3,R21
	brlt L16
X3:
	.dbline -2
L15:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r cnt 20 I
	.dbend
	.dbfunc e Delaymsec _Delaymsec fV
;     delayvalue -> R16,R17
	.even
_Delaymsec::
	.dbline -1
	.dbline 103
; }
; 
; void Delaymsec(int delayvalue)
; {
	.dbline 104
;  	 mseccountdown2 = delayvalue;
	sts _mseccountdown2+1,R17
	sts _mseccountdown2,R16
L20:
	.dbline 105
; 	 while(mseccountdown2) ;
L21:
	.dbline 105
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne L20
	tst R3
	brne L20
X4:
	.dbline -2
L19:
	.dbline 0 ; func end
	ret
	.dbsym r delayvalue 16 I
	.dbend
	.dbfunc e GREEN_LED _GREEN_LED fV
;           mode -> R16
	.even
_GREEN_LED::
	.dbline -1
	.dbline 109
; }
; 
; void GREEN_LED(unsigned char mode)
; {
	.dbline 110
;  	if(mode==ON) PORTD &= ~BIT(6);	// low output to turn LED on
	tst R16
	brne L24
X5:
	.dbline 110
	cbi 0x12,6
	xjmp L25
L24:
	.dbline 111
; 	else PORTD |= BIT(6);	// low output to turn LED off
	sbi 0x12,6
L25:
	.dbline -2
L23:
	.dbline 0 ; func end
	ret
	.dbsym r mode 16 c
	.dbend
	.dbfunc e RED_LED _RED_LED fV
;           mode -> R16
	.even
_RED_LED::
	.dbline -1
	.dbline 115
; }
; 
; void RED_LED(unsigned char mode)
; {
	.dbline 116
;  	 if(mode==ON) PORTD &= ~BIT(7);	
	tst R16
	brne L27
X6:
	.dbline 116
	cbi 0x12,7
	xjmp L28
L27:
	.dbline 117
; 	 else PORTD |= BIT(7);	
	sbi 0x12,7
L28:
	.dbline -2
L26:
	.dbline 0 ; func end
	ret
	.dbsym r mode 16 c
	.dbend
	.dbfunc e RTEEPROMwrite _RTEEPROMwrite fV
;      savedSREG -> R10
;       databyte -> R18
;       location -> R16,R17
	.even
_RTEEPROMwrite::
	st -y,R10
	.dbline -1
	.dbline 124
; }
; 
; // Function to initiate an EEPROM write
; // writes the specified data byte to the specified location
; // this will fail if the EEPROM is not ready!
; void RTEEPROMwrite(int location, unsigned char databyte)
; {
	.dbline 126
; 	unsigned char savedSREG;
; 	EEAR = location;								// set address
	out 0x1f,R17
	out 0x1e,R16
	.dbline 127
; 	EEDR = databyte;								// set data	
	out 0x1d,R18
	.dbline 128
; 	savedSREG = SREG;								// keep setting so it can be restored
	in R10,0x3f
	.dbline 129
; 	CLI();													// disable interrupts
	cli
	.dbline 130
; 	EECR |= BIT(EEMWE);							// set "write enable" bit
	sbi 0x1c,2
	.dbline 131
; 	EECR |= BIT(EEWE);							// set "write" bit
	sbi 0x1c,1
	.dbline 132
; 	SREG = savedSREG;								// restore SREG
	out 0x3f,R10
	.dbline 133
; 	EEAR = 0;
	clr R2
	clr R3
	out 0x1f,R3
	out 0x1e,R2
	.dbline -2
L29:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r savedSREG 10 c
	.dbsym r databyte 18 c
	.dbsym r location 16 I
	.dbend
	.dbfunc e EEPROMWrite _EEPROMWrite fV
;       databyte -> R12
;       location -> R10,R11
	.even
_EEPROMWrite::
	xcall push_xgset003C
	mov R12,R18
	movw R10,R16
	.dbline -1
	.dbline 139
; }
; 
; // EEPROM writes take about 8ms - so poll until done
; // Do not use ICC V7 function EEPROMwrite() - this routine turns interrupts off!
; void EEPROMWrite(int location, unsigned char databyte)
; {
L31:
	.dbline 140
;  	 while(!RTEEPROMReady())  ;
L32:
	.dbline 140
	xcall _RTEEPROMReady
	cpi R16,0
	cpc R16,R17
	breq L31
X7:
	.dbline 141
;  	 RTEEPROMwrite(location,databyte);
	mov R18,R12
	movw R16,R10
	xcall _RTEEPROMwrite
L34:
	.dbline 142
;  	 while(!RTEEPROMReady())  ;
L35:
	.dbline 142
	xcall _RTEEPROMReady
	cpi R16,0
	cpc R16,R17
	breq L34
X8:
	.dbline -2
L30:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r databyte 12 c
	.dbsym r location 10 I
	.dbend
	.dbfunc e WriteEEPROM _WriteEEPROM fV
;              i -> R20,R21
;           strg -> R10,R11
;       location -> R12,R13
	.even
_WriteEEPROM::
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
	.dbline -1
	.dbline 147
; }
; 
; // Write a string of characters to EEPROM at specified start location
; void WriteEEPROM(int location, unsigned char *strg)
; {
	.dbline 150
;  	 int i;
; 	 
; 	 i = 0;
	clr R20
	clr R21
	xjmp L39
L38:
	.dbline 151
; 	 while(strg[i] != 0x00)  {
	.dbline 152
; 	     EEPROMWrite(location+i,strg[i]);
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R18,z+0
	movw R16,R12
	add R16,R20
	adc R17,R21
	xcall _EEPROMWrite
	.dbline 153
; 		 i++;
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 154
; 		 }
L39:
	.dbline 151
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	brne L38
X9:
	.dbline -2
L37:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 20 I
	.dbsym r strg 10 pc
	.dbsym r location 12 I
	.dbend
	.dbfunc e ShortBlackfinReset _ShortBlackfinReset fV
	.even
_ShortBlackfinReset::
	.dbline -1
	.dbline 160
; }
; 
; 
; //  Reset the Blackfin for a short period
; void ShortBlackfinReset(void)
; {
	.dbline 161
;  	 PORTD &= 0xF7;
	in R24,0x12
	andi R24,247
	out 0x12,R24
	.dbline 162
;  	 Delay();
	xcall _Delay
	.dbline 163
; 	 PORTD |= 0x08;
	sbi 0x12,3
	.dbline -2
L41:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e HaltBlackfin _HaltBlackfin fV
;           mode -> R20
	.even
_HaltBlackfin::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 168
; }
; 
; // Halt Blackfin - Reset line is on Port D pin 3
; void HaltBlackfin(char mode)
; {
	.dbline 169
;  	RED_LED(ON);
	clr R16
	xcall _RED_LED
	.dbline 170
; 	PORTD &= 0xF7;
	in R24,0x12
	andi R24,247
	out 0x12,R24
	.dbline 171
; 	if(mode!=QUIET)  puts("Halt Blackfin\n\r");
	cpi R20,1
	breq L43
X10:
	.dbline 171
	ldi R16,<L45
	ldi R17,>L45
	xcall _puts
L43:
	.dbline -2
L42:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r mode 20 c
	.dbend
	.dbfunc e ReleaseBlackfin _ReleaseBlackfin fV
;           mode -> R20
	.even
_ReleaseBlackfin::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 175
; }
; 
; void ReleaseBlackfin(char mode)
; {
	.dbline 176
;  	RED_LED(OFF);
	ldi R16,1
	xcall _RED_LED
	.dbline 177
; 	PORTD |= 0x08;
	sbi 0x12,3
	.dbline 178
; 	if(mode!=QUIET)  puts("Release Blackfin\n\r");
	cpi R20,1
	breq L47
X11:
	.dbline 178
	ldi R16,<L49
	ldi R17,>L49
	xcall _puts
L47:
	.dbline -2
L46:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r mode 20 c
	.dbend
	.dbfunc e ResetBlackfin _ResetBlackfin fV
;           mode -> R20
	.even
_ResetBlackfin::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 183
; }
; 
; // Blackfin Reset line is on Port D pin 3
; void ResetBlackfin(char mode)
; {
	.dbline 184
;  	RED_LED(ON);
	clr R16
	xcall _RED_LED
	.dbline 185
; 	PORTD &= 0xF7;
	in R24,0x12
	andi R24,247
	out 0x12,R24
	.dbline 186
; 	LongDelay(1);
	ldi R16,1
	ldi R17,0
	xcall _LongDelay
	.dbline 187
; 	PORTD |= 0x08;
	sbi 0x12,3
	.dbline 188
; 	RED_LED(OFF);
	ldi R16,1
	xcall _RED_LED
	.dbline 189
; 	if(mode!=QUIET)  puts("Blackfin Reset and enabled\n\r");
	cpi R20,1
	breq L51
X12:
	.dbline 189
	ldi R16,<L53
	ldi R17,>L53
	xcall _puts
L51:
	.dbline -2
L50:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r mode 20 c
	.dbend
	.dbfunc e BlinkGreen _BlinkGreen fV
;         period -> R10,R11
	.even
_BlinkGreen::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 193
; }
; 
; void BlinkGreen(int period)
; {
	.dbline 194
;  	 GREEN_LED(ON);
	clr R16
	xcall _GREEN_LED
	.dbline 195
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline 196
; 	 GREEN_LED(OFF);
	ldi R16,1
	xcall _GREEN_LED
	.dbline 197
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline -2
L54:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r period 10 I
	.dbend
	.dbfunc e BlinkRed _BlinkRed fV
;         period -> R10,R11
	.even
_BlinkRed::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 201
; }
; 
; void BlinkRed(int period)
; {
	.dbline 202
;  	 RED_LED(ON);
	clr R16
	xcall _RED_LED
	.dbline 203
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline 204
; 	 RED_LED(OFF);
	ldi R16,1
	xcall _RED_LED
	.dbline 205
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline -2
L55:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r period 10 I
	.dbend
	.dbfunc e BlackfinBootMode _BlackfinBootMode fV
;       bootmode -> R16
	.even
_BlackfinBootMode::
	.dbline -1
	.dbline 216
; }
; 
; // Select Blackfin boot mode - 00, 01, 10 or 11
; //
; // Blackfin Rev 0.3 silicon boots from Atmel SPI Flash as Boot Mode 3.
; // Note: Rev 0.2 silicon can not communicate with Atmel SPI Flash
; //       devices AT45DB041, AT45DB081 or ATDB45161 - must use SPI Flash
; //       that supports read command 0x03 such as the Microship 25LC640
; //       or ST M25P80.
; void BlackfinBootMode(unsigned char bootmode)
; {
	.dbline 218
;  	 //  Boot mode 0 - parallel flash
;  	 if(bootmode==BOOTMODE0) PORTD &= 0xCF;
	cpi R16,48
	brne L57
X13:
	.dbline 218
	in R24,0x12
	andi R24,207
	out 0x12,R24
	xjmp L58
L57:
	.dbline 221
; 	 
; 	 //  Blackfin SPI Slave to AVR
; 	 else if(bootmode==BOOTMODE2) {
	cpi R16,50
	brne L59
X14:
	.dbline 221
	.dbline 222
; 	     PORTD &= 0xDF;
	in R24,0x12
	andi R24,223
	out 0x12,R24
	.dbline 223
; 		 PORTD |= 0x10;
	sbi 0x12,4
	.dbline 224
; 		 }
	xjmp L60
L59:
	.dbline 228
; 	 //  Boot from SPI Slave Flash
; 	 //     Rev 0.2 silicon uses read command 0x03 
; 	 //     Rev 0.3 silicon attempts 0x03 read then switches to Atmel SPI
; 	 else if(bootmode==BOOTMODE3) PORTD |= 0x30;
	cpi R16,51
	brne L61
X15:
	.dbline 228
	in R24,0x12
	ori R24,48
	out 0x12,R24
L61:
L60:
L58:
	.dbline -2
L56:
	.dbline 0 ; func end
	ret
	.dbsym r bootmode 16 c
	.dbend
	.dbfunc e ResetBlackfinBootMode _ResetBlackfinBootMode fV
;       bootmode -> R10
	.even
_ResetBlackfinBootMode::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 233
; }
; 
; //  Fast blackfin boot mode setting function
; void ResetBlackfinBootMode(unsigned char bootmode)
; {
	.dbline 234
;  	 HaltBlackfin(QUIET);
	ldi R16,1
	xcall _HaltBlackfin
	.dbline 235
; 	 shortdelay(100);
	ldi R16,100
	ldi R17,0
	xcall _shortdelay
	.dbline 236
;  	 BlackfinBootMode(bootmode);
	mov R16,R10
	xcall _BlackfinBootMode
	.dbline 237
; 	 shortdelay(100);	 
	ldi R16,100
	ldi R17,0
	xcall _shortdelay
	.dbline -2
L63:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r bootmode 10 c
	.dbend
	.dbfunc e PrintHex _PrintHex fV
;         inbyte -> R10
	.even
_PrintHex::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 242
; 	 //ReleaseBlackfin(QUIET);
; }
; 
; void PrintHex(unsigned char inbyte)
; {
	.dbline 243
;  	 bytetohex(inbyte);
	mov R16,R10
	xcall _bytetohex
	.dbline 244
; 	 puts(hexbyte);
	ldi R16,<_hexbyte
	ldi R17,>_hexbyte
	xcall _puts
	.dbline -2
L64:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inbyte 10 c
	.dbend
	.dbfunc e PrintWordHex _PrintWordHex fV
;         inword -> R10,R11
	.even
_PrintWordHex::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 248
; }
; 
; void PrintWordHex(unsigned int inword)
; {
	.dbline 249
;  	 addresstohex(inword);
	movw R16,R10
	xcall _addresstohex
	.dbline 250
; 	 puts(hexaddress);
	ldi R16,<_hexaddress
	ldi R17,>_hexaddress
	xcall _puts
	.dbline -2
L65:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r inword 10 i
	.dbend
	.dbfunc e PrintLongHex _PrintLongHex fV
;    nonzerobyte -> R20
;        outbyte -> R14
;              i -> R10
;    tempaddress -> y+0
;        nobytes -> R12
;        address -> y+12
	.even
_PrintLongHex::
	xcall push_arg4
	xcall push_xgset30FC
	sbiw R28,4
	ldd R12,y+16
	.dbline -1
	.dbline 254
; }
; 
; void PrintLongHex(long address,unsigned char nobytes)
; {
	.dbline 258
;  	 unsigned char i,outbyte,nonzerobyte;
; 	 long tempaddress;
; 	 
; 	 nonzerobyte = NO;
	clr R20
	.dbline 259
; 	 for(i=0; i<nobytes; i++) {
	clr R10
	xjmp L70
L67:
	.dbline 259
	.dbline 260
; 	     tempaddress = address;
	ldd R2,y+12
	ldd R3,y+13
	ldd R4,y+14
	ldd R5,y+15
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	.dbline 261
; 		 tempaddress = tempaddress>>(((nobytes-1)*8)-8*i);
	mov R2,R10
	clr R3
	lsl R2
	rol R3
	lsl R2
	rol R3
	lsl R2
	rol R3
	mov R24,R12
	clr R25
	sbiw R24,1
	movw R4,R24
	lsl R4
	rol R5
	lsl R4
	rol R5
	lsl R4
	rol R5
	sub R4,R2
	sbc R5,R3
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R4
	xcall asr32
	std y+0,R16
	std y+1,R17
	std y+2,R18
	std y+3,R19
	.dbline 262
; 	     outbyte = tempaddress&0x00000000000000ff;
	ldi R24,255
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	mov R14,R2
	.dbline 263
; 		 if(outbyte==0) {
	tst R2
	brne L71
X16:
	.dbline 263
	.dbline 264
; 		 	if(nonzerobyte==YES) {
	cpi R20,1
	brne L72
X17:
	.dbline 264
	.dbline 265
; 		  	    bytetohex(outbyte);
	mov R16,R2
	xcall _bytetohex
	.dbline 266
; 	 	        puts(hexbyte); 
	ldi R16,<_hexbyte
	ldi R17,>_hexbyte
	xcall _puts
	.dbline 267
; 			    }
	.dbline 268
; 			}
	xjmp L72
L71:
	.dbline 269
; 		 else {
	.dbline 270
; 		  	 bytetohex(outbyte);
	mov R16,R14
	xcall _bytetohex
	.dbline 271
; 			 if((nonzerobyte==NO)&&(hexbyte[0]=='0')) putchar(hexbyte[1]);
	tst R20
	brne L75
X18:
	lds R24,_hexbyte
	cpi R24,48
	brne L75
X19:
	.dbline 271
	lds R16,_hexbyte+1
	xcall _putchar$device_specific$
	xjmp L76
L75:
	.dbline 272
; 	 	     else puts(hexbyte); 
	ldi R16,<_hexbyte
	ldi R17,>_hexbyte
	xcall _puts
L76:
	.dbline 273
; 		     nonzerobyte = YES;
	ldi R20,1
	.dbline 274
; 			 }
L72:
	.dbline 275
; 		 }
L68:
	.dbline 259
	inc R10
L70:
	.dbline 259
	cp R10,R12
	brsh X21
	xjmp L67
X21:
X20:
	.dbline -2
L66:
	.dbline 0 ; func end
	adiw R28,4
	xcall pop_xgset30FC
	adiw R28,4
	ret
	.dbsym r nonzerobyte 20 c
	.dbsym r outbyte 14 c
	.dbsym r i 10 c
	.dbsym l tempaddress 0 L
	.dbsym r nobytes 12 c
	.dbsym l address 12 L
	.dbend
	.dbfunc e EEPROMSetup _EEPROMSetup fV
	.even
_EEPROMSetup::
	.dbline -1
	.dbline 280
; }
; 
; //  TBD
; void EEPROMSetup(void)
; {
	.dbline -2
L78:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ReadAVRFlash _ReadAVRFlash fc
;          rbyte -> R10
;      flashbyte -> R10
;        address -> <dead>
	.even
_ReadAVRFlash::
	st -y,r17
	st -y,r16
	st -y,R10
	.dbline -1
	.dbline 286
;  	
; }
; 
; //  Access contents of AVR flash at specified address
; unsigned char ReadAVRFlash(int address)
; {
	.dbline 289
;  	unsigned char flashbyte,rbyte;
; 	
; 	flashbyte = 0;
	clr R10
	.dbline 290
;  	asm("mov r30,r16 \n"
	mov r30,r16 
	mov r31,r17 
	lpm r0,Z 
	mov R10,r0 
	
	.dbline 294
;        "mov r31,r17 \n"
; 	   "lpm r0,Z \n"
; 	   "mov %flashbyte,r0 \n"); 
; 	rbyte = flashbyte;  
	.dbline 295
; 	return(rbyte);                              
	mov R16,R10
	.dbline -2
L79:
	.dbline 0 ; func end
	ld R10,y+
	adiw R28,2
	ret
	.dbsym r rbyte 10 c
	.dbsym r flashbyte 10 c
	.dbsym l address 1 I
	.dbend
	.area lit(rom, con, rel)
L81:
	.byte 48,46,57,49,0
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
	.dbfunc e ProgramVersion _ProgramVersion fV
;        version -> y+0
	.even
_ProgramVersion::
	sbiw R28,5
	.dbline -1
	.dbline 301
; }
; 
; //  Output program version
; //   TBD - read from EEPROM
; void ProgramVersion(void)
; {
	.dbline 302
;       char version[5]="0.91";
	ldi R24,<L81
	ldi R25,>L81
	movw R30,R28
	ldi R16,5
	ldi R17,0
	st -y,R31
	st -y,R30
	st -y,R25
	st -y,R24
	xcall asgncblk
	.dbline 304
; 	  
; 	  putfs(progmessage);
	ldi R16,<_progmessage
	ldi R17,>_progmessage
	xcall _putfs
	.dbline 305
; 	  puts(version); 
	movw R16,R28
	xcall _puts
	.dbline 306
; 	  puts("\n\rF1-");
	ldi R16,<L82
	ldi R17,>L82
	xcall _puts
	.dbline 309
; 	  //printf("Flashtype0 = %x\n\r",flashtype0);
; 	  //printf("Flashtype1 = %x\n\r",flashtype1);
; 	  DisplayFlashType(flashtype0); puts(", F2-");
	lds R16,_flashtype0
	clr R17
	xcall _DisplayFlashType
	.dbline 309
	ldi R16,<L83
	ldi R17,>L83
	xcall _puts
	.dbline 310
; 	  DisplayFlashType(flashtype1); puts(", Cb-");
	lds R16,_flashtype1
	clr R17
	xcall _DisplayFlashType
	.dbline 310
	ldi R16,<L84
	ldi R17,>L84
	xcall _puts
	.dbline 311
; 	  DisplayCalibrationByte(); puts(", 32K");
	xcall _DisplayCalibrationByte
	.dbline 311
	ldi R16,<L85
	ldi R17,>L85
	xcall _puts
	.dbline 312
; 	  putCRLF();
	xcall _putCRLF
	.dbline -2
L80:
	.dbline 0 ; func end
	adiw R28,5
	ret
	.dbsym l version 0 A[5:5]c
	.dbend
	.dbfunc e signon _signon fV
	.even
_signon::
	.dbline -1
	.dbline 317
; }
; 
; //  Output sign on message loaded from Flash
; void signon()
; {
	.dbline 318
;     putCRLF(); putCRLF();
	xcall _putCRLF
	.dbline 318
	xcall _putCRLF
	.dbline 320
; 	//putfs(signon1);
; 	ProgramVersion();
	xcall _ProgramVersion
	.dbline 321
; 	putfs(signon2);	
	ldi R16,<_signon2
	ldi R17,>_signon2
	xcall _putfs
	.dbline 322
; 	putfs(signon3);
	ldi R16,<_signon3
	ldi R17,>_signon3
	xcall _putfs
	.dbline 323
; 	putfs(signon4);
	ldi R16,<_signon4
	ldi R17,>_signon4
	xcall _putfs
	.dbline 324
; 	putfs(signon5);
	ldi R16,<_signon5
	ldi R17,>_signon5
	xcall _putfs
	.dbline 325
; 	putfs(signon6);
	ldi R16,<_signon6
	ldi R17,>_signon6
	xcall _putfs
	.dbline 326
; 	putfs(signon63);
	ldi R16,<_signon63
	ldi R17,>_signon63
	xcall _putfs
	.dbline 327
; 	putfs(signon65);
	ldi R16,<_signon65
	ldi R17,>_signon65
	xcall _putfs
	.dbline 328
; 	putfs(signon82);
	ldi R16,<_signon82
	ldi R17,>_signon82
	xcall _putfs
	.dbline 329
; 	putfs(signon83);
	ldi R16,<_signon83
	ldi R17,>_signon83
	xcall _putfs
	.dbline 330
; 	putfs(signon85);
	ldi R16,<_signon85
	ldi R17,>_signon85
	xcall _putfs
	.dbline 331
; 	putfs(signon7);
	ldi R16,<_signon7
	ldi R17,>_signon7
	xcall _putfs
	.dbline 332
; 	putfs(signon8);
	ldi R16,<_signon8
	ldi R17,>_signon8
	xcall _putfs
	.dbline 333
; 	putfs(signon9);
	ldi R16,<_signon9
	ldi R17,>_signon9
	xcall _putfs
	.dbline 334
; 	putfs(crlfbar);
	ldi R16,<_crlfbar
	ldi R17,>_crlfbar
	xcall _putfs
	.dbline -2
L86:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayEEPROM _DisplayEEPROM fV
; bytesonlastline -> y+25
;       numlines -> y+23
;        linecnt -> y+21
;      tempvalue -> y+20
;       asciicnt -> y+19
;     newaddress -> y+17
;       crcvalue -> y+16
;          ascii -> y+0
;           byte -> R12
;              i -> R10
;       numbytes -> y+40
;        address -> y+36
	.even
_DisplayEEPROM::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,26
	.dbline -1
	.dbline 340
; }
; 
; 
; //  Display AVR EEPROM memory
; void DisplayEEPROM(long address,long numbytes)
; {
	.dbline 344
;  	 unsigned char i,byte,bytesonlastline,ascii[16],asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+19,R0
	clr R2
	clr R3
	std y+22,R3
	std y+21,R2
	.dbline 345
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 346
; 	 numlines = numbytes/bytesonline;
	movw R2,R24
	clr R4
	clr R5
	ldd R16,y+40
	ldd R17,y+41
	ldd R18,y+42
	ldd R19,y+43
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32s
	std y+24,R17
	std y+23,R16
	.dbline 347
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	xcall empy16s
	movw R2,R16
	clr R4
	clr R5
	ldd R6,y+40
	ldd R7,y+41
	ldd R8,y+42
	ldd R9,y+43
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+25,R6
	xjmp L89
L88:
	.dbline 348
; 	 while(linecnt<numlines) {
	.dbline 349
; 	     crcvalue = 0;
	clr R0
	std y+16,R0
	.dbline 350
; 	     putchar(':');
	ldi R16,58
	xcall _putchar$device_specific$
	.dbline 351
; 		 PrintHex(bytesonline);		 //  Output bytes on line
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 352
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	ldd R4,y+16
	clr R5
	add R4,R2
	adc R5,R3
	std y+16,R4
	.dbline 354
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+21
	ldd R19,y+22
	xcall empy16s
	movw R2,R16
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R6,y+36
	ldd R7,y+37
	ldd R8,y+38
	ldd R9,y+39
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	movw R2,R6
	std y+18,R3
	std y+17,R2
	.dbline 355
; 	     PrintWordHex(newaddress);
	movw R16,R6
	xcall _PrintWordHex
	.dbline 356
; 		 tempvalue = (newaddress&0xff00)>>8;
	ldd R24,y+17
	ldd R25,y+18
	andi R24,0
	mov R24,R25
	clr R25
	std y+20,R24
	.dbline 357
; 		 crcvalue += tempvalue;
	ldd R0,y+16
	add R0,R24
	std y+16,R0
	.dbline 358
; 		 tempvalue = newaddress&0x00ff;
	ldd R24,y+17
	ldd R25,y+18
	andi R25,0
	std y+20,R24
	.dbline 359
; 		 crcvalue += tempvalue;
	ldd R0,y+16
	add R0,R24
	std y+16,R0
	.dbline 361
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L91
	ldi R17,>L91
	xcall _puts
	.dbline 363
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L95
L92:
	.dbline 363
	.dbline 364
; 	         byte = EEPROMread(i+newaddress);
	mov R16,R10
	clr R17
	ldd R0,y+17
	ldd R1,y+18
	add R16,R0
	adc R17,R1
	xcall _EEPROMread
	mov R12,R16
	.dbline 365
; 			 ascii[asciicnt++] = byte;
	ldd R2,y+19
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+19,R24
	movw R24,R28
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R12
	.dbline 366
; 			 crcvalue += byte;
	ldd R0,y+16
	add R0,R16
	std y+16,R0
	.dbline 367
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 368
; 	         }
L93:
	.dbline 363
	inc R10
L95:
	.dbline 363
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L92
X22:
	.dbline 369
; 		 linecnt++;
	ldd R24,y+21
	ldd R25,y+22
	adiw R24,1
	std y+22,R25
	std y+21,R24
	.dbline 370
; 		 asciicnt = 0;
	clr R0
	std y+19,R0
	.dbline 372
; 		 // Output CRC
; 		 PrintHex((~crcvalue)+0x01);
	ldd R16,y+16
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 373
; 	     if(showascii==YES)  {
	lds R24,_showascii
	cpi R24,1
	brne L96
X23:
	.dbline 373
	.dbline 374
; 	         puts("  ");
	ldi R16,<L98
	ldi R17,>L98
	xcall _puts
	.dbline 375
; 		     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L102
L99:
	.dbline 375
	.dbline 376
; 		         if(ascii[i]>0x1F&&ascii[i]<0x80)  putchar(ascii[i]);
	movw R24,R28
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R14,z+0
	clr R15
	ldi R24,31
	cp R24,R14
	brsh L103
X24:
	mov R24,R14
	cpi R24,128
	brsh L103
X25:
	.dbline 376
	movw R24,R28
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putchar$device_specific$
	xjmp L104
L103:
	.dbline 377
; 			     else putchar('.');
	ldi R16,46
	xcall _putchar$device_specific$
L104:
	.dbline 378
; 			     }
L100:
	.dbline 375
	inc R10
L102:
	.dbline 375
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L99
X26:
	.dbline 379
; 			 }
L96:
	.dbline 380
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 381
; 		 }
L89:
	.dbline 348
	ldd R0,y+21
	ldd R1,y+22
	ldd R16,y+23
	ldd R17,y+24
	cp R0,R16
	cpc R1,R17
	brge X34
	xjmp L88
X34:
X27:
	.dbline 382
; 	 if(bytesonlastline) {
	ldd R0,y+25
	tst R0
	brne X35
	xjmp L105
X35:
X28:
	.dbline 382
	.dbline 383
; 	     crcvalue = 0;
	clr R0
	std y+16,R0
	.dbline 384
; 	     putchar(':');
	ldi R16,58
	xcall _putchar$device_specific$
	.dbline 386
; 		 //  Output bytes on line
; 		 PrintHex(bytesonlastline);
	ldd R16,y+25
	xcall _PrintHex
	.dbline 387
; 		 crcvalue += bytesonlastline;
	ldd R0,y+16
	ldd R16,y+25
	add R0,R16
	std y+16,R0
	.dbline 389
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+21
	ldd R19,y+22
	xcall empy16s
	movw R2,R16
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R6,y+36
	ldd R7,y+37
	ldd R8,y+38
	ldd R9,y+39
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	movw R2,R6
	std y+18,R3
	std y+17,R2
	.dbline 390
; 	     addresstohex(newaddress);
	movw R16,R6
	xcall _addresstohex
	.dbline 391
; 		 tempvalue = (newaddress&0xff00)>>8;
	ldd R24,y+17
	ldd R25,y+18
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	std y+20,R2
	.dbline 392
; 		 crcvalue += tempvalue;
	ldd R0,y+16
	add R0,R2
	std y+16,R0
	.dbline 393
; 		 tempvalue = newaddress&0x00ff;
	ldd R24,y+17
	ldd R25,y+18
	andi R25,0
	std y+20,R24
	.dbline 394
; 		 crcvalue += tempvalue;
	ldd R0,y+16
	add R0,R24
	std y+16,R0
	.dbline 395
; 	     puts(hexaddress);
	ldi R16,<_hexaddress
	ldi R17,>_hexaddress
	xcall _puts
	.dbline 397
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L91
	ldi R17,>L91
	xcall _puts
	.dbline 399
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L110
L107:
	.dbline 399
	.dbline 400
; 	         byte = EEPROMread(i+address+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+21
	ldd R19,y+22
	xcall empy16s
	movw R2,R16
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R6,y+36
	ldd R7,y+37
	ldd R8,y+38
	ldd R9,y+39
	mov R20,R10
	clr R21
	clr R22
	clr R23
	add R20,R6
	adc R21,R7
	adc R22,R8
	adc R23,R9
	add R20,R2
	adc R21,R3
	adc R22,R4
	adc R23,R5
	movw R16,R20
	xcall _EEPROMread
	mov R14,R16
	mov R12,R14
	.dbline 401
; 			 ascii[asciicnt++] = byte;
	ldd R14,y+19
	clr R15
	mov R24,R14
	subi R24,255    ; addi 1
	std y+19,R24
	movw R24,R28
	mov R30,R14
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R12
	.dbline 402
; 			 crcvalue += byte;
	ldd R0,y+16
	add R0,R16
	std y+16,R0
	.dbline 403
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 404
; 	         }
L108:
	.dbline 399
	inc R10
L110:
	.dbline 399
	ldd R0,y+25
	cp R10,R0
	brsh X36
	xjmp L107
X36:
X29:
	.dbline 406
; 		 // Output CRC
; 		 PrintHex((~crcvalue)+0x01);
	ldd R16,y+16
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 407
; 	     if(showascii==YES)  {
	lds R24,_showascii
	cpi R24,1
	brne L111
X30:
	.dbline 407
	.dbline 408
; 	         puts("  ");
	ldi R16,<L98
	ldi R17,>L98
	xcall _puts
	.dbline 409
; 		     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L116
L113:
	.dbline 409
	.dbline 410
; 		         if(ascii[i]>0x1F&&ascii[i]<0x80)  putchar(ascii[i]);
	movw R24,R28
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R14,z+0
	clr R15
	ldi R24,31
	cp R24,R14
	brsh L117
X31:
	mov R24,R14
	cpi R24,128
	brsh L117
X32:
	.dbline 410
	movw R24,R28
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putchar$device_specific$
	xjmp L118
L117:
	.dbline 411
; 			     else putchar('.');
	ldi R16,46
	xcall _putchar$device_specific$
L118:
	.dbline 412
; 			     }
L114:
	.dbline 409
	inc R10
L116:
	.dbline 409
	ldd R0,y+25
	cp R10,R0
	brlo L113
X33:
	.dbline 413
; 			 }
L111:
	.dbline 414
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 415
; 		 }
L105:
	.dbline 416
; 	 puts(":00000001FF\n\r");
	ldi R16,<L119
	ldi R17,>L119
	xcall _puts
	.dbline -2
L87:
	.dbline 0 ; func end
	adiw R28,26
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l bytesonlastline 25 c
	.dbsym l numlines 23 I
	.dbsym l linecnt 21 I
	.dbsym l tempvalue 20 c
	.dbsym l asciicnt 19 c
	.dbsym l newaddress 17 I
	.dbsym l crcvalue 16 c
	.dbsym l ascii 0 A[16:16]c
	.dbsym r byte 12 c
	.dbsym r i 10 c
	.dbsym l numbytes 40 L
	.dbsym l address 36 L
	.dbend
	.dbfunc e DisplayAVRFlash _DisplayAVRFlash fV
; bytesonlastline -> y+22
;       numlines -> y+20
;     newaddress -> R12,R13
;      tempvalue -> R10
;       asciicnt -> y+19
;        linecnt -> y+17
;       crcvalue -> y+16
;          ascii -> y+0
;           byte -> R12
;              i -> R10
;       numbytes -> y+37
;        address -> y+33
	.even
_DisplayAVRFlash::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,23
	.dbline -1
	.dbline 421
; }
; 
; //  Display P1 AVR Flash memory
; void DisplayAVRFlash(long address,long numbytes)
; {
	.dbline 425
;  	 unsigned char i,byte,bytesonlastline,ascii[16],asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+19,R0
	clr R2
	clr R3
	std y+18,R3
	std y+17,R2
	.dbline 426
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 427
; 	 numlines = numbytes/bytesonline;
	movw R2,R24
	clr R4
	clr R5
	ldd R16,y+37
	ldd R17,y+38
	ldd R18,y+39
	ldd R19,y+40
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32s
	std y+21,R17
	std y+20,R16
	.dbline 428
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	xcall empy16s
	movw R2,R16
	clr R4
	clr R5
	ldd R6,y+37
	ldd R7,y+38
	ldd R8,y+39
	ldd R9,y+40
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+22,R6
	xjmp L122
L121:
	.dbline 429
; 	 while(linecnt<numlines) {
	.dbline 430
; 	 	 crcvalue = 0;
	clr R0
	std y+16,R0
	.dbline 431
; 	     putchar(':');
	ldi R16,58
	xcall _putchar$device_specific$
	.dbline 433
; 		 //  Output bytes on line
; 		 PrintHex(bytesonline);
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 434
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	ldd R4,y+16
	clr R5
	add R4,R2
	adc R5,R3
	std y+16,R4
	.dbline 436
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+17
	ldd R19,y+18
	xcall empy16s
	movw R2,R16
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R6,y+33
	ldd R7,y+34
	ldd R8,y+35
	ldd R9,y+36
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	movw R12,R6
	.dbline 437
; 	     PrintWordHex(newaddress);
	movw R16,R6
	xcall _PrintWordHex
	.dbline 438
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R24,R12
	andi R24,0
	movw R10,R24
	mov R10,R11
	clr R11
	.dbline 439
; 		 crcvalue += tempvalue;
	ldd R0,y+16
	add R0,R10
	std y+16,R0
	.dbline 440
; 		 tempvalue = newaddress&0x00ff;
	movw R24,R12
	andi R25,0
	.dbline 441
; 		 crcvalue += tempvalue;
	add R0,R24
	std y+16,R0
	.dbline 443
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L91
	ldi R17,>L91
	xcall _puts
	.dbline 445
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L127
L124:
	.dbline 445
	.dbline 446
; 	         byte = ReadAVRFlash(address+i+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+17
	ldd R19,y+18
	xcall empy16s
	movw R2,R16
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	mov R6,R10
	clr R7
	clr R8
	clr R9
	ldd R20,y+33
	ldd R21,y+34
	ldd R22,y+35
	ldd R23,y+36
	add R20,R6
	adc R21,R7
	adc R22,R8
	adc R23,R9
	add R20,R2
	adc R21,R3
	adc R22,R4
	adc R23,R5
	movw R16,R20
	xcall _ReadAVRFlash
	mov R12,R16
	.dbline 447
; 			 ascii[asciicnt++] = byte;
	ldd R2,y+19
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+19,R24
	movw R24,R28
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R12
	.dbline 448
; 			 crcvalue += byte;
	ldd R0,y+16
	add R0,R16
	std y+16,R0
	.dbline 449
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 450
; 	         }
L125:
	.dbline 445
	inc R10
L127:
	.dbline 445
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brsh X49
	xjmp L124
X49:
X37:
	.dbline 451
; 		 linecnt++;
	ldd R24,y+17
	ldd R25,y+18
	adiw R24,1
	std y+18,R25
	std y+17,R24
	.dbline 452
; 		 asciicnt = 0;
	clr R0
	std y+19,R0
	.dbline 454
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	ldd R16,y+16
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 455
; 	     if(showascii==YES)  {
	lds R24,_showascii
	cpi R24,1
	brne L128
X38:
	.dbline 455
	.dbline 456
; 	         puts("  ");
	ldi R16,<L98
	ldi R17,>L98
	xcall _puts
	.dbline 457
; 		     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L133
L130:
	.dbline 457
	.dbline 458
; 		         if(ascii[i]>0x1F&&ascii[i]<0x80)  putchar(ascii[i]);
	movw R24,R28
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R14,z+0
	clr R15
	ldi R24,31
	cp R24,R14
	brsh L134
X39:
	mov R24,R14
	cpi R24,128
	brsh L134
X40:
	.dbline 458
	movw R24,R28
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putchar$device_specific$
	xjmp L135
L134:
	.dbline 459
; 			     else putchar('.');
	ldi R16,46
	xcall _putchar$device_specific$
L135:
	.dbline 460
; 			     }
L131:
	.dbline 457
	inc R10
L133:
	.dbline 457
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L130
X41:
	.dbline 461
; 			 }
L128:
	.dbline 462
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 463
; 		 }
L122:
	.dbline 429
	ldd R0,y+17
	ldd R1,y+18
	ldd R16,y+20
	ldd R17,y+21
	cp R0,R16
	cpc R1,R17
	brge X50
	xjmp L121
X50:
X42:
	.dbline 464
; 	 if(bytesonlastline) {
	ldd R0,y+22
	tst R0
	brne X51
	xjmp L136
X51:
X43:
	.dbline 464
	.dbline 465
; 	     crcvalue = 0;
	clr R0
	std y+16,R0
	.dbline 466
; 	     putchar(':');
	ldi R16,58
	xcall _putchar$device_specific$
	.dbline 468
; 		 //  Output bytes on line
; 		 PrintHex(bytesonlastline);
	ldd R16,y+22
	xcall _PrintHex
	.dbline 470
; 	     //  Output hex start address
; 	     PrintWordHex(address+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+17
	ldd R19,y+18
	xcall empy16s
	movw R2,R16
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R6,y+33
	ldd R7,y+34
	ldd R8,y+35
	ldd R9,y+36
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	movw R16,R6
	xcall _PrintWordHex
	.dbline 472
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L91
	ldi R17,>L91
	xcall _puts
	.dbline 474
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L141
L138:
	.dbline 474
	.dbline 475
; 	         byte = ReadAVRFlash(address+i+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+17
	ldd R19,y+18
	xcall empy16s
	movw R2,R16
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	mov R6,R10
	clr R7
	clr R8
	clr R9
	ldd R20,y+33
	ldd R21,y+34
	ldd R22,y+35
	ldd R23,y+36
	add R20,R6
	adc R21,R7
	adc R22,R8
	adc R23,R9
	add R20,R2
	adc R21,R3
	adc R22,R4
	adc R23,R5
	movw R16,R20
	xcall _ReadAVRFlash
	mov R14,R16
	mov R12,R14
	.dbline 476
; 			 ascii[asciicnt++] = byte;
	ldd R14,y+19
	clr R15
	mov R24,R14
	subi R24,255    ; addi 1
	std y+19,R24
	movw R24,R28
	mov R30,R14
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R12
	.dbline 477
; 			 crcvalue += byte;
	ldd R0,y+16
	add R0,R16
	std y+16,R0
	.dbline 478
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 479
; 	         }
L139:
	.dbline 474
	inc R10
L141:
	.dbline 474
	ldd R0,y+22
	cp R10,R0
	brsh X52
	xjmp L138
X52:
X44:
	.dbline 481
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	ldd R16,y+16
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 482
; 	     if(showascii==YES)  {
	lds R24,_showascii
	cpi R24,1
	brne L142
X45:
	.dbline 482
	.dbline 483
; 		 	 puts("  ");
	ldi R16,<L98
	ldi R17,>L98
	xcall _puts
	.dbline 484
; 		     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L147
L144:
	.dbline 484
	.dbline 485
; 		         if(ascii[i]>0x1F&&ascii[i]<0x80)  putchar(ascii[i]);
	movw R24,R28
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R14,z+0
	clr R15
	ldi R24,31
	cp R24,R14
	brsh L148
X46:
	mov R24,R14
	cpi R24,128
	brsh L148
X47:
	.dbline 485
	movw R24,R28
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putchar$device_specific$
	xjmp L149
L148:
	.dbline 486
; 			     else putchar('.');
	ldi R16,46
	xcall _putchar$device_specific$
L149:
	.dbline 487
; 			     }
L145:
	.dbline 484
	inc R10
L147:
	.dbline 484
	ldd R0,y+22
	cp R10,R0
	brlo L144
X48:
	.dbline 488
; 			 }
L142:
	.dbline 489
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 490
; 		 }
L136:
	.dbline 491
; 	 puts(":00000001FF\n\r");
	ldi R16,<L119
	ldi R17,>L119
	xcall _puts
	.dbline -2
L120:
	.dbline 0 ; func end
	adiw R28,23
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l bytesonlastline 22 c
	.dbsym l numlines 20 I
	.dbsym r newaddress 12 I
	.dbsym r tempvalue 10 c
	.dbsym l asciicnt 19 c
	.dbsym l linecnt 17 I
	.dbsym l crcvalue 16 c
	.dbsym l ascii 0 A[16:16]c
	.dbsym r byte 12 c
	.dbsym r i 10 c
	.dbsym l numbytes 37 L
	.dbsym l address 33 L
	.dbend
	.dbfunc e hextobyte _hextobyte fc
;         inbyte -> R16
	.even
_hextobyte::
	xcall push_xgsetF000
	.dbline -1
	.dbline 495
; }
; 
; unsigned char hextobyte(unsigned char inbyte)
; {
	.dbline 496
; 	 if((inbyte >= 'A')&(inbyte<='F')) return (inbyte - 'A' + 10);
	cpi R16,65
	brlo L153
X53:
	ldi R22,1
	ldi R23,0
	xjmp L154
L153:
	clr R22
	clr R23
L154:
	ldi R24,70
	cp R24,R16
	brlo L155
X54:
	ldi R20,1
	ldi R21,0
	xjmp L156
L155:
	clr R20
	clr R21
L156:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X55
	tst R3
	breq L151
X55:
	.dbline 496
	mov R24,R16
	subi R24,65
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L150
L151:
	.dbline 497
; 	 if((inbyte >= 'a')&(inbyte<='f')) return (inbyte - 'a' + 10);
	cpi R16,97
	brlo L159
X56:
	ldi R22,1
	ldi R23,0
	xjmp L160
L159:
	clr R22
	clr R23
L160:
	ldi R24,102
	cp R24,R16
	brlo L161
X57:
	ldi R20,1
	ldi R21,0
	xjmp L162
L161:
	clr R20
	clr R21
L162:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X58
	tst R3
	breq L157
X58:
	.dbline 497
	mov R24,R16
	subi R24,97
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L150
L157:
	.dbline 498
; 	 else return (inbyte - '0');
	subi R16,48
	.dbline -2
L150:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 16 c
	.dbend
	.dbfunc e ScanHex _ScanHex fL
;        address -> y+0
;            len -> R12
;              i -> R10
	.even
_ScanHex::
	xcall push_xgsetF0FC
	sbiw R28,4
	.dbline -1
	.dbline 504
; }
; 
; // Read in a hex string and convert to int or long
; //  TBD - add long support for serial flash support
; long  ScanHex()
; {
	.dbline 506
;  	 long  address;
;  	 char i=0,len;
	clr R10
	.dbline 508
; 	 
; 	 address = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+0,R20
	std y+1,R21
	std y+2,R22
	std y+3,R23
	.dbline 509
; 	 putchar((instrg[0]=getchar()));
	xcall _getchar$device_specific$
	sts _instrg,R16
	xcall _putchar$device_specific$
	xjmp L165
L164:
	.dbline 510
;  	 while((instrg[i]!=CR)&&(instrg[i]!=' ')) {
	.dbline 511
; 	 	 i++;
	inc R10
	.dbline 512
; 	     putchar((instrg[i]=getchar()));
	xcall _getchar$device_specific$
	movw R12,R16
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R12
	xcall _putchar$device_specific$
	.dbline 513
; 		 }
L165:
	.dbline 510
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R12,z+0
	clr R13
	mov R24,R12
	cpi R24,13
	breq L167
X59:
	cpi R24,32
	brne L164
X60:
L167:
	.dbline 514
; 	 instrg[i] = 0;
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
	.dbline 515
; 	 len = strlen(instrg);
	ldi R16,<_instrg
	ldi R17,>_instrg
	xcall _strlen
	movw R12,R16
	.dbline 516
; 	 address = hextobyte(instrg[len-1]);
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	mov R30,R12
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R2,R14
	clr R3
	clr R4
	clr R5
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	.dbline 517
; 	 i = 1;
	clr R10
	inc R10
	xjmp L170
L169:
	.dbline 518
; 	 while(i<len) {
	.dbline 519
; 	     if(i==1) address += ((long) hextobyte(instrg[len-i-1])*16);
	mov R24,R10
	cpi R24,1
	brne L172
X61:
	.dbline 519
	mov R2,R24
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R2,R14
	clr R3
	clr R4
	clr R5
	ldi R20,16
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
L172:
	.dbline 520
; 	     if(i==2) address += ((long) hextobyte(instrg[len-i-1])*256);
	mov R24,R10
	cpi R24,2
	brne L175
X62:
	.dbline 520
	mov R2,R24
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R2,R14
	clr R3
	clr R4
	clr R5
	ldi R20,0
	ldi R21,1
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
L175:
	.dbline 521
; 	     if(i==3) address += ((long) hextobyte(instrg[len-i-1])*4096);
	mov R24,R10
	cpi R24,3
	brne L178
X63:
	.dbline 521
	mov R2,R24
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R2,R14
	clr R3
	clr R4
	clr R5
	ldi R20,0
	ldi R21,16
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
L178:
	.dbline 522
; 	     if(i==4) address += ((long) hextobyte(instrg[len-i-1])*65536);
	mov R24,R10
	cpi R24,4
	brne L181
X64:
	.dbline 522
	mov R2,R24
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R2,R14
	clr R3
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
L181:
	.dbline 523
; 	     if(i==5) address += ((long) hextobyte(instrg[len-i-1])*1048576);
	mov R24,R10
	cpi R24,5
	brne L184
X65:
	.dbline 523
	mov R2,R24
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R2,R14
	clr R3
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,16
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
L184:
	.dbline 524
; 	     if(i==6) address += ((long) hextobyte(instrg[len-i-1])*16777216);
	mov R24,R10
	cpi R24,6
	brne L187
X66:
	.dbline 524
	mov R2,R24
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R2,R14
	clr R3
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,1
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
L187:
	.dbline 525
; 		 i++;
	inc R10
	.dbline 526
; 		 }
L170:
	.dbline 518
	cp R10,R12
	brsh X68
	xjmp L169
X68:
X67:
	.dbline 527
; 	 return address;
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	.dbline -2
L163:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF0FC
	.dbsym l address 0 L
	.dbsym r len 12 c
	.dbsym r i 10 c
	.dbend
	.dbfunc e GetByteHex _GetByteHex fc
;           strg -> y+0
	.even
_GetByteHex::
	st -y,R10
	st -y,R11
	sbiw R28,3
	.dbline -1
	.dbline 531
; }
; 
; unsigned char GetByteHex()
; {
	.dbline 534
;  	 char strg[3];
; 	 
; 	 putchar((strg[0]=getchar()));
	xcall _getchar$device_specific$
	std y+0,R16
	xcall _putchar$device_specific$
	.dbline 535
; 	 putchar((strg[1]=getchar()));
	xcall _getchar$device_specific$
	movw R10,R16
	std y+1,R10
	xcall _putchar$device_specific$
	.dbline 536
; 	 strg[2] = 0;
	clr R2
	std y+2,R2
	.dbline 537
; 	 return converttohex(strg);
	movw R16,R28
	xcall _converttohex
	mov R10,R16
	.dbline -2
L190:
	.dbline 0 ; func end
	adiw R28,3
	ld R11,y+
	ld R10,y+
	ret
	.dbsym l strg 0 A[3:3]c
	.dbend
	.dbfunc e DisplayMemory _DisplayMemory fV
;         length -> y+9
;        address -> y+5
;         inchar -> R10
	.even
_DisplayMemory::
	xcall push_xgset300C
	sbiw R28,13
	.dbline -1
	.dbline 541
; }
; 
; void DisplayMemory(void)
; {
	.dbline 545
;     unsigned char inchar;
; 	long address, length;
; 	
; 	inchar = getchar();
	xcall _getchar$device_specific$
	mov R10,R16
	.dbline 546
; 	putchar(inchar);
	xcall _putchar$device_specific$
	.dbline 547
; 	putCRLF();
	xcall _putCRLF
	.dbline 548
; 	putfs(displaymessage1);
	ldi R16,<_displaymessage1
	ldi R17,>_displaymessage1
	xcall _putfs
	.dbline 549
; 	address = ScanHex(); 
	xcall _ScanHex
	std y+5,R16
	std y+6,R17
	std y+7,R18
	std y+8,R19
	.dbline 550
; 	length = ScanHex();
	xcall _ScanHex
	std y+9,R16
	std y+10,R17
	std y+11,R18
	std y+12,R19
	.dbline 551
; 	putCRLF();
	xcall _putCRLF
	.dbline 552
; 	switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	breq L198
X69:
	cpi R20,66
	ldi R30,0
	cpc R21,R30
	brne X78
	xjmp L200
X78:
X70:
	cpi R20,69
	ldi R30,0
	cpc R21,R30
	breq L197
X71:
	cpi R20,70
	ldi R30,0
	cpc R21,R30
	breq L199
X72:
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	brge X79
	xjmp L194
X79:
X73:
L201:
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L198
X74:
	cpi R20,98
	ldi R30,0
	cpc R21,R30
	brne X80
	xjmp L200
X80:
X75:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L197
X76:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L199
X77:
	xjmp L194
L197:
	.dbline 554
; 	    case 'e': case 'E':
; 			DisplayEEPROM(address,length);
	ldd R2,y+9
	ldd R3,y+10
	ldd R4,y+11
	ldd R5,y+12
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R16,y+5
	ldd R17,y+6
	ldd R18,y+7
	ldd R19,y+8
	xcall _DisplayEEPROM
	.dbline 555
; 		    break;
	xjmp L195
L198:
	.dbline 557
; 		case 'a': case 'A':
; 		    DisplayAVRFlash(address,length);
	ldd R2,y+9
	ldd R3,y+10
	ldd R4,y+11
	ldd R5,y+12
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R16,y+5
	ldd R17,y+6
	ldd R18,y+7
	ldd R19,y+8
	xcall _DisplayAVRFlash
	.dbline 558
; 		    break;
	xjmp L195
L199:
	.dbline 565
; 		//  In order to access Blackfin Flash the AVR must ask the Blackfin
; 		//  to release control of the SPI lines.  This is simulated in Rev A
; 		//  boards by resetting the Blackfin (which should release the SPI lines)
; 		//  On completion the AVR SPI lines are released.
; 		case 'f': case 'F':
; 			//  Reset Blackfin to boot mode 0 - release reset
; 			ResetBlackfinBootMode(BOOTMODE0);
	ldi R16,48
	xcall _ResetBlackfinBootMode
	.dbline 567
; 
; 			Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 568
; 		    DisplaySerialFlash(address,length,READCONTINUOUS);			
	ldi R24,1
	std y+4,R24
	ldd R2,y+9
	ldd R3,y+10
	ldd R4,y+11
	ldd R5,y+12
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R16,y+5
	ldd R17,y+6
	ldd R18,y+7
	ldd R19,y+8
	xcall _DisplaySerialFlash
	.dbline 569
; 			Release_SPI();
	xcall _Release_SPI
	.dbline 572
; 			
; 			//  Reset Blackfin to boot mode 3
; 			ResetBlackfinBootMode(BOOTMODE3);
	ldi R16,51
	xcall _ResetBlackfinBootMode
	.dbline 573
; 			ReleaseBlackfin(QUIET);
	ldi R16,1
	xcall _ReleaseBlackfin
	.dbline 574
; 		    break;
	xjmp L195
L200:
	.dbline 577
; 		case 'b': case 'B':
; 			//  Reset Blackfin to boot mode 0 - release reset
; 			ResetBlackfinBootMode(BOOTMODE0);
	ldi R16,48
	xcall _ResetBlackfinBootMode
	.dbline 579
; 
; 			Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 580
; 		    DisplaySerialFlash(address,length,READBUFFER);				
	ldi R24,2
	std y+4,R24
	ldd R2,y+9
	ldd R3,y+10
	ldd R4,y+11
	ldd R5,y+12
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R16,y+5
	ldd R17,y+6
	ldd R18,y+7
	ldd R19,y+8
	xcall _DisplaySerialFlash
	.dbline 581
; 			Release_SPI();
	xcall _Release_SPI
	.dbline 584
; 			
; 			//  Reset Blackfin to boot mode 3
; 			ResetBlackfinBootMode(BOOTMODE3);
	ldi R16,51
	xcall _ResetBlackfinBootMode
	.dbline 585
; 		    break;
	xjmp L195
L194:
	.dbline 587
; 		default:
; 		    putfs(displaymessage33);
	ldi R16,<_displaymessage33
	ldi R17,>_displaymessage33
	xcall _putfs
	.dbline 588
; 		    break;
L195:
	.dbline -2
L193:
	.dbline 0 ; func end
	adiw R28,13
	xjmp pop_xgset300C
	.dbsym l length 9 L
	.dbsym l address 5 L
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e checkcrc _checkcrc fI
;        crcbyte -> <dead>
;        cycbyte -> <dead>
	.even
_checkcrc::
	st -y,r17
	st -y,r16
	.dbline -1
	.dbline 595
; 	    }
; }
; 
; 
; // Check intelbinary CRC 
; int checkcrc(unsigned char cycbyte)
; {
	.dbline 598
;  	unsigned char crcbyte;
; 	
; 	GetByteHex();
	xcall _GetByteHex
	.dbline 599
;  	return 1;
	ldi R16,1
	ldi R17,0
	.dbline -2
L202:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbsym l crcbyte 1 c
	.dbsym l cycbyte 0 c
	.dbend
	.dbfunc e DecodeIntelHex _DecodeIntelHex fI
;    addressbyte -> <dead>
;           strg -> y+0
;         inbyte -> R10
;              i -> R20,R21
	.even
_DecodeIntelHex::
	xcall push_xgset303C
	sbiw R28,8
	.dbline -1
	.dbline 614
; }
; 
; // Convert Intel Hex ASCII string to binary
; //
; // :10 0100 00 0C948F0D0C941D0E0C941D0E0C941D0E 38
; // :1001000000C941D0E0C941D0E0C944E590C941D0E38
; // This routine decodes a line of Intel Hex.  Other 
; // routines write the data to either AVR Flash, external Flash
; // or AVR EEPROM
; //
; //   :02 0000 04 0000FA  - IntelHex32 extended address record
; // 
; //  TBD - check crc byte - drop record if incorrect
; int DecodeIntelHex(void)
; {
	.dbline 618
;  	 unsigned char strg[8],addressbyte,inbyte;
; 	 int i;
; 	 
; 	 putchar(':');
	ldi R16,58
	xcall _putchar$device_specific$
	.dbline 620
; 	 // Convert count of bytes on line
; 	 bytesonline = GetByteHex();
	xcall _GetByteHex
	mov R2,R16
	clr R3
	sts _bytesonline+1,R3
	sts _bytesonline,R2
	.dbline 624
; 	 
; 	 // Convert address to binary - ignore filler byte
; 	 // Typical Intel Hex consists of 4 ASCII characters
; 	 inteladdress = GetByteHex()*256;
	xcall _GetByteHex
	mov R18,R16
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	sts _inteladdress+1,R17
	sts _inteladdress,R16
	.dbline 625
; 	 inteladdress += GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	mov R2,R12
	clr R3
	lds R4,_inteladdress
	lds R5,_inteladdress+1
	add R4,R2
	adc R5,R3
	sts _inteladdress+1,R5
	sts _inteladdress,R4
	.dbline 628
; 	 
; 	 // Read record type byte (2 characters)
; 	 intelrecordcommand = GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	sts _intelrecordcommand,R12
	.dbline 630
; 	 
; 	 if(intelrecordcommand==0x04) {
	cpi R16,4
	brne L204
X81:
	.dbline 630
	.dbline 631
; 	     intelextendedaddress = GetByteHex()*256;
	xcall _GetByteHex
	mov R12,R16
	mov R18,R12
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	sts _intelextendedaddress+1,R17
	sts _intelextendedaddress,R16
	.dbline 632
; 		 intelextendedaddress += GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	mov R2,R12
	clr R3
	lds R4,_intelextendedaddress
	lds R5,_intelextendedaddress+1
	add R4,R2
	adc R5,R3
	sts _intelextendedaddress+1,R5
	sts _intelextendedaddress,R4
	.dbline 633
; 		 }
	xjmp L205
L204:
	.dbline 634
; 	 else  {
	.dbline 636
; 	     // Convert all data to binary
; 	     for(i=0; i<bytesonline; i++) {
	clr R20
	clr R21
	xjmp L209
L206:
	.dbline 636
	.dbline 637
; 		     inbyte = GetByteHex(strg);
	movw R16,R28
	xcall _GetByteHex
	mov R12,R16
	mov R10,R12
	.dbline 638
; 		     intelbinary[i] = inbyte;
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	movw R30,R20
	add R30,R24
	adc R31,R25
	std z+0,R10
	.dbline 639
; 	 	     }
L207:
	.dbline 636
	subi R20,255  ; offset = 1
	sbci R21,255
L209:
	.dbline 636
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	cp R20,R2
	cpc R21,R3
	brlo L206
X82:
	.dbline 640
; 		 }
L205:
	.dbline 643
; 		 
; 	// Check CRC - todo
; 	if(checkcrc(inbyte)) return 1;
	mov R16,R10
	xcall _checkcrc
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L210
X83:
	.dbline 643
	ldi R16,1
	ldi R17,0
	xjmp L203
L210:
	.dbline 644
; 	else return -1;
	ldi R16,-1
	ldi R17,-1
	.dbline -2
L203:
	.dbline 0 ; func end
	adiw R28,8
	xjmp pop_xgset303C
	.dbsym l addressbyte 1 c
	.dbsym l strg 0 A[8:8]c
	.dbsym r inbyte 10 c
	.dbsym r i 20 I
	.dbend
	.dbfunc e RTEEPROMReady _RTEEPROMReady fc
	.even
_RTEEPROMReady::
	.dbline -1
	.dbline 650
; }
; 
; // function to test if the EEPROM is ready for a read or write operation
; // returns non zero if ready, zero if not ready 
; unsigned char RTEEPROMReady(void)
; {
	.dbline 651
; 	return !(EECR & 0x02);
	sbic 0x1c,1
	rjmp L213
X84:
	ldi R16,1
	ldi R17,0
	xjmp L214
L213:
	clr R16
	clr R17
L214:
	.dbline -2
L212:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ProgramEEPROM _ProgramEEPROM fV
;              i -> R10
	.even
_ProgramEEPROM::
	st -y,R10
	.dbline -1
	.dbline 656
; }
; 
; //  Write decoded Intel hex to EEPROM
; void ProgramEEPROM(void)
; {
	.dbline 659
;      unsigned char i;
; 	 
; 	 for(i=0; i<bytesonline; i++)  EEPROMWrite(inteladdress+i,intelbinary[i]);
	clr R10
	xjmp L219
L216:
	.dbline 659
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	mov R2,R10
	clr R3
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	add R16,R2
	adc R17,R3
	xcall _EEPROMWrite
L217:
	.dbline 659
	inc R10
L219:
	.dbline 659
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L216
X85:
	.dbline -2
L215:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r i 10 c
	.dbend
	.dbfunc e ProgramAVRFlash _ProgramAVRFlash fV
;         inchar -> R10
	.even
_ProgramAVRFlash::
	st -y,R10
	.dbline -1
	.dbline 664
; }
; 
; //  TBD - AVR Flash hold program so programming AVR flash may overwrite program
; void ProgramAVRFlash(void)
; {
	xjmp L222
L221:
	.dbline 667
;  	 char inchar;
; 	 
;  	 while((inchar=getchar())!=CR) putchar(inchar);
	mov R16,R10
	xcall _putchar$device_specific$
L222:
	.dbline 667
	xcall _getchar$device_specific$
	mov R10,R16
	cpi R16,13
	brne L221
X86:
	.dbline 668
; 	 putCRLF(); putchar('-');
	xcall _putCRLF
	.dbline 668
	ldi R16,45
	xcall _putchar$device_specific$
	.dbline -2
L220:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e CleanUpFlashState _CleanUpFlashState fV
	.even
_CleanUpFlashState::
	st -y,R10
	st -y,R11
	sbiw R28,1
	.dbline -1
	.dbline 672
; }
; 
; void CleanUpFlashState()
; {
	.dbline 673
; 	if(flashdatainbuffer==YES)  {
	lds R24,_flashdatainbuffer
	cpi R24,1
	brne L225
X87:
	.dbline 673
	.dbline 676
; 	    //inteladdress = lastaddress;
; 		//puts("clean ");  PrintLongHex(lastaddress,6);
; 	    ProgramBuffertoPageErase(lastaddress,1);
	ldi R24,1
	std y+0,R24
	lds R18,_lastaddress+2
	lds R19,_lastaddress+2+1
	lds R16,_lastaddress
	lds R17,_lastaddress+1
	xcall _ProgramBuffertoPageErase
	.dbline 677
; 		WaitForFlashFree(1);
	ldi R16,1
	ldi R17,0
	xcall _WaitForFlashFree
	.dbline 678
; 		intelextendedaddress = 0;
	clr R2
	clr R3
	sts _intelextendedaddress+1,R3
	sts _intelextendedaddress,R2
	.dbline 679
; 		}
L225:
	.dbline 680
; 	if(flashprogrammingactive==YES)  {
	lds R24,_flashprogrammingactive
	cpi R24,1
	brne L227
X88:
	.dbline 680
	.dbline 681
; 		Release_SPI();
	xcall _Release_SPI
	.dbline 682
; 		flashprogrammingactive = NO;
	clr R2
	sts _flashprogrammingactive,R2
	.dbline 683
; 		flashpageloaded = NO;
	sts _flashpageloaded,R2
	.dbline 684
; 		flashpageboundarytraversed = NO;
	sts _flashpageboundarytraversed,R2
	.dbline 685
; 		flashdatainbuffer = NO;
	sts _flashdatainbuffer,R2
	.dbline 686
; 		}
L227:
	.dbline 688
; 	//  Restore Blackfin to normal operation - boot mode 3
; 	ResetBlackfinBootMode(BOOTMODE3);
	ldi R16,51
	xcall _ResetBlackfinBootMode
	.dbline 689
; 	ReleaseBlackfin(QUIET);
	ldi R16,1
	xcall _ReleaseBlackfin
	.dbline -2
L224:
	.dbline 0 ; func end
	adiw R28,1
	ld R11,y+
	ld R10,y+
	ret
	.dbend
	.dbfunc e ProgramMemory _ProgramMemory fV
	.even
_ProgramMemory::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 701
; }
; 
; //  Main memory programming selection function
; //  Program EEPROM, AVR Flash or SPI Flash.
; //  Three IntelHex32 Records 0x00, 0x01 and 0x04 are processed by this
; //  routine.  0x00 is a data record, 0x01 is End of File record and 
; //  0x04 is extended address record
; //
; //  TBD - no intel record time out - reset defaults if no intel 
; //        records received after 3 seconds
; void ProgramMemory(void)
; {
	.dbline 702
;  	DecodeIntelHex();
	xcall _DecodeIntelHex
	.dbline 703
; 	switch (programmode) {
	lds R20,_programmode
	clr R21
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L236
X89:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L233
X90:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L239
X91:
	xjmp L230
L233:
	.dbline 705
; 	    case LEEPROM:
; 			if(intelrecordcommand==0) ProgramEEPROM();
	lds R2,_intelrecordcommand
	tst R2
	brne L231
X92:
	.dbline 705
	xcall _ProgramEEPROM
	.dbline 706
; 			break;
	xjmp L231
L236:
	.dbline 708
; 		case LAVRFLASH:
; 		    if(intelrecordcommand==0) ProgramAVRFlash();
	lds R2,_intelrecordcommand
	tst R2
	brne L231
X93:
	.dbline 708
	xcall _ProgramAVRFlash
	.dbline 709
; 			break;
	xjmp L231
L239:
	.dbline 722
; 			
; 		//  To access Blackfin Flash the Blackfin must not have control 
; 		//  of the shared SPI lines and the Blackfin reset line must not
; 		//  be active.  The Blackfin releases control of the SPI lines under 
; 		//  software control or by being forced to boot mode 0.  If the Blackfin
; 		//  is reset to boot mode 3 it will attempt to load a program from 
; 		//  serial flash preventing the AVR from accessing the serial flash.
; 		
; 		//  This implementation forces the Blackfin to reboot.
; 		//  Cooperative flash access still TBD
; 		case LFLASH:
; 		    // Data record			
; 			if(intelrecordcommand==0) {
	lds R2,_intelrecordcommand
	tst R2
	brne L240
X94:
	.dbline 722
	.dbline 723
; 			    flashcountdown = 3000;  // 3 second no new Hex record timeout
	ldi R24,3000
	ldi R25,11
	sts _flashcountdown+1,R25
	sts _flashcountdown,R24
	.dbline 725
; 			    //  See is SPI Master is active - set active if not
; 			    if(flashprogrammingactive==NO) {
	lds R2,_flashprogrammingactive
	tst R2
	brne L242
X95:
	.dbline 725
	.dbline 727
; 				    // Reset Blackfin to boot mode 0  forcing SPI lines release
; 			        ResetBlackfinBootMode(BOOTMODE0);
	ldi R16,48
	xcall _ResetBlackfinBootMode
	.dbline 728
; 				    Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 729
; 					}
L242:
	.dbline 731
; 					
; 		        ProgramSerialFlash();		
	xcall _ProgramSerialFlash
	.dbline 732
; 				}
	xjmp L231
L240:
	.dbline 734
; 			// Extended address record
; 			else if(intelrecordcommand==0x04) ; // nothing to do
	lds R24,_intelrecordcommand
	cpi R24,4
	brne L244
X96:
	.dbline 734
	xjmp L231
L244:
	.dbline 737
; 			
; 			// End of File record - reset all variables
; 			else if(intelrecordcommand==0x01) CleanUpFlashState();
	lds R24,_intelrecordcommand
	cpi R24,1
	brne L231
X97:
	.dbline 737
	xcall _CleanUpFlashState
	.dbline 738
; 			break;
L230:
L231:
	.dbline -2
L229:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbend
	.dbfunc e LoadMemory _LoadMemory fV
;         inchar -> R10
	.even
_LoadMemory::
	xcall push_xgset300C
	.dbline -1
	.dbline 745
; 		} 
; }
; 
; //  Set default memory programming mode
; //  Subsequent Intel Hex dumps will load to the specific memory
; void LoadMemory(void)
; {
	.dbline 748
;     unsigned char inchar;
; 	
; 	inchar = getchar();
	xcall _getchar$device_specific$
	mov R10,R16
	.dbline 749
; 	putchar(inchar);
	xcall _putchar$device_specific$
	.dbline 750
; 	switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	breq L254
X98:
	cpi R20,69
	ldi R30,0
	cpc R21,R30
	breq L252
X99:
	cpi R20,70
	ldi R30,0
	cpc R21,R30
	breq L253
X100:
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	brlt L250
X101:
L255:
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L254
X102:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L252
X103:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L253
X104:
	xjmp L250
L252:
	.dbline 752
; 	    case 'e': case 'E':
; 			programmode = LEEPROM;
	ldi R24,101
	sts _programmode,R24
	.dbline 753
; 			putfs(loadmessage1);
	ldi R16,<_loadmessage1
	ldi R17,>_loadmessage1
	xcall _putfs
	.dbline 754
; 		    break;
	xjmp L250
L253:
	.dbline 756
; 		case 'f': case 'F':
; 			programmode = LFLASH;
	ldi R24,102
	sts _programmode,R24
	.dbline 757
; 			putfs(loadmessage2);
	ldi R16,<_loadmessage2
	ldi R17,>_loadmessage2
	xcall _putfs
	.dbline 758
; 		    break;
	xjmp L250
L254:
	.dbline 760
; 		case 'a': case 'A':
; 			programmode = LAVRFLASH;
	ldi R24,97
	sts _programmode,R24
	.dbline 761
; 		    putfs(loadmessage3);
	ldi R16,<_loadmessage3
	ldi R17,>_loadmessage3
	xcall _putfs
	.dbline 762
; 		    break;
	.dbline 764
; 		default:
; 		   break;
L250:
	.dbline -2
L248:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e DisplayFlashType _DisplayFlashType fV
;      flashtype -> R20
	.even
_DisplayFlashType::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 769
; 	    }
; }
; 
; void DisplayFlashType(unsigned char flashtype)
; {
	.dbline 770
; 	 if(flashtype==AT45DB041ID) putfs(signon121);
	cpi R20,28
	brne L257
X105:
	.dbline 770
	ldi R16,<_signon121
	ldi R17,>_signon121
	xcall _putfs
	xjmp L258
L257:
	.dbline 771
;      else if(flashtype==AT45DB081ID) putfs(signon122);  
	cpi R20,36
	brne L259
X106:
	.dbline 771
	ldi R16,<_signon122
	ldi R17,>_signon122
	xcall _putfs
	xjmp L260
L259:
	.dbline 772
;      else if(flashtype==AT45DB161ID) putfs(signon123);  
	cpi R20,44
	brne L261
X107:
	.dbline 772
	ldi R16,<_signon123
	ldi R17,>_signon123
	xcall _putfs
	xjmp L262
L261:
	.dbline 773
;      else if(flashtype==AT45DB321ID) putfs(signon124);  
	cpi R20,52
	brne L263
X108:
	.dbline 773
	ldi R16,<_signon124
	ldi R17,>_signon124
	xcall _putfs
	xjmp L264
L263:
	.dbline 774
;      else if(flashtype==AT45DB642ID) putfs(signon125); 
	cpi R20,60
	brne L265
X109:
	.dbline 774
	ldi R16,<_signon125
	ldi R17,>_signon125
	xcall _putfs
	xjmp L266
L265:
	.dbline 775
; 	 else putfs(signon126); 
	ldi R16,<_signon126
	ldi R17,>_signon126
	xcall _putfs
L266:
L264:
L262:
L260:
L258:
	.dbline -2
L256:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r flashtype 20 c
	.dbend
	.dbfunc e DisplayCalibrationByte _DisplayCalibrationByte fV
	.even
_DisplayCalibrationByte::
	.dbline -1
	.dbline 779
; }
; 
; void DisplayCalibrationByte()
; {
	.dbline 780
;  	 bytetohex(OSCCAL);
	in R16,0x31
	xcall _bytetohex
	.dbline 781
; 	 puts(hexbyte);
	ldi R16,<_hexbyte
	ldi R17,>_hexbyte
	xcall _puts
	.dbline -2
L267:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e AnalogCh _AnalogCh fI
;           high -> R12
;            low -> R10
;             ch -> R20,R21
	.even
_AnalogCh::
	xcall push_xgset303C
	movw R20,R16
	.dbline -1
	.dbline 787
; }
; 
; //  Read selected analog channel - wait until it completes
; //   TBD - background interrupt process
; int AnalogCh(int ch)
; {
	.dbline 791
;  	unsigned char low,high;
; 	
; 	
; 	if(ch==0) ADMUX = 0x40;  // Select AVCC, ch 0
	cpi R20,0
	cpc R20,R21
	brne L269
X110:
	.dbline 791
	ldi R24,64
	out 0x7,R24
	xjmp L270
L269:
	.dbline 792
; 	else if(ch==1) ADMUX = 0x41; // Select AVCC, ch 0
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brne L271
X111:
	.dbline 792
	ldi R24,65
	out 0x7,R24
	xjmp L272
L271:
	.dbline 793
; 	else if(ch==2) ADMUX = 0x42;
	cpi R20,2
	ldi R30,0
	cpc R21,R30
	brne L273
X112:
	.dbline 793
	ldi R24,66
	out 0x7,R24
	xjmp L274
L273:
	.dbline 794
; 	else if(ch==3) ADMUX = 0x43;
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brne L275
X113:
	.dbline 794
	ldi R24,67
	out 0x7,R24
	xjmp L276
L275:
	.dbline 795
; 	else if(ch==4) ADMUX = 0x44;
	cpi R20,4
	ldi R30,0
	cpc R21,R30
	brne L277
X114:
	.dbline 795
	ldi R24,68
	out 0x7,R24
	xjmp L278
L277:
	.dbline 796
; 	else if(ch==5) ADMUX = 0x45;
	cpi R20,5
	ldi R30,0
	cpc R21,R30
	brne L279
X115:
	.dbline 796
	ldi R24,69
	out 0x7,R24
	xjmp L280
L279:
	.dbline 797
; 	else if(ch==6) ADMUX = 0x46;
	cpi R20,6
	ldi R30,0
	cpc R21,R30
	brne L281
X116:
	.dbline 797
	ldi R24,70
	out 0x7,R24
	xjmp L282
L281:
	.dbline 798
; 	else if(ch==7) ADMUX = 0x47;
	cpi R20,7
	ldi R30,0
	cpc R21,R30
	brne L283
X117:
	.dbline 798
	ldi R24,71
	out 0x7,R24
L283:
L282:
L280:
L278:
L276:
L274:
L272:
L270:
	.dbline 800
; 	
; 	ADCSRA = 0xC1; // Enable ADC, start conversion, max clock
	ldi R24,193
	out 0x6,R24
L285:
	.dbline 802
; 	
; 	while(!(ADCSRA&0x10)) ; // loop until conversion completes
L286:
	.dbline 802
	sbis 0x6,4
	rjmp L285
X118:
	.dbline 804
; 	
; 	low = ADCL;
	in R10,0x4
	.dbline 805
; 	high = ADCH;
	in R12,0x5
	.dbline 806
;  	return (low+high*256);
	mov R18,R12
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	movw R2,R16
	mov R16,R10
	clr R17
	add R16,R2
	adc R17,R3
	.dbline -2
L268:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r high 12 c
	.dbsym r low 10 c
	.dbsym r ch 20 I
	.dbend
	.dbfunc e DumpAnalogChs _DumpAnalogChs fV
;    analogvalue -> R10,R11
;              i -> R20,R21
	.even
_DumpAnalogChs::
	xcall push_xgset300C
	sbiw R28,1
	.dbline -1
	.dbline 810
; }
; 
; void DumpAnalogChs(void)
; {
	.dbline 813
;     int  i,analogvalue;
; 	
; 	puts("Analog Channels 0..7\n\r");
	ldi R16,<L289
	ldi R17,>L289
	xcall _puts
	.dbline 814
;  	for(i=0; i<8; i++) {
	clr R20
	clr R21
L290:
	.dbline 814
	.dbline 815
; 	    analogvalue = AnalogCh(i);
	movw R16,R20
	xcall _AnalogCh
	movw R10,R16
	.dbline 816
; 		printint(analogvalue,4,' ');
	ldi R24,32
	std y+0,R24
	ldi R18,4
	xcall _printint
	.dbline 817
; 		} 
L291:
	.dbline 814
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 814
	cpi R20,8
	ldi R30,0
	cpc R21,R30
	brlt L290
X119:
	.dbline 818
; 	puts("\n\r"); 
	ldi R16,<L294
	ldi R17,>L294
	xcall _puts
	.dbline -2
L288:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset300C
	.dbsym r analogvalue 10 I
	.dbsym r i 20 I
	.dbend
	.dbfunc e getint _getint fc
;       intvalue -> R20
;         inchar -> R22
	.even
_getint::
	st -y,R20
	st -y,R22
	.dbline -1
	.dbline 822
; }
; 
; char getint()
; {
	.dbline 825
; 	char intvalue,inchar;
; 	
; 	inchar = getchar();
	xcall _getchar$device_specific$
	mov R22,R16
	.dbline 826
; 	putchar(inchar);
	xcall _putchar$device_specific$
	.dbline 827
; 	if(inchar==CR) return 0x78;
	cpi R22,13
	brne L296
X120:
	.dbline 827
	ldi R16,120
	xjmp L295
L296:
	.dbline 828
; 	intvalue = (inchar - '0')*10;
	ldi R24,10
	mul R24,R22
	mov R20,R0
	subi R20,224
	.dbline 829
; 	inchar = getchar();
	xcall _getchar$device_specific$
	mov R22,R16
	.dbline 830
; 	putchar(inchar);	
	xcall _putchar$device_specific$
	.dbline 831
; 	intvalue = intvalue + (inchar-'0');
	mov R24,R22
	subi R24,48
	add R20,R24
	.dbline 832
; 	return intvalue;
	mov R16,R20
	.dbline -2
L295:
	.dbline 0 ; func end
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r intvalue 20 c
	.dbsym r inchar 22 c
	.dbend
	.dbfunc e getsettime _getsettime fV
;         inchar -> R10
;         instrg -> y+1
	.even
_getsettime::
	xcall push_xgset003C
	sbiw R28,5
	.dbline -1
	.dbline 837
; }
; 
; // Update the current day and time
; void  getsettime()
; {
	.dbline 840
;     unsigned char instrg[4],inchar;
; 	
;     _CLI();
	cli
	.dbline 841
; 	instrg[0] = days;
	lds R2,_days
	std y+1,R2
	.dbline 842
; 	instrg[1] = hours;
	lds R2,_hours
	std y+2,R2
	.dbline 843
; 	instrg[2] = minutes;
	lds R2,_minutes
	std y+3,R2
	.dbline 844
; 	instrg[3] = seconds;
	lds R2,_seconds
	std y+4,R2
	.dbline 845
; 	_SEI();	
	sei
	.dbline 847
; 	
;     puts("Set time [hh:mm:ss]=");
	ldi R16,<L302
	ldi R17,>L302
	xcall _puts
	.dbline 848
; 	printint(instrg[0],3,'0'); putchar(' ');
	ldi R24,48
	std y+0,R24
	ldi R18,3
	ldd R16,y+1
	clr R17
	xcall _printint
	.dbline 848
	ldi R16,32
	xcall _putchar$device_specific$
	.dbline 849
; 	printint(instrg[1],2,'0'); putchar(':');
	ldi R24,48
	std y+0,R24
	ldi R18,2
	ldd R16,y+2
	clr R17
	xcall _printint
	.dbline 849
	ldi R16,58
	xcall _putchar$device_specific$
	.dbline 850
; 	printint(instrg[2],2,'0'); putchar(':');
	ldi R24,48
	std y+0,R24
	ldi R18,2
	ldd R16,y+3
	clr R17
	xcall _printint
	.dbline 850
	ldi R16,58
	xcall _putchar$device_specific$
	.dbline 851
; 	printint(instrg[3],2,'0'); puts(" :");
	ldi R24,48
	std y+0,R24
	ldi R18,2
	ldd R16,y+4
	clr R17
	xcall _printint
	.dbline 851
	ldi R16,<L306
	ldi R17,>L306
	xcall _puts
	.dbline 853
; 	
; 	if((instrg[1]=getint())==0x78) return;
	xcall _getint
	std y+2,R16
	cpi R16,120
	brne L307
X121:
	.dbline 853
	xjmp L298
L307:
	.dbline 854
; 	inchar = getchar(); putchar(inchar);
	xcall _getchar$device_specific$
	.dbline 854
	xcall _putchar$device_specific$
	.dbline 855
; 	instrg[2] = getint();
	xcall _getint
	mov R12,R16
	std y+3,R12
	.dbline 856
; 	inchar = getchar(); putchar(inchar);
	xcall _getchar$device_specific$
	.dbline 856
	xcall _putchar$device_specific$
	.dbline 857
; 	instrg[3] = getint();
	xcall _getint
	mov R12,R16
	std y+4,R12
	.dbline 858
; 	inchar = getchar(); putchar(inchar);
	xcall _getchar$device_specific$
	movw R12,R16
	mov R10,R12
	.dbline 858
	xcall _putchar$device_specific$
	.dbline 860
; 
;     _CLI();
	cli
	.dbline 861
; 	hours = instrg[1];
	ldd R2,y+2
	sts _hours,R2
	.dbline 862
; 	minutes = instrg[2];
	ldd R2,y+3
	sts _minutes,R2
	.dbline 863
; 	seconds = instrg[3];
	ldd R2,y+4
	sts _seconds,R2
	.dbline 864
; 	_SEI();	
	sei
	.dbline -2
L298:
	.dbline 0 ; func end
	adiw R28,5
	xjmp pop_xgset003C
	.dbsym r inchar 10 c
	.dbsym l instrg 1 A[4:4]c
	.dbend
	.dbfunc e convertiptobinary _convertiptobinary fV
;             ip -> R0,R1
	.even
_convertiptobinary::
	.dbline -1
	.dbline 869
; }
; 
; //  Convert ASCII ip address to binary - TBD
; void convertiptobinary(unsigned char *ip)
; {
	.dbline -2
L315:
	.dbline 0 ; func end
	ret
	.dbsym l ip 0 pc
	.dbend
	.dbfunc e InternetSettings _InternetSettings fV
	.even
_InternetSettings::
	.dbline -1
	.dbline 874
; }
; 
; //  Get set Internet settings
; void InternetSettings(void)
; {
	.dbline 875
; 	convertiptobinary(IPADDRESS);
	ldi R16,<L317
	ldi R17,>L317
	xcall _convertiptobinary
	.dbline -2
L316:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TestAVR _TestAVR fV
;              j -> R20
;              i -> R22
	.even
_TestAVR::
	xcall push_xgsetF000
	.dbline -1
	.dbline 880
; }
; 
; //  Simple test routine
; void TestAVR(void)
; {
	.dbline 883
;  	 char i,j;
; 	 
;  	 puts("\n\rTesting AVR Version 0.90\n\r");
	ldi R16,<L319
	ldi R17,>L319
	xcall _puts
	.dbline 888
; //	 TestAVRRAM();
; //	 TestAVREEPROM();
; //	 TestAVRFLASH();
; //	 TestBoardFLASH():
; 	 j = 0;
	clr R20
	.dbline 889
; 	 putchar(' ');
	ldi R16,32
	xcall _putchar$device_specific$
	.dbline 890
; 	 for(i=0x20; i<0x7f; i++) {
	ldi R22,32
	xjmp L323
L320:
	.dbline 890
	.dbline 891
; 	 	 putchar(i);
	mov R16,R22
	xcall _putchar$device_specific$
	.dbline 892
; 		 if(j++ == 60)  {
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	mov R24,R2
	cpi R24,60
	brne L324
X122:
	.dbline 892
	.dbline 893
; 		     j = 0;
	clr R20
	.dbline 894
; 			 puts("\n\r ");
	ldi R16,<L326
	ldi R17,>L326
	xcall _puts
	.dbline 895
; 			 }
L324:
	.dbline 896
; 		 }
L321:
	.dbline 890
	inc R22
L323:
	.dbline 890
	cpi R22,127
	brlo L320
X123:
	.dbline 897
; 	 puts("\n\r ");
	ldi R16,<L326
	ldi R17,>L326
	xcall _puts
	.dbline 898
; 	 DumpAnalogChs();
	xcall _DumpAnalogChs
	.dbline -2
L318:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r j 20 c
	.dbsym r i 22 c
	.dbend
	.dbfunc e SetBlackfinBootMode _SetBlackfinBootMode fV
;       bootmode -> R20
	.even
_SetBlackfinBootMode::
	st -y,R20
	.dbline -1
	.dbline 903
; }
; 
; //  Set Blackfin boot mode
; void SetBlackfinBootMode(void)
; {
	.dbline 906
;  	unsigned char bootmode;
; 	
;     putfs(signon66);  // Ask for boot mode
	ldi R16,<_signon66
	ldi R17,>_signon66
	xcall _putfs
	.dbline 907
; 	bootmode = getchar();
	xcall _getchar$device_specific$
	mov R20,R16
	.dbline 908
; 	putchar(bootmode);
	xcall _putchar$device_specific$
	.dbline 909
; 	putfs(signon67);
	ldi R16,<_signon67
	ldi R17,>_signon67
	xcall _putfs
	.dbline 910
; 	putchar(bootmode);
	mov R16,R20
	xcall _putchar$device_specific$
	.dbline 911
; 	puts("\n\r");
	ldi R16,<L294
	ldi R17,>L294
	xcall _puts
	.dbline 912
; 	BlackfinBootMode(bootmode-0x30);
	mov R16,R20
	subi R16,48
	xcall _BlackfinBootMode
	.dbline -2
L327:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r bootmode 20 c
	.dbend
	.dbfunc e Calibrate _Calibrate fI
	.even
_Calibrate::
	.dbline -1
	.dbline 916
; }
; 
; int Calibrate()
; {
	.dbline 917
; 	 rtccountdown1 = 128;
	ldi R24,128
	ldi R25,0
	sts _rtccountdown1+1,R25
	sts _rtccountdown1,R24
	.dbline 918
; 	 mseccountdown3 = 750;
	ldi R24,750
	ldi R25,2
	sts _mseccountdown3+1,R25
	sts _mseccountdown3,R24
L329:
	.dbline 919
; 	 while(rtccountdown1) ;
L330:
	.dbline 919
	lds R2,_rtccountdown1
	lds R3,_rtccountdown1+1
	tst R2
	brne L329
	tst R3
	brne L329
X124:
	.dbline 920
; 	 return mseccountdown3;
	lds R16,_mseccountdown3
	lds R17,_mseccountdown3+1
	.dbline -2
L328:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e CalibrateOsc _CalibrateOsc fV
;         inchar -> R20
;       attempts -> R22,R23
;      timedelay -> R10,R11
;           mode -> R20
	.even
_CalibrateOsc::
	xcall push_xgsetF00C
	mov R20,R16
	.dbline -1
	.dbline 928
; }
; 
; //  Calibrate Internal Oscillator
; //    Check for value in EEPROM first, then calculate new value
; //    Compare new value to stored value (if any) and request 
; //    store permission
; void CalibrateOsc(unsigned char mode)
; {
	.dbline 932
;  	 char inchar;
;  	 int  timedelay,attempts;
; 	 
;  	 if(mode==VERBOSE) {
	cpi R20,2
	brne L333
X125:
	.dbline 932
	.dbline 933
; 	     putfs(calmessage1);
	ldi R16,<_calmessage1
	ldi R17,>_calmessage1
	xcall _putfs
	.dbline 934
; 	     DisplayCalibrationByte();
	xcall _DisplayCalibrationByte
	.dbline 935
; 		 }
L333:
	.dbline 940
; 	 
; 	 //  Setup one second delay
; 	 //  Difference between mseccounddown3 and 1000 gives percentage
; 	 //  offset of internal osc.
; 	 attempts = 20;
	ldi R22,20
	ldi R23,0
	xjmp L336
L335:
	.dbline 941
; 	 while(attempts--)  {
	.dbline 942
; 	     timedelay = Calibrate();
	xcall _Calibrate
	movw R10,R16
	.dbline 944
; 	     //printint(timedelay,4,' ');
; 	     if((256-timedelay)>0)  OSCCAL -= 1;
	ldi R24,256
	ldi R25,1
	movw R2,R24
	sub R2,R16
	sbc R3,R17
	clr R4
	clr R5
	cp R4,R2
	cpc R5,R3
	brge L338
X126:
	.dbline 944
	in R24,0x31
	subi R24,1
	out 0x31,R24
	xjmp L339
L338:
	.dbline 945
; 	     else  OSCCAL += 1;
	in R24,0x31
	subi R24,255    ; addi 1
	out 0x31,R24
L339:
	.dbline 946
; 		 if(abs(256-timedelay)<4) break;
	ldi R16,256
	ldi R17,1
	sub R16,R10
	sbc R17,R11
	xcall _abs
	cpi R16,4
	ldi R30,0
	cpc R17,R30
	brge L340
X127:
	.dbline 946
	xjmp L337
L340:
	.dbline 947
; 		 }
L336:
	.dbline 941
	movw R10,R22
	subi R22,1
	sbci R23,0
	tst R10
	brne L335
	tst R11
	brne L335
X128:
L337:
	.dbline 948
;  	 if(mode==VERBOSE) {
	cpi R20,2
	brne L342
X129:
	.dbline 948
	.dbline 949
; 	 	 putCRLF();
	xcall _putCRLF
	.dbline 950
; 	     putfs(calmessage2);
	ldi R16,<_calmessage2
	ldi R17,>_calmessage2
	xcall _putfs
	.dbline 951
; 	     DisplayCalibrationByte();
	xcall _DisplayCalibrationByte
	.dbline 952
; 	 	 putCRLF();
	xcall _putCRLF
	.dbline 953
; 		 putfs(calmessage3);
	ldi R16,<_calmessage3
	ldi R17,>_calmessage3
	xcall _putfs
	.dbline 954
; 		 inchar = getchar();
	xcall _getchar$device_specific$
	movw R10,R16
	mov R20,R10
	.dbline 955
; 		 if((inchar=='y')||(inchar=='Y')) EEPROMwrite(19,OSCCAL);  
	cpi R16,121
	breq L346
X130:
	cpi R16,89
	brne L344
X131:
L346:
	.dbline 955
	in R18,0x31
	ldi R16,19
	ldi R17,0
	xcall _EEPROMwrite
L344:
	.dbline 956
; 	 	 putCRLF();
	xcall _putCRLF
	.dbline 957
; 		 }
L342:
	.dbline -2
L332:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r inchar 20 c
	.dbsym r attempts 22 I
	.dbsym r timedelay 10 I
	.dbsym r mode 20 c
	.dbend
	.dbfunc e SetNewBaudRate _SetNewBaudRate fV
;       baudchar -> R20
	.even
_SetNewBaudRate::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 961
; }
; 
; void SetNewBaudRate(unsigned char baudchar)
; {
	.dbline 962
; 	  if(baudchar=='2')       ChangeBaudRate(BAUDRATE2400);
	cpi R20,50
	brne L348
X132:
	.dbline 962
	ldi R16,204
	xcall _ChangeBaudRate
	xjmp L349
L348:
	.dbline 963
; 	  else if(baudchar=='4')  ChangeBaudRate(BAUDRATE4800);
	cpi R20,52
	brne L350
X133:
	.dbline 963
	ldi R16,102
	xcall _ChangeBaudRate
	xjmp L351
L350:
	.dbline 964
; 	  else if(baudchar=='9')  ChangeBaudRate(BAUDRATE9600);
	cpi R20,57
	brne L352
X134:
	.dbline 964
	ldi R16,50
	xcall _ChangeBaudRate
	xjmp L353
L352:
	.dbline 965
; 	  else if(baudchar=='1')  ChangeBaudRate(BAUDRATE19200);
	cpi R20,49
	brne L354
X135:
	.dbline 965
	ldi R16,25
	xcall _ChangeBaudRate
	xjmp L355
L354:
	.dbline 966
; 	  else if(baudchar=='3')  ChangeBaudRate(BAUDRATE38400);
	cpi R20,51
	brne L356
X136:
	.dbline 966
	ldi R16,12
	xcall _ChangeBaudRate
	xjmp L357
L356:
	.dbline 967
; 	  else if(baudchar=='5')  ChangeBaudRate(BAUDRATE57600);
	cpi R20,53
	brne L358
X137:
	.dbline 967
	ldi R16,9
	xcall _ChangeBaudRate
L358:
L357:
L355:
L353:
L351:
L349:
	.dbline -2
L347:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r baudchar 20 c
	.dbend
	.dbfunc e EnterNewBaudRate _EnterNewBaudRate fV
;              i -> <dead>
;      firstchar -> R10
;         inchar -> R20
	.even
_EnterNewBaudRate::
	xcall push_xgsetF03C
	.dbline -1
	.dbline 971
; }
; 
; void EnterNewBaudRate(void)
; {
	.dbline 974
;       unsigned char i,firstchar,inchar;
; 	  
; 	  putCRLF();
	xcall _putCRLF
	.dbline 975
;       putfs(changebaudmessage);
	ldi R16,<_changebaudmessage
	ldi R17,>_changebaudmessage
	xcall _putfs
	.dbline 976
; 	  firstchar = getchar();
	xcall _getchar$device_specific$
	mov R10,R16
	.dbline 977
; 	  putchar(firstchar);
	xcall _putchar$device_specific$
	xjmp L362
L361:
	.dbline 978
; 	  while((inchar=getchar())!=CR) putchar(inchar) ;
	mov R16,R20
	xcall _putchar$device_specific$
L362:
	.dbline 978
	xcall _getchar$device_specific$
	mov R22,R16
	mov R20,R22
	cpi R16,13
	brne L361
X138:
	.dbline 979
; 	  putCRLF();
	xcall _putCRLF
	.dbline 980
; 	  putfs(calmessage3);
	ldi R16,<_calmessage3
	ldi R17,>_calmessage3
	xcall _putfs
	.dbline 981
; 	  inchar = getchar();
	xcall _getchar$device_specific$
	movw R12,R16
	mov R20,R12
	.dbline 982
; 	  putchar(inchar);
	xcall _putchar$device_specific$
	.dbline 983
; 	  if((inchar=='y')||(inchar=='Y')) EEPROMwrite(20,firstchar); 
	cpi R20,121
	breq L366
X139:
	cpi R20,89
	brne L364
X140:
L366:
	.dbline 983
	mov R18,R10
	ldi R16,20
	ldi R17,0
	xcall _EEPROMwrite
L364:
	.dbline 984
; 	  SetNewBaudRate(firstchar);
	mov R16,R10
	xcall _SetNewBaudRate
	.dbline -2
L360:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym l i 1 c
	.dbsym r firstchar 10 c
	.dbsym r inchar 20 c
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L326:
	.blkb 4
	.area idata
	.byte 10,13,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L319:
	.blkb 29
	.area idata
	.byte 10,13,'T,'e,'s,'t,'i,'n,'g,32,'A,'V,'R,32,'V,'e
	.byte 'r,'s,'i,'o,'n,32,48,46,57,48,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L317:
	.blkb 13
	.area idata
	.byte 50,53,54,46,49,50,56,46,48,46,50,52,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L306:
	.blkb 3
	.area idata
	.byte 32,58,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L302:
	.blkb 21
	.area idata
	.byte 'S,'e,'t,32,'t,'i,'m,'e,32,91,'h,'h,58,'m,'m,58
	.byte 's,'s,93,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L294:
	.blkb 3
	.area idata
	.byte 10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L289:
	.blkb 23
	.area idata
	.byte 'A,'n,'a,'l,'o,'g,32,'C,'h,'a,'n,'n,'e,'l,'s,32
	.byte 48,46,46,55,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L119:
	.blkb 14
	.area idata
	.byte 58,48,48,48,48,48,48,48,49,'F,'F,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L98:
	.blkb 3
	.area idata
	.byte 32,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L91:
	.blkb 3
	.area idata
	.byte 48,48,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L85:
	.blkb 6
	.area idata
	.byte 44,32,51,50,'K,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L84:
	.blkb 6
	.area idata
	.byte 44,32,'C,'b,45,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L83:
	.blkb 6
	.area idata
	.byte 44,32,'F,50,45,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L82:
	.blkb 6
	.area idata
	.byte 10,13,'F,49,45,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L53:
	.blkb 29
	.area idata
	.byte 'B,'l,'a,'c,'k,'f,'i,'n,32,'R,'e,'s,'e,'t,32,'a
	.byte 'n,'d,32,'e,'n,'a,'b,'l,'e,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L49:
	.blkb 19
	.area idata
	.byte 'R,'e,'l,'e,'a,'s,'e,32,'B,'l,'a,'c,'k,'f,'i,'n
	.byte 10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
L45:
	.blkb 16
	.area idata
	.byte 'H,'a,'l,'t,32,'B,'l,'a,'c,'k,'f,'i,'n,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\STEPHE~1\Desktop\P1AVRM~1\P1_AVR_Utilities.c
; 	  //putCRLF();
; }
